/* This file was generated by SableCC (http://www.sablecc.org/). */

package ContextExpressionLanguage.lexer;

import java.io.*;
import java.util.*;
import ContextExpressionLanguage.node.*;

public class Lexer
{
    protected Token token;
    protected State state = State.INITIAL;

    private PushbackReader in;
    private int line;
    private int pos;
    private boolean cr;
    private boolean eof;
    private final StringBuffer text = new StringBuffer();

    protected void filter() throws LexerException, IOException
    {
    }

    public Lexer(PushbackReader in)
    {
        this.in = in;

        if(gotoTable == null)
        {
            try
            {
                DataInputStream s = new DataInputStream(
                    new BufferedInputStream(
                    Lexer.class.getResourceAsStream("lexer.dat")));

                // read gotoTable
                int length = s.readInt();
                gotoTable = new int[length][][][];
                for(int i = 0; i < gotoTable.length; i++)
                {
                    length = s.readInt();
                    gotoTable[i] = new int[length][][];
                    for(int j = 0; j < gotoTable[i].length; j++)
                    {
                        length = s.readInt();
                        gotoTable[i][j] = new int[length][3];
                        for(int k = 0; k < gotoTable[i][j].length; k++)
                        {
                            for(int l = 0; l < 3; l++)
                            {
                                gotoTable[i][j][k][l] = s.readInt();
                            }
                        }
                    }
                }

                // read accept
                length = s.readInt();
                accept = new int[length][];
                for(int i = 0; i < accept.length; i++)
                {
                    length = s.readInt();
                    accept[i] = new int[length];
                    for(int j = 0; j < accept[i].length; j++)
                    {
                        accept[i][j] = s.readInt();
                    }
                }

                s.close();
            }
            catch(Exception e)
            {
                throw new RuntimeException("The file \"lexer.dat\" is either missing or corrupted.");
            }
        }
    }

    public Token peek() throws LexerException, IOException
    {
        while(token == null)
        {
            token = getToken();
            filter();
        }

        return token;
    }

    public Token next() throws LexerException, IOException
    {
        while(token == null)
        {
            token = getToken();
            filter();
        }

        Token result = token;
        token = null;
        return result;
    }

    protected Token getToken() throws IOException, LexerException
    {
        int dfa_state = 0;

        int start_pos = pos;
        int start_line = line;

        int accept_state = -1;
        int accept_token = -1;
        int accept_length = -1;
        int accept_pos = -1;
        int accept_line = -1;

        int[][][] gotoTable = this.gotoTable[state.id()];
        int[] accept = this.accept[state.id()];
        text.setLength(0);

        while(true)
        {
            int c = getChar();

            if(c != -1)
            {
                switch(c)
                {
                case 10:
                    if(cr)
                    {
                        cr = false;
                    }
                    else
                    {
                        line++;
                        pos = 0;
                    }
                    break;
                case 13:
                    line++;
                    pos = 0;
                    cr = true;
                    break;
                default:
                    pos++;
                    cr = false;
                    break;
                };

                text.append((char) c);

                do
                {
                    int oldState = (dfa_state < -1) ? (-2 -dfa_state) : dfa_state;

                    dfa_state = -1;

                    int[][] tmp1 =  gotoTable[oldState];
                    int low = 0;
                    int high = tmp1.length - 1;

                    while(low <= high)
                    {
                        int middle = (low + high) / 2;
                        int[] tmp2 = tmp1[middle];

                        if(c < tmp2[0])
                        {
                            high = middle - 1;
                        }
                        else if(c > tmp2[1])
                        {
                            low = middle + 1;
                        }
                        else
                        {
                            dfa_state = tmp2[2];
                            break;
                        }
                    }
                }while(dfa_state < -1);
            }
            else
            {
                dfa_state = -1;
            }

            if(dfa_state >= 0)
            {
                if(accept[dfa_state] != -1)
                {
                    accept_state = dfa_state;
                    accept_token = accept[dfa_state];
                    accept_length = text.length();
                    accept_pos = pos;
                    accept_line = line;
                }
            }
            else
            {
                if(accept_state != -1)
                {
                    switch(accept_token)
                    {
                    case 0:
                        {
                            Token token = new0(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 1:
                        {
                            Token token = new1(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 2:
                        {
                            Token token = new2(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 3:
                        {
                            Token token = new3(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 4:
                        {
                            Token token = new4(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 5:
                        {
                            Token token = new5(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 6:
                        {
                            Token token = new6(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 7:
                        {
                            Token token = new7(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 8:
                        {
                            Token token = new8(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 9:
                        {
                            Token token = new9(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 10:
                        {
                            Token token = new10(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 11:
                        {
                            Token token = new11(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 12:
                        {
                            Token token = new12(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 13:
                        {
                            Token token = new13(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 14:
                        {
                            Token token = new14(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 15:
                        {
                            Token token = new15(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 16:
                        {
                            Token token = new16(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 17:
                        {
                            Token token = new17(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 18:
                        {
                            Token token = new18(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 19:
                        {
                            Token token = new19(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 20:
                        {
                            Token token = new20(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 21:
                        {
                            Token token = new21(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 22:
                        {
                            Token token = new22(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 23:
                        {
                            Token token = new23(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 24:
                        {
                            Token token = new24(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 25:
                        {
                            Token token = new25(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 26:
                        {
                            Token token = new26(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 27:
                        {
                            Token token = new27(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 28:
                        {
                            Token token = new28(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 29:
                        {
                            Token token = new29(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 30:
                        {
                            Token token = new30(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    }
                }
                else
                {
                    if(text.length() > 0)
                    {
                        throw new LexerException(
                            "[" + (start_line + 1) + "," + (start_pos + 1) + "]" +
                            " Unknown token: " + text);
                    }
                    else
                    {
                        EOF token = new EOF(
                            start_line + 1,
                            start_pos + 1);
                        return token;
                    }
                }
            }
        }
    }

    Token new0(String text, int line, int pos) { return new TBlank(text, line, pos); }
    Token new1(String text, int line, int pos) { return new TTraditionalComment(text, line, pos); }
    Token new2(String text, int line, int pos) { return new TEndOfLineComment(text, line, pos); }
    Token new3(int line, int pos) { return new TTrue(line, pos); }
    Token new4(int line, int pos) { return new TFalse(line, pos); }
    Token new5(int line, int pos) { return new TLParenthese(line, pos); }
    Token new6(int line, int pos) { return new TRParenthese(line, pos); }
    Token new7(int line, int pos) { return new TLBrace(line, pos); }
    Token new8(int line, int pos) { return new TRBrace(line, pos); }
    Token new9(int line, int pos) { return new TExpressionAbstraction(line, pos); }
    Token new10(int line, int pos) { return new TPlus(line, pos); }
    Token new11(int line, int pos) { return new TMinus(line, pos); }
    Token new12(int line, int pos) { return new TStar(line, pos); }
    Token new13(int line, int pos) { return new TDiv(line, pos); }
    Token new14(int line, int pos) { return new TMod(line, pos); }
    Token new15(int line, int pos) { return new TLt(line, pos); }
    Token new16(int line, int pos) { return new TGt(line, pos); }
    Token new17(int line, int pos) { return new TNot(line, pos); }
    Token new18(int line, int pos) { return new TEq(line, pos); }
    Token new19(int line, int pos) { return new TLteq(line, pos); }
    Token new20(int line, int pos) { return new TGteq(line, pos); }
    Token new21(int line, int pos) { return new TNeq(line, pos); }
    Token new22(int line, int pos) { return new TAnd(line, pos); }
    Token new23(int line, int pos) { return new TOr(line, pos); }
    Token new24(int line, int pos) { return new TIn(line, pos); }
    Token new25(int line, int pos) { return new TSet(line, pos); }
    Token new26(int line, int pos) { return new TQualifier(line, pos); }
    Token new27(int line, int pos) { return new TComma(line, pos); }
    Token new28(String text, int line, int pos) { return new TIdentifier(text, line, pos); }
    Token new29(String text, int line, int pos) { return new TNumber(text, line, pos); }
    Token new30(String text, int line, int pos) { return new TText(text, line, pos); }

    private int getChar() throws IOException
    {
        if(eof)
        {
            return -1;
        }

        int result = in.read();

        if(result == -1)
        {
            eof = true;
        }

        return result;
    }

    private void pushBack(int acceptLength) throws IOException
    {
        int length = text.length();
        for(int i = length - 1; i >= acceptLength; i--)
        {
            eof = false;

            in.unread(text.charAt(i));
        }
    }

    protected void unread(Token token) throws IOException
    {
        String text = token.getText();
        int length = text.length();

        for(int i = length - 1; i >= 0; i--)
        {
            eof = false;

            in.unread(text.charAt(i));
        }

        pos = token.getPos() - 1;
        line = token.getLine() - 1;
    }

    private String getText(int acceptLength)
    {
        StringBuffer s = new StringBuffer(acceptLength);
        for(int i = 0; i < acceptLength; i++)
        {
            s.append(text.charAt(i));
        }

        return s.toString();
    }

    private static int[][][][] gotoTable;
/*  {
        { // INITIAL
            {{10, 10, 1}, {13, 13, 2}, {32, 32, 3}, {33, 33, 4}, {34, 34, 5}, {37, 37, 6}, {38, 38, 7}, {40, 40, 8}, {41, 41, 9}, {42, 42, 10}, {43, 43, 11}, {44, 44, 12}, {45, 45, 13}, {46, 46, 14}, {47, 47, 15}, {48, 57, 16}, {60, 60, 17}, {61, 61, 18}, {62, 62, 19}, {65, 90, 20}, {95, 95, 21}, {97, 100, 22}, {101, 101, 23}, {102, 102, 24}, {103, 104, 22}, {105, 105, 25}, {106, 115, 22}, {116, 116, 26}, {117, 122, 22}, {123, 123, 27}, {124, 124, 28}, {125, 125, 29}, {170, 170, 30}, {181, 181, 31}, {186, 186, 32}, {192, 214, 33}, {216, 246, 34}, {248, 501, 35}, {506, 535, 36}, {592, 680, 37}, {688, 696, 38}, {699, 705, 39}, {720, 721, 40}, {736, 740, 41}, {890, 890, 42}, {902, 902, 43}, {904, 906, 44}, {908, 908, 45}, {910, 929, 46}, {931, 974, 47}, {976, 982, 48}, {986, 986, 49}, {988, 988, 50}, {990, 990, 51}, {992, 992, 52}, {994, 1011, 53}, {1025, 1036, 54}, {1038, 1103, 55}, {1105, 1116, 56}, {1118, 1153, 57}, {1168, 1220, 58}, {1223, 1224, 59}, {1227, 1228, 60}, {1232, 1259, 61}, {1262, 1269, 62}, {1272, 1273, 63}, {1329, 1366, 64}, {1369, 1369, 65}, {1377, 1415, 66}, {1488, 1514, 67}, {1520, 1522, 68}, {1569, 1594, 69}, {1600, 1610, 70}, {1632, 1641, 71}, {1649, 1719, 72}, {1722, 1726, 73}, {1728, 1742, 74}, {1744, 1747, 75}, {1749, 1749, 76}, {1765, 1766, 77}, {1776, 1785, 78}, {2309, 2361, 79}, {2365, 2365, 80}, {2392, 2401, 81}, {2406, 2415, 82}, {2437, 2444, 83}, {2447, 2448, 84}, {2451, 2472, 85}, {2474, 2480, 86}, {2482, 2482, 87}, {2486, 2489, 88}, {2524, 2525, 89}, {2527, 2529, 90}, {2534, 2543, 91}, {2544, 2545, 92}, {2565, 2570, 93}, {2575, 2576, 94}, {2579, 2600, 95}, {2602, 2608, 96}, {2610, 2611, 97}, {2613, 2614, 98}, {2616, 2617, 99}, {2649, 2652, 100}, {2654, 2654, 101}, {2662, 2671, 102}, {2674, 2676, 103}, {2693, 2699, 104}, {2701, 2701, 105}, {2703, 2705, 106}, {2707, 2728, 107}, {2730, 2736, 108}, {2738, 2739, 109}, {2741, 2745, 110}, {2749, 2749, 111}, {2784, 2784, 112}, {2790, 2799, 113}, {2821, 2828, 114}, {2831, 2832, 115}, {2835, 2856, 116}, {2858, 2864, 117}, {2866, 2867, 118}, {2870, 2873, 119}, {2877, 2877, 120}, {2908, 2909, 121}, {2911, 2913, 122}, {2918, 2927, 123}, {2949, 2954, 124}, {2958, 2960, 125}, {2962, 2965, 126}, {2969, 2970, 127}, {2972, 2972, 128}, {2974, 2975, 129}, {2979, 2980, 130}, {2984, 2986, 131}, {2990, 2997, 132}, {2999, 3001, 133}, {3047, 3055, 134}, {3077, 3084, 135}, {3086, 3088, 136}, {3090, 3112, 137}, {3114, 3123, 138}, {3125, 3129, 139}, {3168, 3169, 140}, {3174, 3183, 141}, {3205, 3212, 142}, {3214, 3216, 143}, {3218, 3240, 144}, {3242, 3251, 145}, {3253, 3257, 146}, {3294, 3294, 147}, {3296, 3297, 148}, {3302, 3311, 149}, {3333, 3340, 150}, {3342, 3344, 151}, {3346, 3368, 152}, {3370, 3385, 153}, {3424, 3425, 154}, {3430, 3439, 155}, {3585, 3630, 156}, {3632, 3632, 157}, {3634, 3635, 158}, {3648, 3654, 159}, {3664, 3673, 160}, {3713, 3714, 161}, {3716, 3716, 162}, {3719, 3720, 163}, {3722, 3722, 164}, {3725, 3725, 165}, {3732, 3735, 166}, {3737, 3743, 167}, {3745, 3747, 168}, {3749, 3749, 169}, {3751, 3751, 170}, {3754, 3755, 171}, {3757, 3758, 172}, {3760, 3760, 173}, {3762, 3763, 174}, {3773, 3773, 175}, {3776, 3780, 176}, {3782, 3782, 177}, {3792, 3801, 178}, {3804, 3805, 179}, {3872, 3881, 180}, {3904, 3911, 181}, {3913, 3945, 182}, {4256, 4293, 183}, {4304, 4342, 184}, {4352, 4441, 185}, {4447, 4514, 186}, {4520, 4601, 187}, {7680, 7835, 188}, {7840, 7929, 189}, {7936, 7957, 190}, {7960, 7965, 191}, {7968, 8005, 192}, {8008, 8013, 193}, {8016, 8023, 194}, {8025, 8025, 195}, {8027, 8027, 196}, {8029, 8029, 197}, {8031, 8061, 198}, {8064, 8116, 199}, {8118, 8124, 200}, {8126, 8126, 201}, {8130, 8132, 202}, {8134, 8140, 203}, {8144, 8147, 204}, {8150, 8155, 205}, {8160, 8172, 206}, {8178, 8180, 207}, {8182, 8188, 208}, {8319, 8319, 209}, {8450, 8450, 210}, {8455, 8455, 211}, {8458, 8467, 212}, {8469, 8469, 213}, {8472, 8477, 214}, {8484, 8484, 215}, {8486, 8486, 216}, {8488, 8488, 217}, {8490, 8497, 218}, {8499, 8504, 219}, {12293, 12293, 220}, {12337, 12341, 221}, {12353, 12436, 222}, {12443, 12446, 223}, {12449, 12538, 224}, {12540, 12542, 225}, {12549, 12588, 226}, {12593, 12686, 227}, {19968, 40869, 228}, {44032, 55203, 229}, {63744, 64045, 230}, {64256, 64262, 231}, {64275, 64279, 232}, {64287, 64296, 233}, {64298, 64310, 234}, {64312, 64316, 235}, {64318, 64318, 236}, {64320, 64321, 237}, {64323, 64324, 238}, {64326, 64433, 239}, {64467, 64829, 240}, {64848, 64911, 241}, {64914, 64967, 242}, {65008, 65019, 243}, {65136, 65138, 244}, {65140, 65140, 245}, {65142, 65276, 246}, {65296, 65305, 247}, {65313, 65338, 248}, {65345, 65370, 249}, {65382, 65470, 250}, {65474, 65479, 251}, {65482, 65487, 252}, {65490, 65495, 253}, {65498, 65500, 254}, },
            {},
            {},
            {{32, 32, 3}, },
            {{61, 61, 255}, },
            {{0, 9, 256}, {11, 12, 256}, {14, 33, 256}, {34, 34, 257}, {35, 91, 256}, {93, 65535, 256}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {{46, 46, 258}, },
            {{42, 42, 259}, {47, 47, 260}, },
            {{48, 57, 16}, {1632, 1641, 71}, {1776, 1785, 78}, {2406, 2415, 82}, {2534, 2543, 91}, {2662, 2671, 102}, {2790, 2799, 113}, {2918, 2927, 123}, {3047, 3055, 134}, {3174, 3183, 141}, {3302, 3311, 149}, {3430, 3439, 155}, {3664, 3673, 160}, {3792, 3801, 178}, {3872, 3881, 180}, {65296, 65305, 247}, },
            {{61, 61, 261}, },
            {},
            {{61, 61, 262}, },
            {{48, 57, 263}, {65, 90, 264}, {95, 95, 265}, {97, 122, 266}, {170, 170, 267}, {181, 181, 268}, {186, 186, 269}, {192, 214, 270}, {216, 246, 271}, {248, 501, 272}, {506, 535, 273}, {592, 680, 274}, {688, 696, 275}, {699, 705, 276}, {720, 721, 277}, {736, 740, 278}, {890, 890, 279}, {902, 902, 280}, {904, 906, 281}, {908, 908, 282}, {910, 929, 283}, {931, 974, 284}, {976, 982, 285}, {986, 986, 286}, {988, 988, 287}, {990, 990, 288}, {992, 992, 289}, {994, 1011, 290}, {1025, 1036, 291}, {1038, 1103, 292}, {1105, 1116, 293}, {1118, 1153, 294}, {1168, 1220, 295}, {1223, 1224, 296}, {1227, 1228, 297}, {1232, 1259, 298}, {1262, 1269, 299}, {1272, 1273, 300}, {1329, 1366, 301}, {1369, 1369, 302}, {1377, 1415, 303}, {1488, 1514, 304}, {1520, 1522, 305}, {1569, 1594, 306}, {1600, 1610, 307}, {1632, 1641, 308}, {1649, 1719, 309}, {1722, 1726, 310}, {1728, 1742, 311}, {1744, 1747, 312}, {1749, 1749, 313}, {1765, 1766, 314}, {1776, 1785, 315}, {2309, 2361, 316}, {2365, 2365, 317}, {2392, 2401, 318}, {2406, 2415, 319}, {2437, 2444, 320}, {2447, 2448, 321}, {2451, 2472, 322}, {2474, 2480, 323}, {2482, 2482, 324}, {2486, 2489, 325}, {2524, 2525, 326}, {2527, 2529, 327}, {2534, 2543, 328}, {2544, 2545, 329}, {2565, 2570, 330}, {2575, 2576, 331}, {2579, 2600, 332}, {2602, 2608, 333}, {2610, 2611, 334}, {2613, 2614, 335}, {2616, 2617, 336}, {2649, 2652, 337}, {2654, 2654, 338}, {2662, 2671, 339}, {2674, 2676, 340}, {2693, 2699, 341}, {2701, 2701, 342}, {2703, 2705, 343}, {2707, 2728, 344}, {2730, 2736, 345}, {2738, 2739, 346}, {2741, 2745, 347}, {2749, 2749, 348}, {2784, 2784, 349}, {2790, 2799, 350}, {2821, 2828, 351}, {2831, 2832, 352}, {2835, 2856, 353}, {2858, 2864, 354}, {2866, 2867, 355}, {2870, 2873, 356}, {2877, 2877, 357}, {2908, 2909, 358}, {2911, 2913, 359}, {2918, 2927, 360}, {2949, 2954, 361}, {2958, 2960, 362}, {2962, 2965, 363}, {2969, 2970, 364}, {2972, 2972, 365}, {2974, 2975, 366}, {2979, 2980, 367}, {2984, 2986, 368}, {2990, 2997, 369}, {2999, 3001, 370}, {3047, 3055, 371}, {3077, 3084, 372}, {3086, 3088, 373}, {3090, 3112, 374}, {3114, 3123, 375}, {3125, 3129, 376}, {3168, 3169, 377}, {3174, 3183, 378}, {3205, 3212, 379}, {3214, 3216, 380}, {3218, 3240, 381}, {3242, 3251, 382}, {3253, 3257, 383}, {3294, 3294, 384}, {3296, 3297, 385}, {3302, 3311, 386}, {3333, 3340, 387}, {3342, 3344, 388}, {3346, 3368, 389}, {3370, 3385, 390}, {3424, 3425, 391}, {3430, 3439, 392}, {3585, 3630, 393}, {3632, 3632, 394}, {3634, 3635, 395}, {3648, 3654, 396}, {3664, 3673, 397}, {3713, 3714, 398}, {3716, 3716, 399}, {3719, 3720, 400}, {3722, 3722, 401}, {3725, 3725, 402}, {3732, 3735, 403}, {3737, 3743, 404}, {3745, 3747, 405}, {3749, 3749, 406}, {3751, 3751, 407}, {3754, 3755, 408}, {3757, 3758, 409}, {3760, 3760, 410}, {3762, 3763, 411}, {3773, 3773, 412}, {3776, 3780, 413}, {3782, 3782, 414}, {3792, 3801, 415}, {3804, 3805, 416}, {3872, 3881, 417}, {3904, 3911, 418}, {3913, 3945, 419}, {4256, 4293, 420}, {4304, 4342, 421}, {4352, 4441, 422}, {4447, 4514, 423}, {4520, 4601, 424}, {7680, 7835, 425}, {7840, 7929, 426}, {7936, 7957, 427}, {7960, 7965, 428}, {7968, 8005, 429}, {8008, 8013, 430}, {8016, 8023, 431}, {8025, 8025, 432}, {8027, 8027, 433}, {8029, 8029, 434}, {8031, 8061, 435}, {8064, 8116, 436}, {8118, 8124, 437}, {8126, 8126, 438}, {8130, 8132, 439}, {8134, 8140, 440}, {8144, 8147, 441}, {8150, 8155, 442}, {8160, 8172, 443}, {8178, 8180, 444}, {8182, 8188, 445}, {8319, 8319, 446}, {8450, 8450, 447}, {8455, 8455, 448}, {8458, 8467, 449}, {8469, 8469, 450}, {8472, 8477, 451}, {8484, 8484, 452}, {8486, 8486, 453}, {8488, 8488, 454}, {8490, 8497, 455}, {8499, 8504, 456}, {12293, 12293, 457}, {12337, 12341, 458}, {12353, 12436, 459}, {12443, 12446, 460}, {12449, 12538, 461}, {12540, 12542, 462}, {12549, 12588, 463}, {12593, 12686, 464}, {19968, 40869, 465}, {44032, 55203, 466}, {63744, 64045, 467}, {64256, 64262, 468}, {64275, 64279, 469}, {64287, 64296, 470}, {64298, 64310, 471}, {64312, 64316, 472}, {64318, 64318, 473}, {64320, 64321, 474}, {64323, 64324, 475}, {64326, 64433, 476}, {64467, 64829, 477}, {64848, 64911, 478}, {64914, 64967, 479}, {65008, 65019, 480}, {65136, 65138, 481}, {65140, 65140, 482}, {65142, 65276, 483}, {65296, 65305, 484}, {65313, 65338, 485}, {65345, 65370, 486}, {65382, 65470, 487}, {65474, 65479, 488}, {65482, 65487, 489}, {65490, 65495, 490}, {65498, 65500, 491}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 95, -22}, {97, 119, 266}, {120, 120, 492}, {121, 122, 266}, {170, 65500, -22}, },
            {{48, 95, -22}, {97, 97, 493}, {98, 122, 266}, {170, 65500, -22}, },
            {{48, 95, -22}, {97, 109, 266}, {110, 110, 494}, {111, 122, 266}, {170, 65500, -22}, },
            {{48, 95, -22}, {97, 113, 266}, {114, 114, 495}, {115, 122, 266}, {170, 65500, -22}, },
            {},
            {},
            {},
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65305, -18}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65305, -18}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65305, -18}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65305, -18}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65305, -18}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65305, -18}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65305, -18}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65305, -18}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65305, -18}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65305, -18}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65305, -18}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65305, -18}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65305, -18}, },
            {{48, 65500, -22}, },
            {{48, 65305, -18}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65305, -18}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {},
            {{0, 65535, -7}, },
            {},
            {},
            {{0, 9, 496}, {10, 10, 497}, {11, 12, 496}, {13, 13, 498}, {14, 41, 496}, {43, 65535, 496}, },
            {{0, 9, 499}, {10, 10, 500}, {11, 12, 499}, {13, 13, 501}, {14, 65535, 499}, },
            {},
            {},
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 95, -22}, {97, 111, 266}, {112, 112, 502}, {113, 122, 266}, {170, 65500, -22}, },
            {{48, 95, -22}, {97, 107, 266}, {108, 108, 503}, {109, 122, 266}, {170, 65500, -22}, },
            {{48, 65500, -22}, },
            {{48, 95, -22}, {97, 116, 266}, {117, 117, 504}, {118, 122, 266}, {170, 65500, -22}, },
            {{0, 41, -261}, {42, 42, 505}, {43, 65535, 496}, },
            {{0, 65535, -498}, },
            {{0, 9, 496}, {10, 10, 506}, {11, 65535, -498}, },
            {{0, 65535, -262}, },
            {},
            {{10, 10, 507}, },
            {{45, 45, 508}, {48, 65500, -22}, },
            {{48, 95, -22}, {97, 114, 266}, {115, 115, 509}, {116, 122, 266}, {170, 65500, -22}, },
            {{48, 95, -22}, {97, 100, 266}, {101, 101, 510}, {102, 122, 266}, {170, 65500, -22}, },
            {{0, 9, 511}, {10, 10, 512}, {11, 12, 511}, {13, 13, 513}, {14, 41, 511}, {42, 42, 505}, {43, 46, 511}, {47, 47, 514}, {48, 65535, 511}, },
            {{0, 65535, -498}, },
            {},
            {{97, 97, 515}, },
            {{48, 100, -506}, {101, 101, 516}, {102, 65500, -506}, },
            {{48, 65500, -22}, },
            {{0, 9, 517}, {10, 10, 518}, {11, 12, 517}, {13, 13, 519}, {14, 41, 517}, {42, 42, 520}, {43, 65535, 517}, },
            {{0, 65535, -513}, },
            {{0, 9, 517}, {10, 10, 521}, {11, 65535, -513}, },
            {},
            {{98, 98, 522}, },
            {{48, 65500, -22}, },
            {{0, 65535, -513}, },
            {{0, 65535, -513}, },
            {{0, 9, 517}, {10, 10, 523}, {11, 65535, -513}, },
            {{0, 41, -507}, {42, 42, 520}, {43, 65535, -507}, },
            {{0, 65535, -513}, },
            {{115, 115, 524}, },
            {{0, 65535, -513}, },
            {},
        }
    };*/

    private static int[][] accept;
/*  {
        // INITIAL
        {0, 0, 0, 0, 17, -1, 14, 22, 5, 6, 12, 10, 27, 11, 26, 13, 29, 15, 18, 16, 28, 28, 28, 28, 28, 28, 28, 7, 23, 8, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 29, 28, 28, 28, 28, 28, 28, 29, 28, 28, 28, 29, 28, 28, 28, 28, 28, 28, 28, 28, 29, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 29, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 29, 28, 28, 28, 28, 28, 28, 28, 28, 28, 29, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 29, 28, 28, 28, 28, 28, 28, 29, 28, 28, 28, 28, 28, 28, 28, 29, 28, 28, 28, 28, 28, 29, 28, 28, 28, 28, 29, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 29, 28, 29, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 29, 28, 28, 28, 28, 28, 28, 28, 21, -1, 30, 25, -1, 2, 19, 20, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 28, 24, 28, -1, -1, -1, 2, 2, 2, 28, 28, 28, -1, -1, 2, -1, 28, 3, -1, -1, -1, 1, -1, 4, -1, -1, -1, -1, -1, -1, -1, 9, },

    };*/

    public static class State
    {
        public final static State INITIAL = new State(0);

        private int id;

        private State(int id)
        {
            this.id = id;
        }

        public int id()
        {
            return id;
        }
    }
}
