package maca_ca.ssl;

/**
 * <p>Title: MACA_CA</p>
 * <p>Description: Middleware de Autenticao e Controle de Acesso</p>
 * <p>Copyright: Copyright (c) 2000-2004</p>
 * <p>Company: Instituto do Corao - FM.USP</p>
 * @author Gustavo Motta
 * @version 3.2.1
 */

import java.net.*;
import javax.net.*;
import javax.net.ssl.*;

public class AutomaticSocketFactory extends SSLSocketFactory {

  static  {
    java.security.Security.addProvider(new com.sun.net.ssl.internal.ssl.Provider());
  }

  private SSLContext ctx = null;

  public AutomaticSocketFactory() {
    try {
      TrustManager[] trustManagers = new TrustManager [] { new X509Truster() };
      ctx = SSLContext.getInstance("TLS");
      ctx.init(null, trustManagers, null);
    }
    catch (Exception exc) {
      System.out.println(exc.getMessage());
    }
  }

  public String[] getDefaultCipherSuites() {
    return ctx.getSocketFactory().getDefaultCipherSuites();
  }
  public String[] getSupportedCipherSuites() {
    return ctx.getSocketFactory().getSupportedCipherSuites();
  }

  public static synchronized SocketFactory getDefault() {
    return new AutomaticSocketFactory();
  }


  public Socket createSocket(InetAddress host, int port) throws java.io.IOException {
    return ctx.getSocketFactory().createSocket(host, port);
  }

  public Socket createSocket(String host, int port) throws java.io.IOException, java.net.UnknownHostException {
    return ctx.getSocketFactory().createSocket(host, port);
  }

  public Socket createSocket(String host, int port, InetAddress client_host, int client_port) throws java.io.IOException, java.net.UnknownHostException {
    return ctx.getSocketFactory().createSocket(host, port, client_host, client_port);
  }

  public Socket createSocket(InetAddress host, int port, InetAddress client_host, int client_port) throws java.io.IOException {
    return ctx.getSocketFactory().createSocket(host, port, client_host, client_port);
  }

  public Socket createSocket(Socket socket, String host, int port, boolean autoclose) throws java.io.IOException {
    return ctx.getSocketFactory().createSocket(socket, host, port, autoclose);
  }

}