package maca_ad;

/**
 * <p>Title: MACA_CA</p>
 * <p>Description: Middleware de Autenticao e Controle de Acesso</p>
 * <p>Copyright: Copyright (c) 2000-2004</p>
 * <p>Company: Instituto do Corao - FM.USP</p>
 * @author Gustavo Motta
 * @version 3.2.1
 */

import java.util.*;
import java.awt.*;
import javax.swing.*;
import javax.naming.*;
import java.awt.event.*;
import javax.swing.border.*;

public class LockoutDialog  extends JDialog {

  //Variveis privadas definidas manualmente
  private int numTentativas = 3;

  //Variveis pblicas definidas automaticamente
  JPanel loginpanel = new JPanel();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  JLabel loginLabel = new JLabel();
  JTextField loginTextField = new JTextField();
  JLabel passwordLabel = new JLabel();
  JPasswordField passwordField = new JPasswordField();
  JPanel jPanel1 = new JPanel();
  JButton cancelButton = new JButton();
  JButton okButton = new JButton();
  Border border1;
  Border border2;
  JPanel jPanel2 = new JPanel();
  BorderLayout borderLayout1 = new BorderLayout();
  JLabel loginStatusLabel = new JLabel();
  Border border3;

  private String userRole = "";

  public LockoutDialog(Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    try {
      userRole = GlobalDefinitions.sa.getUserRole();
      StringTokenizer userRoles = new StringTokenizer(userRole, ";");
      if (userRoles.hasMoreTokens()) {
        userRole = userRoles.nextToken();
      }
      GlobalDefinitions.sa.CloseSession();
      jbInit();
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public LockoutDialog() {
    this(null, "", false);
  }

  void jbInit() throws Exception {
    this.setSize(300, 160);
    border1 = BorderFactory.createCompoundBorder(new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(142, 142, 142)),BorderFactory.createEmptyBorder(2,2,2,2));
    border2 = BorderFactory.createCompoundBorder(new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(142, 142, 142)),BorderFactory.createEmptyBorder(2,2,2,2));
    border3 = BorderFactory.createCompoundBorder(new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(142, 142, 142)),BorderFactory.createEmptyBorder(2,2,2,2));
    loginpanel.setLayout(gridBagLayout1);
    this.setTitle("Desbloqueio da Aplicao");
    this.setModal(true);
    this.enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    this.addWindowListener(new java.awt.event.WindowAdapter() {

      public void windowOpened(WindowEvent e) {
        this_windowOpened(e);
      }

      public void windowClosing(WindowEvent e) {
        this_windowClosing(e);
      }
    });
    loginLabel.setToolTipText("");
    loginLabel.setDisplayedMnemonic('0');
    loginLabel.setText("Login:");
    passwordLabel.setText("Senha:");
    cancelButton.setText("Encerra");
    cancelButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        cancelButton_actionPerformed(e);
      }
    });
    okButton.setMnemonic('C');
    okButton.setText("Confirma");
    okButton.addFocusListener(new java.awt.event.FocusAdapter() {

      public void focusGained(FocusEvent e) {
        okButton_focusGained(e);
      }

      public void focusLost(FocusEvent e) {
        okButton_focusLost(e);
      }
    });
    okButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        okButton_actionPerformed(e);
      }
    });
    passwordField.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        transferFocusOnEnter(e);
      }
    });
    loginpanel.setBorder(border1);
    jPanel1.setBorder(border2);
    jPanel2.setLayout(borderLayout1);
    loginStatusLabel.setBorder(border3);
    loginStatusLabel.setText("Status:");
    String ldapLogin = (String) GlobalDefinitions.ctx.value.getEnvironment().get(Context.SECURITY_PRINCIPAL);
    loginTextField.setText(ldapLogin.substring(ldapLogin.indexOf('=')+1,ldapLogin.indexOf(',')));
    loginTextField.setRequestFocusEnabled(false);
    loginTextField.setEditable(false);
    getContentPane().add(loginpanel, BorderLayout.NORTH);
    loginpanel.add(loginLabel, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(10, 0, 3, 3), 0, 0));
    loginpanel.add(loginTextField, new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(10, 0, 3, 20), 0, 0));
    loginpanel.add(passwordLabel, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 0, 0, 3), 0, 0));
    loginpanel.add(passwordField, new GridBagConstraints(1, 1, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 3, 20), 0, 0));
    this.getContentPane().add(jPanel1, BorderLayout.CENTER);
    jPanel1.add(okButton, null);
    jPanel1.add(cancelButton, null);
    this.getContentPane().add(jPanel2, BorderLayout.SOUTH);
    jPanel2.add(loginStatusLabel, BorderLayout.CENTER);
    this.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
  }

  void cancelButton_actionPerformed(ActionEvent e) {
    this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
    this.dispatchEvent(new WindowEvent(this, WindowEvent.WINDOW_CLOSING));
  }

  void okButton_actionPerformed(ActionEvent e) {
    if ((GlobalDefinitions.sa.Authenticate(loginTextField.getText(),
                                           passwordField,
                                           userRole))) {
      this.hide();
    }
    else {
      loginStatusLabel.setText("Status: senha invlida!");
      passwordField.setText("");
      passwordField.requestFocus();
      if ((numTentativas -= 1) < 0) {
        this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
        this.dispatchEvent(new WindowEvent(this, WindowEvent.WINDOW_CLOSING));
      }
    }
  }

  void this_windowOpened(WindowEvent e) {
   passwordField.requestFocus();
  }

  void transferFocusOnEnter(KeyEvent e) {
     if (e.getKeyCode() == KeyEvent.VK_ENTER) {
       e.getComponent().transferFocus();
     }
  }

 protected void processWindowEvent(WindowEvent e) {
   JDialog frame = null;
   if (e.getSource() instanceof JDialog) {
     frame = (JDialog) e.getSource();
   }
   if (frame != null) {
     if (e.getID() == WindowEvent.WINDOW_CLOSING) {
       if (frame.getDefaultCloseOperation() == JFrame.DISPOSE_ON_CLOSE) {
         super.processWindowEvent(e);
         System.exit(0);
       }
     }
     else {
       super.processWindowEvent(e);
     }
   }
   else {
     super.processWindowEvent(e);
   }
 }

 void okButton_focusGained(FocusEvent e) {
    this.rootPane.setDefaultButton(okButton);
  }

  void okButton_focusLost(FocusEvent e) {
    this.rootPane.setDefaultButton(null);
  }

  void this_windowClosing(WindowEvent e) {
     GlobalDefinitions.sa.CloseSession();
     System.out.println("Saindo da aplicao ...");
  }

}