package maca_ad;

/**
 * <p>Title: MACA_CA</p>
 * <p>Description: Middleware de Autenticao e Controle de Acesso</p>
 * <p>Copyright: Copyright (c) 2000-2004</p>
 * <p>Company: Instituto do Corao - FM.USP</p>
 * @author Gustavo Motta
 * @version 3.2.1
 */

import java.awt.*;
import java.util.*;
import java.text.*;
import javax.swing.*;
import javax.naming.*;
import java.security.*;
import java.awt.event.*;
import javax.swing.border.*;
import javax.naming.directory.*;
import javax.naming.directory.*;


public class LoginDialog extends JDialog {

  static {
    try {
      maca_ca.LoadProperties.init(null);
      maca_ca.UserSchema.init();
    }
    catch (Exception exc) {
      System.out.println(exc);
    }
  }

  //Variveis privadas definidas manualmente
  private int numTentativas = 3;
  private ImageIcon incorLogo = new ImageIcon(LoginDialog.class.getResource("incor.gif"));

  //Variveis pblicas definidas automaticamente
  JPanel loginpanel = new JPanel();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  JTextField ldapPortTextField = new JTextField();
  JLabel ldapPortLabel = new JLabel();
  JTextField ldapServerTextField = new JTextField();
  JLabel ldapServerLabel = new JLabel();
  JLabel loginLabel = new JLabel();
  JTextField loginTextField = new JTextField();
  JLabel passwordLabel = new JLabel();
  JPasswordField passwordField = new JPasswordField();
  JPanel jPanel1 = new JPanel();
  JButton cancelButton = new JButton();
  JButton okButton = new JButton();
  Border border1;
  Border border2;
  JPanel jPanel2 = new JPanel();
  BorderLayout borderLayout1 = new BorderLayout();
  JLabel loginStatusLabel = new JLabel();
  Border border3;
  JCheckBox jCheckBox = new JCheckBox();
  JLabel incorLabel = new JLabel();

  public LoginDialog(Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    try {
      jbInit();
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
    if (GlobalDefinitions.sa == null) {
      GlobalDefinitions.sa = new SimpleAuthenticatorCS();
    }
  }

  public LoginDialog() {
    this(null, "", false);
  }

  void jbInit() throws Exception {
    border1 = BorderFactory.createCompoundBorder(new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(142, 142, 142)),BorderFactory.createEmptyBorder(2,2,2,2));
    border2 = BorderFactory.createCompoundBorder(new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(142, 142, 142)),BorderFactory.createEmptyBorder(2,2,2,2));
    border3 = BorderFactory.createCompoundBorder(new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(142, 142, 142)),BorderFactory.createEmptyBorder(2,2,2,2));
    loginpanel.setLayout(gridBagLayout1);
    this.setTitle("Login - MACA "+GlobalDefinitions.VERSION);
    this.setModal(true);
    this.enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    this.addWindowListener(new java.awt.event.WindowAdapter() {

      public void windowOpened(WindowEvent e) {
        this_windowOpened(e);
      }
    });
    ldapPortTextField.setText("389");
    ldapPortTextField.setHorizontalAlignment(SwingConstants.RIGHT);
    ldapPortTextField.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        transferFocusOnEnter(e);
      }
    });
    ldapPortLabel.setToolTipText("");
    ldapPortLabel.setHorizontalAlignment(SwingConstants.RIGHT);
    ldapPortLabel.setText("Porta:");
    ldapServerTextField.setNextFocusableComponent(ldapPortTextField);
    ldapServerTextField.setToolTipText("Servidor LDAP");
    ldapServerTextField.setText("ldap.incor.usp.br");
    ldapServerTextField.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        transferFocusOnEnter(e);
      }
    });
    ldapServerLabel.setToolTipText("Servidor LDAP");
    ldapServerLabel.setText("LDAP:");
    loginLabel.setToolTipText("");
    loginLabel.setDisplayedMnemonic('0');
    loginLabel.setText("Login:");
    passwordLabel.setText("Senha:");
    cancelButton.setText("Cancela");
    cancelButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        cancelButton_actionPerformed(e);
      }
    });
    okButton.setMnemonic('C');
    okButton.setText("Confirma");
    okButton.addFocusListener(new java.awt.event.FocusAdapter() {

      public void focusGained(FocusEvent e) {
        okButton_focusGained(e);
      }

      public void focusLost(FocusEvent e) {
        okButton_focusLost(e);
      }
    });
    okButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        okButton_actionPerformed(e);
      }
    });
    loginTextField.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        transferFocusOnEnter(e);
      }
    });
    passwordField.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        transferFocusOnEnter(e);
      }
    });
    loginpanel.setBorder(border1);
    jPanel1.setBorder(border2);
    jPanel2.setLayout(borderLayout1);
    loginStatusLabel.setBorder(border3);
    loginStatusLabel.setText("Status:");
    jCheckBox.setText("Conexo segura (SSL)");
    jCheckBox.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        jCheckBox_actionPerformed(e);
      }
    });
    incorLabel.setRequestFocusEnabled(false);
    incorLabel.setIcon(incorLogo);
    getContentPane().add(loginpanel, BorderLayout.NORTH);
    loginpanel.add(ldapServerTextField,   new GridBagConstraints(1, 3, 2, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 3, 0), 0, 0));
    loginpanel.add(ldapServerLabel,   new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 0, 3, 3), 0, 0));
    loginpanel.add(ldapPortLabel,  new GridBagConstraints(3, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 14, 0));
    loginpanel.add(ldapPortTextField,  new GridBagConstraints(4, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 7, 0, 0), 7, 0));
    loginpanel.add(loginLabel,  new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(10, 0, 3, 3), 0, 0));
    loginpanel.add(loginTextField,  new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(10, 0, 3, 0), 0, 0));
    loginpanel.add(passwordLabel,  new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 0, 0, 3), 0, 0));
    loginpanel.add(passwordField,     new GridBagConstraints(1, 1, 2, 1, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 3, 0), 0, 0));
    loginpanel.add(incorLabel,                       new GridBagConstraints(3, 0, 2, 3, 0.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.VERTICAL, new Insets(10, 10, 3, 4), 8, -17));
    this.getContentPane().add(jPanel1, BorderLayout.CENTER);
    jPanel1.add(okButton, null);
    jPanel1.add(cancelButton, null);
    jPanel1.add(jCheckBox, null);
    this.getContentPane().add(jPanel2, BorderLayout.SOUTH);
    jPanel2.add(loginStatusLabel, BorderLayout.CENTER);

    this.addComponentListener(new java.awt.event.ComponentListener() {

      public void componentResized(ComponentEvent e) {
      }

      public void componentMoved(ComponentEvent e) {
      }

      public void componentShown(ComponentEvent e) {
        GlobalDefinitions.splash.setVisible(false);
      }

      public void componentHidden(ComponentEvent e) {
      }

    });

    StringTokenizer serverAndPort = new StringTokenizer(System.getProperty("maca_ca.ldap.server"), ":");
    if (serverAndPort.hasMoreTokens()) {
      ldapServerTextField.setText(serverAndPort.nextToken());
    }
    if (serverAndPort.hasMoreTokens()) {
      ldapPortTextField.setText(serverAndPort.nextToken());
    }
    if (!"false".equalsIgnoreCase(System.getProperty("maca_ca.ldap.ssl"))) {
      jCheckBox.setSelected(true);
      GlobalDefinitions.isSSL = true;
      System.getProperties().setProperty("maca_ca.ldap.ssl", "true");
      ldapPortTextField.setText("636");
    }
    else {
      jCheckBox.setSelected(false);
      GlobalDefinitions.isSSL = false;
      System.getProperties().setProperty("maca_ca.ldap.ssl", "false");
      ldapPortTextField.setText("389");
    }
    //this.roleComboBox.addItem("Administrador de Contas");
  }

  void cancelButton_actionPerformed(ActionEvent e) {
    System.exit(0);
  }

  void okButton_actionPerformed(ActionEvent e) {
    try {
      System.setProperty("maca_ca.ldap.server", ldapServerTextField.getText()+":"+ldapPortTextField.getText());
      System.setProperty("maca_ca.ldap.ssl", jCheckBox.isSelected()?"true":"false");
      if ((GlobalDefinitions.sa.Authenticate(loginTextField.getText(), passwordField, ""))) {
          if ((GlobalDefinitions.sa.AccessAllowed("MACA","Execuo"))) {
            this.setVisible(false);
            loginStatusLabel.setText("Status: Login efetuado com sucesso!");
            GlobalDefinitions.splash.setVisible(true);
            GlobalDefinitions.splash.update(GlobalDefinitions.splash.getGraphics());
            JFrame frame = new MACA_Frame();
            MACA_Applet applet = new MACA_Applet(frame, ldapServerTextField.getText(), ldapPortTextField.getText(),
                                                 loginTextField.getText(), new String(passwordField.getPassword()));
            applet.isStandalone = true;
            frame.getContentPane().add(applet, BorderLayout.CENTER);
            applet.init();
            applet.start();
            applet.setUserID();
            frame.setSize(800, 600);
            Dimension d = frame.getToolkit().getScreenSize();
            frame.setLocation((d.width - frame.getSize().width) / 2, (d.height - frame.getSize().height) / 2);
            frame.pack();
            frame.setVisible(true);
            this.dispose();
            GlobalDefinitions.splash.setVisible(false);
            GlobalDefinitions.splash.dispose();
          }
          else {
            GlobalDefinitions.sa.CloseSession();
            loginStatusLabel.setText("Status: voc est no autorizado a executar esta aplicao!");
            passwordField.setText("");
          }
      }
      else {
        loginStatusLabel.setText("Status: Login invlido!");
        passwordField.setText("");
        loginTextField.requestFocus();
        loginTextField.selectAll();
        if ((numTentativas -= 1) < 0) {
          System.exit(0);
        }
      };
    }
    catch (Exception exc) {
      JOptionPane.showMessageDialog(this, exc.getMessage(),
                                    "Erro conectando com o servidor LDAP!",
                                    JOptionPane.ERROR_MESSAGE);
      System.exit(-1);
    }
  }

  public static void main(String[] args) {
    GlobalDefinitions.splash.pack();
    showCenteredWindow(GlobalDefinitions.splash, true);

    Security.addProvider(new com.sun.net.ssl.internal.ssl.Provider());
    JDialog loginDlg = new LoginDialog();
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    loginDlg.setLocation((d.width - loginDlg.getSize().width) / 2, (d.height - loginDlg.getSize().height) / 2);
    loginDlg.setSize(425, 200);
    loginDlg.pack();
    loginDlg.show();
  }

  void this_windowOpened(WindowEvent e) {
    loginTextField.requestFocus();
  }

  void transferFocusOnEnter(KeyEvent e) {
     if (e.getKeyCode() == KeyEvent.VK_ENTER) {
       e.getComponent().transferFocus();
     }
  }

  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }

  static private void showCenteredWindow(Window window, boolean usePreferredSize) {
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension windowSize;
    if (usePreferredSize)
      windowSize = window.getPreferredSize();
    else
      windowSize = window.getSize();

    if (windowSize.height > screenSize.height)
      windowSize.height = screenSize.height;
    if (windowSize.width > screenSize.width)
      windowSize.width = screenSize.width;

    window.setLocation((screenSize.width - windowSize.width) / 2, (screenSize.height - windowSize.height) / 2);
    window.setVisible(true);
  }

  void okButton_focusGained(FocusEvent e) {
    this.rootPane.setDefaultButton(okButton);
  }

  void okButton_focusLost(FocusEvent e) {
    this.rootPane.setDefaultButton(null);
  }

  void jCheckBox_actionPerformed(ActionEvent e) {
    if (jCheckBox.isSelected()) {
      GlobalDefinitions.isSSL = true;
      System.getProperties().setProperty("maca_ca.ldap.ssl", "true");
      ldapPortTextField.setText("636");
    }
    else {
      GlobalDefinitions.isSSL = false;
      System.getProperties().setProperty("maca_ca.ldap.ssl", "false");
      ldapPortTextField.setText("389");
    }
  }

}