package maca_ad;

/**
 * <p>Title: MACA_CA</p>
 * <p>Description: Middleware de Autenticao e Controle de Acesso</p>
 * <p>Copyright: Copyright (c) 2000-2004</p>
 * <p>Company: Instituto do Corao - FM.USP</p>
 * @author Gustavo Motta
 * @version 3.2.1
 */

import maca_ca.*;
import java.io.*;
import java.awt.*;
import java.util.*;
import java.beans.*;
import java.applet.*;
import tablesorter.*;
import javax.swing.*;
import javax.naming.*;
import java.awt.event.*;
import javax.swing.tree.*;
import javax.swing.event.*;
import javax.swing.table.*;
import javax.swing.border.*;
import javax.naming.directory.*;
import javax.swing.JOptionPane;
import com.borland.jbcl.layout.*;
import javax.naming.directory.InitialDirContext;

public class MACA_Applet extends JApplet implements maca_ad.TimerListener {

  //Variveis de instncia definidas manualmente
  private Group grupos = null;
  private Group selGrupo = null;
  private Group resGroup = null;
  private Group privGroup = null;
  private Group userGroup = null;
  private GroupApplet grpApplet = null;
  private ResourceApplet resApplet = null;
  private maca_ad.Timer timer;
  private JFrame containerFrame = null;
  private RoleAuthorizationsTableModel roleTableModel = null;
  private ResourceLookupComboBoxModel resFilterComboBoxModel = null;
  private UserReturningFieldsDialog userRetFldDlg = new
      UserReturningFieldsDialog();
  private boolean authoFilterActivated = false;
  private ConflictingAuthorizationsTableModel conflitingTableModel = null;
  private Vector conflictingAuthos = new Vector();

  //Variveis de instncia definidas automaticamente
  boolean isStandalone = false;
  JPanel topPanel = new JPanel();
  JPanel bottomPanel = new JPanel();
  JPanel centerPanel = new JPanel();
  BorderLayout borderLayout1 = new BorderLayout();
  JTabbedPane macaTabbedPane = new JTabbedPane();
  JPanel dirPanel = new JPanel();
  BorderLayout borderLayout2 = new BorderLayout();
  JSplitPane dirSplitPane = new JSplitPane();
  JPanel leftDirPanel = new JPanel();
  JPanel rightDirPanel = new JPanel();
  BorderLayout borderLayout3 = new BorderLayout();
  BorderLayout borderLayout4 = new BorderLayout();
  JComboBox gruposComboBox = new JComboBox();
  JScrollPane dirScrollPane = new JScrollPane();
  JTree dirTree = new JTree();
  JTabbedPane workingDirTabbedPane = new JTabbedPane();
  JPanel descriptionPanel = new JPanel();
  BorderLayout borderLayout5 = new BorderLayout();
  JScrollPane descriptionScrollPane = new JScrollPane();
  JPanel resPanel = new JPanel();
  BorderLayout borderLayout6 = new BorderLayout();
  JSplitPane resSplitPane = new JSplitPane();
  JScrollPane resScrollPane = new JScrollPane();
  JTree resTree = new JTree();
  Border border1;
  TitledBorder titledBorder1;
  Border border2;
  TitledBorder titledBorder2;
  JPanel userPanel = new JPanel();
  BorderLayout borderLayout9 = new BorderLayout();
  JPanel topUserPanel = new JPanel();
  JPanel bottomUserPanel = new JPanel();
  JPanel centerUserPanel = new JPanel();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  JButton searchButton = new JButton();
  JLabel filterLabel = new JLabel();
  JTextField userTextField = new JTextField();
  BorderLayout borderLayout10 = new BorderLayout();
  JButton editUserButton = new JButton();
  Border border3;
  Border border4;
  Border border5;
  Border border6;
  TitledBorder titledBorder3;
  JButton newUserButton = new JButton();
  JButton removeButton = new JButton();
  JPanel jPanel1 = new JPanel();
  Border border7;
  JButton newGroupButton = new JButton();
  JButton removeGroupButton = new JButton();
  JPanel resRightPanel = new JPanel();
  JPanel buttonsPanel = new JPanel();
  BorderLayout borderLayout11 = new BorderLayout();
  JButton newResourceButton = new JButton();
  JButton removeResourceButton = new JButton();
  JScrollPane resAttrScrollPane = new JScrollPane();
  JButton refreshButton = new JButton();
  JLabel statusLabel = new JLabel();
  BorderLayout borderLayout12 = new BorderLayout();
  Border border8;
  JButton RefreshGroupButton = new JButton();
  JPanel membersPanel = new JPanel();
  BorderLayout borderLayout13 = new BorderLayout();
  JPanel topMembersPanel = new JPanel();
  JScrollPane memberScrollPane = new JScrollPane();
  JList memberList = new JList();
  JCheckBox subTreeMembersCheckBox = new JCheckBox();
  Border border9;
  Border border10;
  JLabel aboutLabel = new JLabel();
  JScrollPane userScrollPane = new JScrollPane();
  JComboBox fieldsComboBox = new JComboBox();
  JLabel jLabel1 = new JLabel();
  JTable userTable = new JTable();
  JButton closeButton = new JButton();
  BorderLayout borderLayout14 = new BorderLayout();
  JButton exportButton = new JButton();
  JLabel topStatusLabel = new JLabel();
  JPanel roleConflictPanel = new JPanel();
  JPanel topRoleConflictPanel = new JPanel();
  BorderLayout borderLayout15 = new BorderLayout();
  JPanel centerRoleConflictPanel = new JPanel();
  JPanel bottomRoleConflictPanel = new JPanel();
  BorderLayout borderLayout16 = new BorderLayout();
  Border border11;
  TitledBorder titledBorder4;
  JPanel authoPanel = new JPanel();
  BorderLayout borderLayout17 = new BorderLayout();
  JPanel authoNorthPanel = new JPanel();
  JPanel authoWestPanel = new JPanel();
  JPanel authoSouthPanel = new JPanel();
  JPanel authoEastPanel = new JPanel();
  JPanel authoCenterPanel = new JPanel();
  GridBagLayout gridBagLayout2 = new GridBagLayout();
  Border border12;
  TitledBorder titledBorder5;
  JCheckBox authoStrongCheckBox = new JCheckBox();
  JCheckBox authoWeakCheckBox = new JCheckBox();
  BorderLayout borderLayout18 = new BorderLayout();
  JCheckBox authoParentCheckBox = new JCheckBox();
  JScrollPane authoTableScrollPane = new JScrollPane();
  JTable authoTable = new JTable();
  JCheckBox authoChildCheckBox = new JCheckBox();
  Border border13;
  TitledBorder titledBorder6;
  JCheckBox authoNegativeCheckBox = new JCheckBox();
  JCheckBox authoPositiveCheckBox = new JCheckBox();
  JButton authoNewButton = new JButton();
  JButton authoChangeButton = new JButton();
  JButton authoRemoveButton = new JButton();
  JButton renameGroupButton = new JButton();
  JButton renameResourceButton = new JButton();
  JComboBox resFilterComboBox = new JComboBox();
  Border border14;
  TitledBorder titledBorder7;
  JButton setReturingFieldsButton = new JButton();
  JButton exportMembersButton = new JButton();
  Border border15;
  JSplitPane conflictsSplitPane = new JSplitPane();
  JScrollPane leftConflictsScrollPane = new JScrollPane();
  JScrollPane rightConflictsScrollPane = new JScrollPane();
  JTable authoConflictsTable = new JTable();
  Border border16;
  TitledBorder titledBorder8;
  JCheckBox authoStrongConflictsCheckBox = new JCheckBox();
  GridBagLayout gridBagLayout3 = new GridBagLayout();
  JCheckBox activatedAuthoFilterCheckBox = new JCheckBox();
  JCheckBox checkForConflictsCheckBox = new JCheckBox();

  //Mtodos privados definidos manualmente

  private void updateRoleConflictPane(Group gp) {
    try {
      if ( (GlobalDefinitions.sa != null) &&
            checkForConflictsCheckBox.isSelected()) {
        if (GlobalDefinitions.sa.AccessAllowed("VerificarConflitos;Grupos;MACA",
                                               "Execuo")) {
          if (gp.getGroupType().equalsIgnoreCase(System.getProperty(
              "maca_ca.roleName"))) {
            Role role = gp.getGroupAsRole();
            if (conflitingTableModel != null) {
              conflitingTableModel.clear();
            }
            conflictingAuthos =
                role.getConflictingAuthorizations(authoStrongConflictsCheckBox.
                                                  isSelected(),
                                                  "*"+this.revertResourceName(this.resFilterComboBoxModel.getSelectedResourceName()));

            if (conflitingTableModel == null) {
              conflitingTableModel =
                  new ConflictingAuthorizationsTableModel(conflictingAuthos,
                  this.authoConflictsTable);
              this.authoConflictsTable.setVisible(true);
            }
            else {
              conflitingTableModel.clear();
              conflitingTableModel.setAuthorizations(conflictingAuthos);
            }
            this.statusLabel.setText(
                "Status: verificaao de conflitos realizada!");
          }
        }
        else {
          checkForConflictsCheckBox.setSelected(false);
          JOptionPane.showMessageDialog(this, "Voc no tem PERMISSO para\n" +
                                        "executar esta operao!",
                                        "Advertncia",
                                        JOptionPane.WARNING_MESSAGE);
        }
      }
      else {
        if (conflitingTableModel != null) {
          this.conflitingTableModel.clear();
        }
      }
    }
    catch (Exception exc) {
      JOptionPane.showMessageDialog(this, exc.getMessage(),
                                    "Erro verificado autorizaoes conflitantes",
                                    JOptionPane.ERROR_MESSAGE);
    }
  }

  private void getUserRoles(Vector fieldsValues, Vector returningFields) {
    int pos = -1;
    for (int n = 0; n < returningFields.size(); n++) {
      if ( ( (String) returningFields.get(n)).equalsIgnoreCase("userRoles")) {
        pos = n;
        break;
      }
    }
    if (pos != -1) {
      User user = null;
      String uid = "";
      Vector userAttr = null;
      Vector rolesList = null;
      String userRoles = "";
      for (int n = 0; n < fieldsValues.size(); n++) {
        userAttr = (Vector) fieldsValues.get(n);
        uid = (String) userAttr.get(0);
        try {
          user = new User(GlobalDefinitions.ctx,
                          System.getProperty("maca_ca.ldap.peopleRDN") + "," +
                          System.getProperty("maca_ca.ldap.rootDN"),
                          "uid=" + uid);
          rolesList = user.getRolesNames();
          for (int i = 0; i < rolesList.size(); i++) {
            userRoles = userRoles + rolesList.get(i) +
                ( (i == rolesList.size() - 1) ? "" : ";");
          }
        }
        catch (Exception exc) {
          this.statusLabel.setText("Erro: " + exc.getMessage());
        }
        userAttr.setElementAt(userRoles, pos);
        userRoles = "";
      }
    }
  }

  private void updateUserTable(String filter, Vector returningFields,
                               Vector headers) throws NamingException {
    Vector fieldsValues = userGroup.getMembers(filter, returningFields);
    this.getUserRoles(fieldsValues, returningFields);
    userTable.setModel(new MACA_TableSorter(new DefaultTableModel(fieldsValues,
        headers)));
    ( (MACA_TableSorter) userTable.getModel()).addMouseListenerToHeaderInTable(
        userTable);
    userTable.sizeColumnsToFit( -1);
    statusLabel.setText("Status: " + Integer.toString(userTable.getRowCount()) +
                        " registro(s) retornado(s).");
  }

  private void openAutorizationDialog() {
    int selRow = this.authoTable.getSelectedRow();
    if (selRow >= 0) {
      try {
        Authorization autho = this.roleTableModel.getAutorization(selRow);
        if (this.roleTableModel.isAuthorizationEditable(autho)) {
          AuthorizationDialog authoDlg = new AuthorizationDialog(autho);
          authoDlg.setVisible(true);
          if (authoDlg.wasSaved()) {
            this.refreshAuthorizationsRoleTable();
          }
        }
        else {
          JOptionPane.showMessageDialog(this,
              "Proibido alterar autorizaes herdadas.",
                                        "Erro para alterar autorizao",
                                        JOptionPane.ERROR_MESSAGE);
        }
      }
      catch (Exception exc) {
        JOptionPane.showMessageDialog(this, exc.getMessage(),
                                      "Erro para alterar autorizao",
                                      JOptionPane.ERROR_MESSAGE);
      }
    }
    else {
      JOptionPane.showMessageDialog(this, "Selecione uma autorizao \n" +
                                    "da lista para alterar.",
                                    "Informao",
                                    JOptionPane.INFORMATION_MESSAGE);
    }
  }

  private void consultarUsuario() {
    if (GlobalDefinitions.sa != null) {
      try {
        if (GlobalDefinitions.sa.AccessAllowed("ConsultarUsuario;Usuarios;MACA",
                                               "Execuo")) {
          Vector headers = this.userRetFldDlg.getSelectedFieldsHeaders();
          headers.add(0, "Login");
          Vector returningFields = this.userRetFldDlg.getSelectedFieldsNames();
          returningFields.add(0, "uid");
          if (userTextField.getText().equalsIgnoreCase("")) {
            if (JOptionPane.showConfirmDialog(this,
                "Esta consulta retorna todos \n os usurios e pode demorar.\n" +
                                              "Deseja CANCELAR esta operao?",
                                              "Advertncia",
                                              JOptionPane.YES_NO_OPTION,
                                              JOptionPane.WARNING_MESSAGE) ==
              JOptionPane.NO_OPTION) {
            	String filter = "uid=*";
                if (this.userRetFldDlg.accountTypeComboBox.getSelectedIndex() == 1) {
                  	filter = "&(!(userPassword=*))" + "(" + filter + ")";
                }
                else if (this.userRetFldDlg.accountTypeComboBox.getSelectedIndex() == 2) {
                  	filter = "&(userPassword=*)" + "(" + filter + ")";
                }            	
                this.updateUserTable(filter, returningFields, headers);
            }
          }
          else {
            String filter = UserApplet.LDAP_LABELS_MAP.get(fieldsComboBox.getSelectedItem()) +
                                                            "=*" + this.userTextField.getText() + "*";
            if (this.userRetFldDlg.accountTypeComboBox.getSelectedIndex() == 1) {
              	filter = "&(!(userPassword=*))" + "(" + filter + ")";
            }
            else if (this.userRetFldDlg.accountTypeComboBox.getSelectedIndex() == 2) {
              	filter = "&(userPassword=*)" + "(" + filter + ")";
            }            	
            this.updateUserTable(filter, returningFields, headers);
          }
        }
        else {
          JOptionPane.showMessageDialog(this, "Voc no tem PERMISSO para\n" +
                                        "executar esta operao!",
                                        "Advertncia",
                                        JOptionPane.WARNING_MESSAGE);
        }
      }
      catch (NamingException exc) {
        JOptionPane.showMessageDialog(this, exc.getMessage(),
                                      "Erro consultando usurios",
                                      JOptionPane.ERROR_MESSAGE);
      }
    }
  }

  private void fillFieldsComboBox() {
    fieldsComboBox.removeAllItems();
    Enumeration enum = UserApplet.LDAP_LABELS_MAP.keys();
    while (enum.hasMoreElements()) {
      fieldsComboBox.addItem( (String) enum.nextElement());
    }
    fieldsComboBox.setSelectedItem("Nome");
  }

  protected static String revertResourceName(String resName) {
    StringTokenizer strTk = new StringTokenizer(resName, ";");
    String result = "";
    while (strTk.hasMoreTokens()) {
      result = strTk.nextToken() + (result.equalsIgnoreCase("")?"":";") + result;
    }
    return result;
  }


  private void fillGruposComboBox() {
    gruposComboBox.removeAllItems();
    Enumeration grpEnum = grupos.children();
    String selGroup = "";
    while (grpEnum.hasMoreElements()) {
      Group grupo = (Group) grpEnum.nextElement();
      String groupName = grupo.getName();
      gruposComboBox.addItem(groupName);
      if (groupName.equalsIgnoreCase(System.getProperty("maca_ca.roleName"))) {
        selGroup = groupName;
      }
    }
    gruposComboBox.setSelectedItem(selGroup);
  }

  private void refreshAuthorizationsRoleTable() {
    if ( (this.activatedAuthoFilterCheckBox.isSelected()) &&
         (this.roleTableModel != null)) {
      try {
        this.roleTableModel.filterAutorizations(this.authoStrongCheckBox.
                                                isSelected(),
                                                this.authoWeakCheckBox.
                                                isSelected(),
                                                this.authoParentCheckBox.
                                                isSelected(),
                                                this.authoChildCheckBox.
                                                isSelected(),
                                                this.authoPositiveCheckBox.
                                                isSelected(),
                                                this.authoNegativeCheckBox.
                                                isSelected(),
                                                this.resFilterComboBoxModel.
                                                getSelectedResourceName());
      }
      catch (Exception exc) {
        JOptionPane.showMessageDialog(this, exc.getMessage(),
                                      "Erro lendo autorizaes",
                                      JOptionPane.ERROR_MESSAGE);
      }
    }
    else {
      this.roleTableModel.clear();
    }
  }

  private void associateSelectedGroupToDirTree(boolean keepSelection) {
    try {
      Group[] selPath = new Group[0];
      if (keepSelection) {
        TreePath path = this.dirTree.getSelectionPath();
        if (path != null) {
          selPath = new Group[path.getPathCount()];
          for (int n = 0; n < path.getPathCount(); n++) {
            selPath[n] = (Group) path.getPathComponent(n);
          }
        }
      }
      String selGroupName = (String) gruposComboBox.getSelectedItem();
      selGrupo = new Group(GlobalDefinitions.ctx,
                           System.getProperty("maca_ca.ldap.groupsRDN") + "," +
                           System.getProperty("maca_ca.ldap.rootDN"),
                           "cn=" + selGroupName);
      dirScrollPane.getViewport().remove(dirTree);
      dirTree = new JTree(selGrupo, false);
      dirTree.addTreeSelectionListener(new javax.swing.event.
                                       TreeSelectionListener() {

        public void valueChanged(TreeSelectionEvent e) {
          dirTree_valueChanged(e);
        }
      });
      dirScrollPane.getViewport().add(dirTree, null);
      if (selGroupName.equalsIgnoreCase(System.getProperty("maca_ca.roleName"))) {
        workingDirTabbedPane.setEnabledAt(workingDirTabbedPane.indexOfComponent(this.
            authoPanel), true);
        workingDirTabbedPane.setEnabledAt(workingDirTabbedPane.indexOfComponent(this.
            roleConflictPanel), true);
      }
      else {
        workingDirTabbedPane.setEnabledAt(workingDirTabbedPane.indexOfComponent(this.
            authoPanel), false);
        workingDirTabbedPane.setEnabledAt(workingDirTabbedPane.indexOfComponent(this.
            roleConflictPanel), false);
      }
      workingDirTabbedPane.setSelectedIndex(0);
      if (keepSelection) {
        int selRow = 0;
        for (int n = 0; n < selPath.length - 1; n++) {
          dirTree.setSelectionRow(selRow);
          dirTree.expandRow(selRow);
          TreePath path = dirTree.getSelectionPath();
          if (path != null) {
            Group grp = (Group) path.getLastPathComponent();
            Enumeration enum = grp.children();
            int row = 1;
            while (enum.hasMoreElements()) {
              Group child = (Group) enum.nextElement();
              if (child.getGroupDN().equalsIgnoreCase(selPath[n + 1].getGroupDN())) {
                selRow = selRow + row;
                dirTree.setSelectionRow(selRow);
                break;
              }
              else {
                row = row + 1;
              }
            }
          }
        }
        TreePath path = dirTree.getSelectionPath();
        if (path != null) {
          Group grp = (Group) path.getLastPathComponent();
          this.openGroupApplet(grp);
          memberList.setListData(grp.getMembersIDS(this.subTreeMembersCheckBox.
              isSelected()));
        }
      }
      else {
        if (grpApplet != null) {
          descriptionScrollPane.getViewport().remove(grpApplet);
        }
        memberList.setListData(selGrupo.getMembersIDS(this.
            subTreeMembersCheckBox.isSelected()));
        grpApplet = null;
      }
    }
    catch (NamingException exc) {
      JOptionPane.showMessageDialog(this, exc.getMessage(),
                                    "Erro na leitura do grupo",
                                    JOptionPane.ERROR_MESSAGE);
    }
  }

  private void fillResourcesTree(boolean keepSelection) {
    Group[] selPath = new Group[0];
    if (keepSelection) {
      TreePath path = this.resTree.getSelectionPath();
      if (path != null) {
        selPath = new Group[path.getPathCount()];
        for (int n = 0; n < path.getPathCount(); n++) {
          selPath[n] = (Group) path.getPathComponent(n);
        }
      }
    }
    resScrollPane.getViewport().remove(resTree);
    resTree = new JTree(resGroup, false);
    resTree.addTreeSelectionListener(new javax.swing.event.
                                     TreeSelectionListener() {
      public void valueChanged(TreeSelectionEvent e) {
        resTree_valueChanged(e);
      }
    });
    resTree.setRootVisible(false);
    resScrollPane.getViewport().add(resTree, null);
    if (keepSelection) {
      int selRow = 0;
      for (int n = 0; n < selPath.length - 1; n++) {
        resTree.setSelectionRow(selRow);
        resTree.expandRow(selRow);
        TreePath path = resTree.getSelectionPath();
        if (path != null) {
          Group grp = (Group) path.getLastPathComponent();
          Enumeration enum = grp.children();
          int row = 1;
          while (enum.hasMoreElements()) {
            Group child = (Group) enum.nextElement();
            if (child.getGroupDN().equalsIgnoreCase(selPath[n + 1].getGroupDN())) {
              selRow = selRow + row;
              resTree.setSelectionRow(selRow);
              break;
            }
            else {
              row = row + 1;
            }
          }
        }
      }
      TreePath path = resTree.getSelectionPath();
      if (path == null) {
        resTree.setSelectionRow(0);
        resTree.expandRow(0);
        path = resTree.getSelectionPath();
      }
      Group grp = (Group) path.getLastPathComponent();
      this.openResourceApplet(grp);
    }
  }

  public void setUserID() {
    if (GlobalDefinitions.sa != null) {
      statusLabel.setText("Usurio: " + GlobalDefinitions.sa.getUserID() +
                          " - [" + GlobalDefinitions.sa.getUserRole() + "]");
    }
  }

  public void timeElapsed(maca_ad.Timer t) {
    if (!GlobalDefinitions.isUsed) {
      LockoutDialog lockDlg = new LockoutDialog();
      Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
      lockDlg.setLocation( (d.width - lockDlg.getSize().width) / 2,
                          (d.height - lockDlg.getSize().height) / 2);
      lockDlg.setSize(300, 160);
      lockDlg.pack();
      lockDlg.show();
      lockDlg.dispose();
      GlobalDefinitions.isUsed = true;
    }
    else {
      GlobalDefinitions.isUsed = false;
    }
  }

  public void openUserApplet(String userID, String userName,
                             String matricula,
                             String areaMeio,
                             String cargo) {
    try {
      UserFrame frame = new UserFrame();
      frame.setTitle("Cadastro do Usurio - [" + userID + "]");
      UserApplet applet = new UserApplet(frame, userID, userName, matricula,
                                         areaMeio, cargo);
      applet.isStandalone = true;
      applet.init();
      applet.start();
      frame.setUserApplet(applet);
      frame.setVisible(true);
    }
    catch (Exception exc) {
      JOptionPane.showMessageDialog(this, exc.getMessage(),
                                    "Erro abrindo janela do usurio",
                                    JOptionPane.ERROR_MESSAGE);
    }
  }

  public void openUserApplet(String userID) {
    this.openUserApplet(userID, "", "", "", "");
  }

  public void openAuthorizationsPanel() {
    String selGroupName = (String) gruposComboBox.getSelectedItem();
    if (selGroupName.equalsIgnoreCase(System.getProperty("maca_ca.roleName"))) {
      if (workingDirTabbedPane.getSelectedIndex() ==
          workingDirTabbedPane.indexOfComponent(this.authoPanel)) {
        TreePath dirPath = dirTree.getSelectionPath();
        if (dirPath != null) {
          try {
            Role role = ( (Group) dirPath.getLastPathComponent()).
                getGroupAsRole();
            roleTableModel = new RoleAuthorizationsTableModel(role,
                this.authoTable);
            this.refreshAuthorizationsRoleTable();
          }
          catch (Exception exc) {
            JOptionPane.showMessageDialog(this, exc.getMessage(),
                                          "Erro lendo autorizaes",
                                          JOptionPane.ERROR_MESSAGE);
          }
        }
      }
    }
  }

  public void openGroupApplet(Group grp) {
    try {
      if (grpApplet == null) {
        grpApplet = new GroupApplet(null, grp);
        grpApplet.isStandalone = true;
        grpApplet.init();
        grpApplet.start();
        descriptionScrollPane.getViewport().add(grpApplet, null);
      }
      else {
        grpApplet.setGroup(grp);
      }
    }
    catch (NamingException exc) {
      JOptionPane.showMessageDialog(this, exc.getMessage(),
                                    "Erro abrindo janela do grupo",
                                    JOptionPane.ERROR_MESSAGE);
    }
  }

  public void openNewGroupApplet(String grpStr) {
    try {
      JDialog frame = new JDialog();
      GroupApplet applet = new GroupApplet(frame, GlobalDefinitions.ctx.value,
                                           System.getProperty(
          "maca_ca.ldap.groupsRDN") + "," +
                                           System.getProperty("maca_ca.ldap.rootDN"),
                                           grpStr, true);
      applet.isStandalone = true;
      frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
      frame.setTitle("Novo Grupo - [" +
                     grpStr.substring(grpStr.indexOf('=') + 1,
                                      grpStr.indexOf(',')) + "]");
      frame.getContentPane().add(applet, BorderLayout.CENTER);
      applet.init();
      applet.start();
      frame.setSize(600, 400);
      Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
      frame.setLocation( (d.width - frame.getSize().width) / 2,
                        (d.height - frame.getSize().height) / 2);
      frame.setModal(true);
      frame.setVisible(true);
    }
    catch (NamingException exc) {
      JOptionPane.showMessageDialog(this, exc.getMessage(),
                                    "Erro abrindo janela do novo grupo",
                                    JOptionPane.ERROR_MESSAGE);
    }
  }

  public void openNewResourceApplet(String resStr) {
    try {
      JDialog frame = new JDialog();
      ResourceApplet applet = new ResourceApplet(frame, resStr);
      applet.isStandalone = true;
      frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
      frame.setTitle("Novo Recurso - [" +
                     resStr.substring(0, resStr.indexOf(',')) + "]");
      frame.getContentPane().add(applet, BorderLayout.CENTER);
      applet.init();
      applet.start();
      frame.setSize(600, 420);
      Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
      frame.setLocation( (d.width - frame.getSize().width) / 2,
                        (d.height - frame.getSize().height) / 2);
      frame.setModal(true);
      frame.setVisible(true);
    }
    catch (NamingException exc) {
      JOptionPane.showMessageDialog(this, exc.getMessage(),
                                    "Erro abrindo janela do novo recurso",
                                    JOptionPane.ERROR_MESSAGE);
    }
  }

  public void openResourceApplet(Group grp) {
    if (resApplet == null) {
      resApplet = new ResourceApplet(null, grp);
      resApplet.isStandalone = true;
      resApplet.init();
      resApplet.start();
      resAttrScrollPane.getViewport().add(resApplet, null);
    }
    else {
      try {
        resApplet.setGroup(grp);
      }
      catch (NamingException exc) {
        JOptionPane.showMessageDialog(this, exc.getMessage(),
                                      "Erro abrindo janela de recurso",
                                      JOptionPane.ERROR_MESSAGE);
      }
    }
  }

  //Get a parameter value
  public String getParameter(String key, String def) {
    return isStandalone ? System.getProperty(key, def) :
        (getParameter(key) != null ? getParameter(key) : def);
  }

  //Construct the applet
  public MACA_Applet(JFrame frame, String ldapServer, String ldapPort,
                     String login, String credentials) {
    containerFrame = frame;
    maca_ad.Timer timer = new maca_ad.Timer(10 * 60 * 1000, this); //10 minutos
    timer.start();
    Hashtable env = new Hashtable();
    env.put(Context.INITIAL_CONTEXT_FACTORY, "com.sun.jndi.ldap.LdapCtxFactory");
    if (GlobalDefinitions.isSSL) {
      env.put(Context.SECURITY_PROTOCOL, "ssl");
      env.put("java.naming.ldap.factory.socket",
              System.getProperty("maca_ca.ldap.ssl.factory.socket"));
    }
    env.put(Context.SECURITY_AUTHENTICATION, "simple");
    env.put(Context.SECURITY_PRINCIPAL,
            "uid=" + login + "," + System.getProperty("maca_ca.ldap.peopleRDN") +
            "," + System.getProperty("maca_ca.ldap.rootDN"));
    env.put(Context.SECURITY_CREDENTIALS, credentials);
    env.put(Context.PROVIDER_URL, "ldap://" + ldapServer + ":" + ldapPort + "/");
    topStatusLabel.setText( (String) env.get(Context.PROVIDER_URL));
    try {
      GlobalDefinitions.ctx.value = new InitialDirContext(env);
    }
    catch (NamingException exc) {
      JOptionPane.showMessageDialog(this, exc.toString(),
                                    "Erro conectando com o servidor LDAP!",
                                    JOptionPane.ERROR_MESSAGE);
      if (containerFrame != null) {
        containerFrame.dispatchEvent(new WindowEvent(containerFrame,
            WindowEvent.WINDOW_CLOSING));
      }
    }
  }

  //Initialize the applet
  public void init() {
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception {
    border1 = BorderFactory.createEtchedBorder(Color.white,
                                               new Color(142, 142, 142));
    titledBorder1 = new TitledBorder(border1, "Recursos disponveis");
    border2 = BorderFactory.createEtchedBorder(Color.white,
                                               new Color(178, 178, 178));
    titledBorder2 = new TitledBorder(border2, "Recursos disponveis");
    border3 = BorderFactory.createEtchedBorder(Color.white,
                                               new Color(142, 142, 142));
    border4 = BorderFactory.createEtchedBorder(Color.white,
                                               new Color(142, 142, 142));
    border5 = BorderFactory.createEtchedBorder(Color.white,
                                               new Color(142, 142, 142));
    border6 = BorderFactory.createEtchedBorder(Color.white,
                                               new Color(178, 178, 178));
    titledBorder3 = new TitledBorder(border6, "Usurios");
    border7 = BorderFactory.createEtchedBorder(Color.white,
                                               new Color(142, 142, 142));
    border8 = BorderFactory.createCompoundBorder(BorderFactory.
                                                 createEtchedBorder(Color.white,
        new Color(142, 142, 142)), BorderFactory.createEmptyBorder(2, 2, 2, 2));
    border9 = BorderFactory.createEtchedBorder(Color.white,
                                               new Color(142, 142, 142));
    border10 = BorderFactory.createEtchedBorder(Color.white,
                                                new Color(142, 142, 142));
    border11 = BorderFactory.createLineBorder(UIManager.getColor(
        "List.selectionBackground"), 1);
    titledBorder4 = new TitledBorder(border11, "Papis conflitantes");
    border12 = BorderFactory.createEmptyBorder();
    titledBorder5 = new TitledBorder(BorderFactory.createEtchedBorder(Color.
        white, new Color(149, 142, 130)), "Filtros");
    border13 = BorderFactory.createEtchedBorder(Color.white,
                                                new Color(159, 159, 159));
    titledBorder6 = new TitledBorder(border13, "Recurso");
    border14 = BorderFactory.createEtchedBorder(Color.white,
                                                new Color(178, 178, 178));
    titledBorder7 = new TitledBorder(border14, "Filtro");
    border15 = BorderFactory.createEtchedBorder(Color.white,
                                                new Color(149, 142, 130));
    border16 = new EtchedBorder(EtchedBorder.RAISED, Color.white,
                                new Color(149, 142, 130));
    titledBorder8 = new TitledBorder(border16, "Autorizaes conflitantes");
    this.setSize(new Dimension(800, 600));
    this.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {

      public void mouseMoved(MouseEvent e) {
        this_mouseMoved(e);
      }
    });
    centerPanel.setLayout(borderLayout1);
    dirPanel.setLayout(borderLayout2);
    leftDirPanel.setLayout(borderLayout3);
    rightDirPanel.setLayout(borderLayout4);
    gruposComboBox.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        gruposComboBox_itemStateChanged(e);
      }
    });
    dirScrollPane.setAutoscrolls(true);
    dirTree.setAutoscrolls(true);
    dirTree.addTreeSelectionListener(new javax.swing.event.
                                     TreeSelectionListener() {

      public void valueChanged(TreeSelectionEvent e) {
        dirTree_valueChanged(e);
      }
    });
    borderLayout2.setHgap(2);
    borderLayout2.setVgap(2);
    descriptionPanel.setLayout(borderLayout5);
    resPanel.setLayout(borderLayout6);
    resTree.setRootVisible(false);
    resTree.addTreeSelectionListener(new javax.swing.event.
                                     TreeSelectionListener() {

      public void valueChanged(TreeSelectionEvent e) {
        resTree_valueChanged(e);
      }
    });
    resSplitPane.setDividerSize(10);
    userPanel.setLayout(borderLayout9);
    topUserPanel.setLayout(gridBagLayout1);
    searchButton.setMnemonic('P');
    searchButton.setText("Pesquisar");
//    this.rootPane.setDefaultButton(searchButton);
    searchButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        searchButton_actionPerformed(e);
      }
    });

    filterLabel.setText("Contendo:");
    userTextField.setToolTipText("mail=g*");
    userTextField.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        userTextField_keyPressed(e);
      }
    });
    centerUserPanel.setLayout(borderLayout10);
    editUserButton.setToolTipText("");
    editUserButton.setMnemonic('A');
    editUserButton.setText("Alterar");
    editUserButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        editUserButton_actionPerformed(e);
      }
    });
    topUserPanel.setBorder(border3);
    centerUserPanel.setBorder(border4);
    bottomUserPanel.setBorder(border5);
    newUserButton.setMnemonic('N');
    newUserButton.setText("Novo");
    newUserButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        newUserButton_actionPerformed(e);
      }
    });
    removeButton.setText("Remover");
    removeButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        removeButton_actionPerformed(e);
      }
    });
    jPanel1.setBorder(border7);
    newGroupButton.setToolTipText("Cria um novo grupo");
    newGroupButton.setActionCommand("Novo");
    newGroupButton.setMnemonic('N');
    newGroupButton.setText("Novo");
    newGroupButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        newGroupButton_actionPerformed(e);
      }
    });
    removeGroupButton.setToolTipText("Remove o grupo selecionado");
    removeGroupButton.setText("Remover");
    removeGroupButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        removeGroupButton_actionPerformed(e);
      }
    });
    resRightPanel.setLayout(borderLayout11);
    newResourceButton.setToolTipText("Cria um novo recurso");
    newResourceButton.setMnemonic('N');
    newResourceButton.setText("Novo");
    newResourceButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        newResourceButton_actionPerformed(e);
      }
    });
    removeResourceButton.setToolTipText("Remove o recurso selecionado");
    removeResourceButton.setText("Remover");
    removeResourceButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        removeResourceButton_actionPerformed(e);
      }
    });
    refreshButton.setToolTipText("Redesenha a rvore");
    refreshButton.setMnemonic('A');
    refreshButton.setText("Atualizar");
    refreshButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        refreshButton_actionPerformed(e);
      }
    });
    macaTabbedPane.addChangeListener(new javax.swing.event.ChangeListener() {

      public void stateChanged(ChangeEvent e) {
        macaTabbedPane_stateChanged(e);
      }
    });
    statusLabel.setText("Usurio:");
    bottomPanel.setLayout(borderLayout12);
    bottomPanel.setBorder(border8);
    RefreshGroupButton.setToolTipText("Redesenha a rvore");
    RefreshGroupButton.setMnemonic('A');
    RefreshGroupButton.setText("Atualizar");
    RefreshGroupButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        refreshGroupButton_actionPerformed(e);
      }
    });
    membersPanel.setLayout(borderLayout13);
    memberList.addMouseListener(new java.awt.event.MouseAdapter() {

      public void mouseClicked(MouseEvent e) {
        memberList_mouseClicked(e);
      }
    });
    subTreeMembersCheckBox.setText("Incluir membros dos subgrupos");
    subTreeMembersCheckBox.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        subTreeMembersCheckBox_actionPerformed(e);
      }
    });
    topMembersPanel.setBorder(border9);
    aboutLabel.setText("       Copyright (c) 2000-2004 Fundao Zerbini/Instituto do Corao - HC.FMUSP");
    userScrollPane.setVerticalScrollBarPolicy(JScrollPane.
                                              VERTICAL_SCROLLBAR_ALWAYS);
    jLabel1.setToolTipText("");
    jLabel1.setText("Pesquisar campo:");
    fieldsComboBox.setEditor(null);
    userTable.setToolTipText("");
    userTable.setAutoResizeMode(JTable.AUTO_RESIZE_ALL_COLUMNS);
    userTable.addMouseListener(new java.awt.event.MouseAdapter() {

      public void mouseClicked(MouseEvent e) {
        userTable_mouseClicked(e);
      }
    });
    closeButton.setText("Sair");
    closeButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        closeButton_actionPerformed(e);
      }
    });
    topPanel.setLayout(borderLayout14);
    exportButton.setToolTipText(
        "Export resultado da pesquisa para arquivo texto");
    exportButton.setMnemonic('E');
    exportButton.setText("Exportar");
    exportButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        exportButton_actionPerformed(e);
      }
    });
    roleConflictPanel.setLayout(borderLayout15);
    centerRoleConflictPanel.setLayout(borderLayout16);
    authoPanel.setLayout(borderLayout17);
    authoNorthPanel.setLayout(gridBagLayout2);
    authoNorthPanel.setBorder(titledBorder5);
    authoStrongCheckBox.setToolTipText("Mostra as autorizaes fortes");
    authoStrongCheckBox.setMnemonic('F');
    authoStrongCheckBox.setSelected(true);
    authoStrongCheckBox.setText("Forte");
    authoStrongCheckBox.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        authoFilterChange_actionPerformed(e);
      }
    });
    authoWeakCheckBox.setToolTipText("Mostra as autorizaes fracas");
    authoWeakCheckBox.setMnemonic('R');
    authoWeakCheckBox.setSelected(true);
    authoWeakCheckBox.setText("Fraca");
    authoWeakCheckBox.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        authoFilterChange_actionPerformed(e);
      }
    });
    authoCenterPanel.setLayout(borderLayout18);
    authoParentCheckBox.setToolTipText("Mostra as autorizaes herdadas");
    authoParentCheckBox.setActionCommand("Herdadas");
    authoParentCheckBox.setMnemonic('H');
    authoParentCheckBox.setSelected(true);
    authoParentCheckBox.setText("Herdadas");
    authoParentCheckBox.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        authoParentCheckBox_actionPerformed(e);
      }
    });
    authoChildCheckBox.setToolTipText(
        "Mostra as autorizaes do papel selecionado");
    authoChildCheckBox.setMnemonic('P');
    authoChildCheckBox.setSelected(true);
    authoChildCheckBox.setText("Papel selecionado");
    authoChildCheckBox.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        authoChildCheckBox_actionPerformed(e);
      }
    });
    authoTable.setAutoResizeMode(JTable.AUTO_RESIZE_ALL_COLUMNS);
    authoTable.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(MouseEvent e) {
        try {
          authoTable_mouseClicked(e);
        }
        catch (Exception exc) {
          JOptionPane.showMessageDialog(null, exc.getMessage(),
                                        "Erro na lendo o autorizao/recurso",
                                        JOptionPane.ERROR_MESSAGE);
        }
      }
    });
    authoNegativeCheckBox.setToolTipText("Mostra as autorizaes negativas");
    authoNegativeCheckBox.setMnemonic('N');
    authoNegativeCheckBox.setSelected(true);
    authoNegativeCheckBox.setText("Negativa");
    authoNegativeCheckBox.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        authoFilterChange_actionPerformed(e);
      }
    });
    authoPositiveCheckBox.setToolTipText("Mostra as autorizaes positivas");
    authoPositiveCheckBox.setMnemonic('P');
    authoPositiveCheckBox.setSelected(true);
    authoPositiveCheckBox.setText("Positiva");
    authoPositiveCheckBox.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        authoFilterChange_actionPerformed(e);
      }
    });
    authoNewButton.setToolTipText(
        "Cria uma nova autorizao para o papel selecionado");
    authoNewButton.setMnemonic('N');
    authoNewButton.setText("Novo");
    authoNewButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        authoNewButton_actionPerformed(e);
      }
    });
    authoChangeButton.setToolTipText(
        "Modifica autorizao do papel selecionado");
    authoChangeButton.setMnemonic('A');
    authoChangeButton.setText("Alterar");
    authoChangeButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        authoChangeButton_actionPerformed(e);
      }
    });
    authoRemoveButton.setToolTipText("Exclui autorizao do papel selecionado");
    authoRemoveButton.setMnemonic('R');
    authoRemoveButton.setText("Remover");
    authoRemoveButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        authoRemoveButton_actionPerformed(e);
      }
    });
    renameGroupButton.setToolTipText("Modifica o nome do grupo selecionado");
    renameGroupButton.setMnemonic('R');
    renameGroupButton.setText("Renomear");
    renameGroupButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        renameGroupButton_actionPerformed(e);
      }
    });
    renameResourceButton.setToolTipText(
        "Modifica o nome do recurso selecionado");
    renameResourceButton.setMnemonic('R');
    renameResourceButton.setText("Renomear");
    renameResourceButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        renameResourceButton_actionPerformed(e);
      }
    });
    resFilterComboBox.setBorder(titledBorder7);
    resFilterComboBox.addPopupMenuListener(new javax.swing.event.
                                           PopupMenuListener() {
      public void popupMenuWillBecomeVisible(PopupMenuEvent e) {
        resFilterComboBox_popupMenuWillBecomeVisible(e);
      }

      public void popupMenuWillBecomeInvisible(PopupMenuEvent e) {
        resFilterComboBox_popupMenuWillBecomeInvisible(e);
      }

      public void popupMenuCanceled(PopupMenuEvent e) {
      }
    });
    setReturingFieldsButton.setToolTipText(
        "Seleciona campos de retorno na pesquisa");
    setReturingFieldsButton.setIcon(new ImageIcon(maca_ad.MACA_Applet.class.
                                                  getResource("field.gif")));
    setReturingFieldsButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        setReturingFieldsButton_actionPerformed(e);
      }
    });
    exportMembersButton.setMnemonic('E');
    exportMembersButton.setText("Exportar");
    exportMembersButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        exportMembersButton_actionPerformed(e);
      }
    });
    conflictsSplitPane.setDividerSize(0);
    rightConflictsScrollPane.setBorder(titledBorder8);
    authoStrongConflictsCheckBox.setText("Forte");
    authoStrongConflictsCheckBox.addActionListener(new java.awt.event.
        ActionListener() {
      public void actionPerformed(ActionEvent e) {
        checkForConflictsCheckBox_actionPerformed(e);
      }
    });
    authoStrongConflictsCheckBox.setSelected(true);
    authoStrongConflictsCheckBox.setMnemonic('F');
    authoStrongConflictsCheckBox.setToolTipText("Mostra somente os conflitos fortes");
    topRoleConflictPanel.setLayout(gridBagLayout3);
    activatedAuthoFilterCheckBox.setMnemonic('F');
    activatedAuthoFilterCheckBox.setText("Filtrar autorizaes");
    activatedAuthoFilterCheckBox.addActionListener(new java.awt.event.
        ActionListener() {
      public void actionPerformed(ActionEvent e) {
        activatedAuthoFilterCheckBox_actionPerformed(e);
      }
    });
    checkForConflictsCheckBox.setText("Verificar conflitos");
    checkForConflictsCheckBox.addActionListener(new java.awt.event.
                                                ActionListener() {
      public void actionPerformed(ActionEvent e) {
        checkForConflictsCheckBox_actionPerformed(e);
      }
    });
    roleConflictPanel.addFocusListener(new java.awt.event.FocusAdapter() {
      public void focusGained(FocusEvent e) {
        roleConflictPanel_focusGained(e);
      }
    });
    this.getContentPane().add(topPanel, BorderLayout.NORTH);
    topPanel.add(closeButton, BorderLayout.EAST);
    topPanel.add(topStatusLabel, BorderLayout.WEST);
    bottomPanel.add(statusLabel, BorderLayout.CENTER);
    bottomPanel.add(aboutLabel, BorderLayout.EAST);
    this.getContentPane().add(centerPanel, BorderLayout.CENTER);
    centerPanel.add(macaTabbedPane, BorderLayout.CENTER);
    macaTabbedPane.add(userPanel, "Usurios");
    macaTabbedPane.add(dirPanel, "Grupos");
    macaTabbedPane.add(resPanel, "Recursos");
    dirPanel.add(dirSplitPane, BorderLayout.CENTER);
    dirSplitPane.add(leftDirPanel, JSplitPane.LEFT);
    dirSplitPane.add(rightDirPanel, JSplitPane.RIGHT);
    rightDirPanel.add(workingDirTabbedPane, BorderLayout.CENTER);
    workingDirTabbedPane.add(descriptionPanel, "Descrio");
    workingDirTabbedPane.add(membersPanel, "Membros");
    workingDirTabbedPane.add(roleConflictPanel, "Conflitos");
    roleConflictPanel.add(topRoleConflictPanel, BorderLayout.NORTH);
    topRoleConflictPanel.add(authoStrongConflictsCheckBox,
                             new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
        , GridBagConstraints.CENTER, GridBagConstraints.NONE,
        new Insets(15, 22, 16, 0), 145, 0));
    roleConflictPanel.add(centerRoleConflictPanel, BorderLayout.CENTER);
    roleConflictPanel.add(bottomRoleConflictPanel, BorderLayout.SOUTH);
    bottomRoleConflictPanel.add(checkForConflictsCheckBox, null);
    workingDirTabbedPane.add(authoPanel, "Autorizaes");
    membersPanel.add(topMembersPanel, BorderLayout.SOUTH);
    topMembersPanel.add(subTreeMembersCheckBox, null);
    topMembersPanel.add(exportMembersButton, null);
    membersPanel.add(memberScrollPane, BorderLayout.CENTER);
    memberScrollPane.getViewport().add(memberList, null);
    resPanel.add(resSplitPane, BorderLayout.CENTER);
    resSplitPane.add(resScrollPane, JSplitPane.LEFT);
    resSplitPane.add(resRightPanel, JSplitPane.RIGHT);
    resRightPanel.add(buttonsPanel, BorderLayout.SOUTH);
    buttonsPanel.add(newResourceButton, null);
    buttonsPanel.add(renameResourceButton, null);
    buttonsPanel.add(removeResourceButton, null);
    buttonsPanel.add(refreshButton, null);
    resRightPanel.add(resAttrScrollPane, BorderLayout.CENTER);
    this.getContentPane().add(bottomPanel, BorderLayout.SOUTH);
    userPanel.add(bottomUserPanel, BorderLayout.SOUTH);
    bottomUserPanel.add(newUserButton, null);
    bottomUserPanel.add(editUserButton, null);
    bottomUserPanel.add(removeButton, null);
    bottomUserPanel.add(exportButton, null);
    userPanel.add(centerUserPanel, BorderLayout.CENTER);
    centerUserPanel.add(userScrollPane, BorderLayout.CENTER);
    userScrollPane.getViewport().add(userTable, null);
    userPanel.add(topUserPanel, BorderLayout.NORTH);
    topUserPanel.add(filterLabel, new GridBagConstraints(2, 1, 1, 1, 0.0, 0.0
        , GridBagConstraints.CENTER, GridBagConstraints.VERTICAL,
        new Insets(3, 3, 3, 3), 0, 7));
    topUserPanel.add(userTextField, new GridBagConstraints(3, 1, 1, 1, 1.0, 0.0
        , GridBagConstraints.CENTER, GridBagConstraints.BOTH,
        new Insets(3, 0, 3, 3), 0, 0));
    topUserPanel.add(searchButton, new GridBagConstraints(5, 1, 1, 1, 0.0, 0.0
        , GridBagConstraints.CENTER, GridBagConstraints.NONE,
        new Insets(3, 2, 3, 2), 0, 0));
    topUserPanel.add(fieldsComboBox,
                     new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0
                                            , GridBagConstraints.CENTER,
                                            GridBagConstraints.NONE,
                                            new Insets(3, 0, 3, 3), 0, 0));
    topUserPanel.add(jLabel1, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
        , GridBagConstraints.CENTER, GridBagConstraints.NONE,
        new Insets(3, 3, 3, 3), 0, 0));
    topUserPanel.add(setReturingFieldsButton,
                     new GridBagConstraints(4, 1, 1, 1, 0.0, 0.0
                                            , GridBagConstraints.CENTER,
                                            GridBagConstraints.NONE,
                                            new Insets(0, 2, 0, 2), 0, 0));
    resScrollPane.getViewport().add(resTree, null);
    descriptionPanel.add(descriptionScrollPane, BorderLayout.CENTER);
    descriptionPanel.add(jPanel1, BorderLayout.SOUTH);
    jPanel1.add(newGroupButton, null);
    jPanel1.add(renameGroupButton, null);
    jPanel1.add(removeGroupButton, null);
    jPanel1.add(RefreshGroupButton, null);
    dirSplitPane.setDividerLocation(160);
    leftDirPanel.add(gruposComboBox, BorderLayout.NORTH);
    leftDirPanel.add(dirScrollPane, BorderLayout.CENTER);
    dirScrollPane.getViewport().add(dirTree, null);
    authoPanel.add(authoWestPanel, BorderLayout.WEST);
    authoPanel.add(authoSouthPanel, BorderLayout.SOUTH);
    authoSouthPanel.add(authoNewButton, null);
    authoSouthPanel.add(authoChangeButton, null);
    authoSouthPanel.add(authoRemoveButton, null);
    authoSouthPanel.add(activatedAuthoFilterCheckBox, null);
    authoPanel.add(authoEastPanel, BorderLayout.EAST);
    authoPanel.add(authoCenterPanel, BorderLayout.CENTER);
    authoCenterPanel.add(authoTableScrollPane, BorderLayout.CENTER);
    authoPanel.add(authoNorthPanel, BorderLayout.NORTH);
    authoTableScrollPane.getViewport().add(authoTable, null);
    authoNorthPanel.add(authoNegativeCheckBox,
                        new GridBagConstraints(0, 1, 1,
                                               GridBagConstraints.REMAINDER,
                                               0.0, 0.0
                                               , GridBagConstraints.CENTER,
                                               GridBagConstraints.NONE,
                                               new Insets(0, 0, 0, 0), 0, 0));
    authoNorthPanel.add(authoPositiveCheckBox,
                        new GridBagConstraints(0, 0,
                                               GridBagConstraints.REMAINDER,
                                               GridBagConstraints.REMAINDER,
                                               0.0, 0.0
                                               , GridBagConstraints.NORTHWEST,
                                               GridBagConstraints.NONE,
                                               new Insets(0, 0, 0, 0), 0, 0));
    authoNorthPanel.add(authoChildCheckBox,
                        new GridBagConstraints(3, 1, 1,
                                               GridBagConstraints.REMAINDER,
                                               0.0, 0.0
                                               , GridBagConstraints.CENTER,
                                               GridBagConstraints.NONE,
                                               new Insets(0, 0, 0, 0), 0, 0));
    authoNorthPanel.add(authoStrongCheckBox,
                        new GridBagConstraints(2, 0, 1, 1, 0.0, 0.0
                                               , GridBagConstraints.NORTHWEST,
                                               GridBagConstraints.NONE,
                                               new Insets(0, 0, 0, 0), 0, 0));
    authoNorthPanel.add(authoParentCheckBox,
                        new GridBagConstraints(3, 0, 1, 1, 0.0, 0.0
                                               , GridBagConstraints.NORTHWEST,
                                               GridBagConstraints.NONE,
                                               new Insets(0, 0, 0, 0), 0, 0));
    authoNorthPanel.add(resFilterComboBox,
                        new GridBagConstraints(4, 0, 1, 2, 1.0, 1.0
                                               , GridBagConstraints.NORTH,
                                               GridBagConstraints.BOTH,
                                               new Insets(0, 0, 0, 0), 0, 0));
    authoNorthPanel.add(authoWeakCheckBox,
                        new GridBagConstraints(2, 1, 1,
                                               GridBagConstraints.REMAINDER,
                                               0.0, 0.0
                                               , GridBagConstraints.CENTER,
                                               GridBagConstraints.NONE,
                                               new Insets(0, 0, 0, 0), 0, 0));
    centerRoleConflictPanel.add(conflictsSplitPane, BorderLayout.CENTER);
    conflictsSplitPane.add(leftConflictsScrollPane, JSplitPane.LEFT);
    conflictsSplitPane.add(rightConflictsScrollPane, JSplitPane.RIGHT);
    rightConflictsScrollPane.getViewport().add(authoConflictsTable, null);
    resSplitPane.setDividerLocation(160);
    conflictsSplitPane.setDividerLocation(0);
    authoConflictsTable.setVisible(false);
  }

  //Start the applet
  public void start() {
    try {
      grupos = new Group(GlobalDefinitions.ctx,
                         System.getProperty("maca_ca.ldap.groupsRDN") + "," +
                         System.getProperty("maca_ca.ldap.rootDN"), "");
      resGroup = new Group(GlobalDefinitions.ctx,
                           System.getProperty("maca_ca.ldap.resourcesRDN") +
                           "," +
                           System.getProperty("maca_ca.ldap.rootDN"), "");
      privGroup = new Group(GlobalDefinitions.ctx,
                            System.getProperty("maca_ca.ldap.resourcesRDN") +
                            "," +
                            System.getProperty("maca_ca.ldap.rootDN"), "");
      userGroup = new Group(GlobalDefinitions.ctx,
                            System.getProperty("maca_ca.ldap.peopleRDN") + "," +
                            System.getProperty("maca_ca.ldap.rootDN"), "");
      this.fillFieldsComboBox();
      this.fillGruposComboBox();
      this.fillResourcesTree(false);
      resFilterComboBoxModel = new ResourceLookupComboBoxModel(this.
          resFilterComboBox,
          new Group(GlobalDefinitions.ctx,
                    System.getProperty("maca_ca.ldap.resourcesRDN") + "," +
                    System.getProperty("maca_ca.ldap.rootDN"), ""));
      this.resFilterComboBox.getEditor().getEditorComponent().addKeyListener(new
          KeyListener() {
        public void keyReleased(KeyEvent e) {
          resFilterComboBox_keyReleased(e);
        }

        public void keyTyped(KeyEvent e) {
        }

        public void keyPressed(KeyEvent e) {
        }
      });
      workingDirTabbedPane.addChangeListener(new javax.swing.event.
                                             ChangeListener() {
        public void stateChanged(ChangeEvent e) {
          workingDirTabbedPane_stateChanged(e);
        }
      });
      userTable.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

      newUserButton.setVisible(false);
      editUserButton.setVisible(false);
      removeButton.setVisible(false);
      exportButton.setVisible(true);
    }
    catch (NamingException exc) {
      JOptionPane.showMessageDialog(this, exc.getMessage(),
                                    "Erro acessando o servidor LDAP!",
                                    JOptionPane.ERROR_MESSAGE);
    }
    catch (Exception exc) {
      JOptionPane.showMessageDialog(this, exc.getMessage(),
                                    "Erro!",
                                    JOptionPane.ERROR_MESSAGE);
    }
  }

  //Stop the applet
  public void stop() {
  }

  //Destroy the applet
  public void destroy() {
  }

  //Get Applet information
  public String getAppletInfo() {
    return "Applet Information";
  }

  //Get parameter info
  public String[][] getParameterInfo() {
    return null;
  }

  //static initializer for setting look & feel
  static {
    try {
      //UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
      //UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
    }
    catch (Exception e) {
    }
  }

  void gruposComboBox_itemStateChanged(ItemEvent e) {
    if (e.getStateChange() == ItemEvent.SELECTED) {
      this.associateSelectedGroupToDirTree(false);
    }
  }

  void dirTree_focusGained(FocusEvent e) {
  }

  void dirTree_valueChanged(TreeSelectionEvent e) {
    TreePath path = dirTree.getSelectionPath();
    if (path != null) {
      Group grp = (Group) path.getLastPathComponent();
      this.openGroupApplet(grp);
      try {
        Vector members = grp.getMembersIDS(this.subTreeMembersCheckBox.
                                           isSelected());
        memberList.setListData(members);
        statusLabel.setText("Total de membros: " + members.size());
        this.updateRoleConflictPane(grp);
        this.openAuthorizationsPanel();
      }
      catch (Exception exc) {
        JOptionPane.showMessageDialog(this, exc.getMessage(),
                                      "Erro lendo membros do grupo",
                                      JOptionPane.ERROR_MESSAGE);
      }
    }
  }

  void memberList_mouseClicked(MouseEvent e) {
    if (e.getClickCount() >= 2) {
      if (memberList.getSelectedIndex() >= 0) {
        // this.openUserApplet((String) memberList.getSelectedValue());
      }
    }
  }

  void resTree_valueChanged(TreeSelectionEvent e) {
    TreePath path = resTree.getSelectionPath();
    if (path != null) {
      Group grp = (Group) path.getLastPathComponent();
      this.openResourceApplet(grp);
    }
  }

  void workingDirTabbedPane_stateChanged(ChangeEvent e) {
    this.openAuthorizationsPanel();
  }

  void searchButton_actionPerformed(ActionEvent e) {
    this.consultarUsuario();
    userTextField.requestFocus();
    userTextField.selectAll();
  }

  void editUserButton_actionPerformed(ActionEvent e) {
    if (GlobalDefinitions.sa != null) {
      if (!userTable.getSelectionModel().isSelectionEmpty()) {
        this.openUserApplet( (String) ( (MACA_TableSorter) userTable.getModel()).
                            getValueAt(userTable.getSelectedRow(), 0));
      }
      else {
        JOptionPane.showMessageDialog(this, "Selecione um usurio da lista \n" +
                                      "de usurios para alterar.",
                                      "Informao",
                                      JOptionPane.INFORMATION_MESSAGE);
      }
    }
  }

  void newUserButton_actionPerformed(ActionEvent e) {
    if (GlobalDefinitions.sa != null) {
      if (GlobalDefinitions.sa.AccessAllowed("NovoUsuario;Usuarios;MACA",
                                             "Execuo")) {
        NewUIDDialog uidDlg = new NewUIDDialog();
        Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
        uidDlg.setLocation( (d.width - uidDlg.getSize().width) / 2,
                           (d.height - uidDlg.getSize().height) / 2);
        uidDlg.setSize(400, 225);
//          uidDlg.pack();
        uidDlg.show();
        if (uidDlg.okButtonPressed) {
          this.openUserApplet(uidDlg.uidTextField.getText(),
                              uidDlg.givenNameTextField.getText(),
                              uidDlg.employeeNumberTextField.getText(),
                              uidDlg.areaMeio, uidDlg.cargo);
        }
        uidDlg.dispose();
      }
      else {
        JOptionPane.showMessageDialog(this, "Voc no tem PERMISSO para\n" +
                                      "executar esta operao!",
                                      "Advertncia",
                                      JOptionPane.WARNING_MESSAGE);
      }
    }
  }

  void removeButton_actionPerformed(ActionEvent e) {
    if (GlobalDefinitions.sa != null) {
      try {
        if (!userTable.getSelectionModel().isSelectionEmpty()) {
          String userName = (String) ( (MACA_TableSorter) userTable.getModel()).
              getValueAt(userTable.getSelectedRow(), 0);
          if (GlobalDefinitions.sa.AccessAllowed(
              "RemoverUsuario;Usuarios;MACA(\"" + userName + "\")", "Execuo")) {
            if (JOptionPane.showConfirmDialog(this,
                                              "Voc tem CERTEZA que deseja\n" +
                                              "EXCLUIR o usurio " + userName +
                                              "?",
                                              "Advertncia",
                                              JOptionPane.YES_NO_OPTION,
                                              JOptionPane.WARNING_MESSAGE) ==
                JOptionPane.YES_OPTION) {
              User usr = new User(GlobalDefinitions.ctx,
                                  System.getProperty("maca_ca.ldap.peopleRDN") +
                                  "," +
                                  System.getProperty("maca_ca.ldap.rootDN"),
                                  "uid=" + userName);
              usr.removeUser();
              ( (DefaultTableModel) ( (MACA_TableSorter) userTable.getModel()).
               getModel()).removeRow( ( (MACA_TableSorter) userTable.getModel()).
                                     indexes[userTable.getSelectedRow()]);
            }
          }
          else {
            JOptionPane.showMessageDialog(this, "Voc no tem PERMISSO para\n" +
                                          "executar esta operao!",
                                          "Advertncia",
                                          JOptionPane.WARNING_MESSAGE);
          }
        }
        else {
          JOptionPane.showMessageDialog(this,
                                        "Selecione um usurio da lista \n" +
                                        "de usurios para remover.",
                                        "Informao",
                                        JOptionPane.INFORMATION_MESSAGE);
        }
      }
      catch (NamingException exc) {
        JOptionPane.showMessageDialog(this, exc.getMessage(),
                                      "Erro na exlcuso do usurio",
                                      JOptionPane.ERROR_MESSAGE);
      }
      catch (Exception exc) {
        JOptionPane.showMessageDialog(this, exc.getMessage(),
                                      "Erro na exlcuso do usurio",
                                      JOptionPane.ERROR_MESSAGE);
      }
    }
  }

  void newGroupButton_actionPerformed(ActionEvent e) {
    if (GlobalDefinitions.sa != null) {
      if (GlobalDefinitions.sa.AccessAllowed("NovoGrupo;Grupos;MACA",
                                             "Execuo")) {
        TreePath path = dirTree.getSelectionPath();
        if (path != null) {
          NewGroupDialog newGrpDlg = new NewGroupDialog(null, "Novo Grupo", true);
          Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
          newGrpDlg.setLocation( (d.width - newGrpDlg.getSize().width) / 2,
                                (d.height - newGrpDlg.getSize().height) / 2);
          newGrpDlg.setSize(400, 150);
          newGrpDlg.show();
          if (newGrpDlg.okButtonPressed) {
            Group grp = (Group) path.getLastPathComponent();
            this.openNewGroupApplet("cn=" + newGrpDlg.uidTextField.getText() +
                                    "," + grp.getGroupRDN());
            this.refreshGroupButton_actionPerformed(e);
          }
          newGrpDlg.dispose();
        }
        else {
          JOptionPane.showMessageDialog(this, "SELECIONE um grupo antes de\n" +
                                        "criar um novo SUBGRUPO!",
                                        "Informao",
                                        JOptionPane.INFORMATION_MESSAGE);
        }
      }
      else {
        JOptionPane.showMessageDialog(this,
            "Voc no tem PERMISSO para criar grupos!",
                                      "Advertncia",
                                      JOptionPane.WARNING_MESSAGE);
      }
    }
  }

  void removeGroupButton_actionPerformed(ActionEvent e) {
    try {
      if ( (GlobalDefinitions.sa != null) &&
          (GlobalDefinitions.sa.AccessAllowed("RemoveGrupo;Grupos;MACA",
                                              "Execuo"))) {
        TreePath path = dirTree.getSelectionPath();
        if (path != null) {
          Group grp = (Group) path.getLastPathComponent();
          if (JOptionPane.showConfirmDialog(this,
                                            "Voc tem CERTEZA que deseja\n" +
                                            "EXCLUIR o grupo " + grp.getName() +
                                            "?",
                                            "Advertncia",
                                            JOptionPane.YES_NO_OPTION,
                                            JOptionPane.WARNING_MESSAGE) ==
              JOptionPane.YES_OPTION) {
            TreePath parentPath = path.getParentPath();
            if (grp.removeGroup(false)) {
              this.dirTree.setSelectionPath(parentPath);
              this.refreshGroupButton_actionPerformed(e);
            }
          }
        }
        else {
          JOptionPane.showMessageDialog(this,
              "SELECIONE um grupo antes de remov-lo!",
                                        "Informao",
                                        JOptionPane.INFORMATION_MESSAGE);
        }
      }
      else {
        JOptionPane.showMessageDialog(this, "Voc no tem PERMISSO para\n" +
                                      "executar esta operao!",
                                      "Advertncia",
                                      JOptionPane.WARNING_MESSAGE);
      }
    }
    catch (NamingException exc) {
      JOptionPane.showMessageDialog(this, exc.getMessage(),
                                    "Erro na excluso do grupo",
                                    JOptionPane.ERROR_MESSAGE);
    }
  }

  void newResourceButton_actionPerformed(ActionEvent e) {
    if ( (GlobalDefinitions.sa != null) &&
        (GlobalDefinitions.sa.AccessAllowed("NovoRecurso;Recursos;MACA",
                                            "Execuo"))) {
      NewResourceDialog newResDlg = new NewResourceDialog(null, "Novo Recurso", true);
      Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
      newResDlg.setLocation( (d.width - newResDlg.getSize().width) / 2,
                            (d.height - newResDlg.getSize().height) / 2);
      newResDlg.setSize(400, 150);
      newResDlg.show();
      if (newResDlg.okButtonPressed) {
        TreePath path = resTree.getSelectionPath();
        if (path != null) {
          Group grp = (Group) path.getLastPathComponent();
          this.openNewResourceApplet(newResDlg.uidTextField.getText() + "," +
                                     grp.getGroupRDN());
          this.fillResourcesTree(true);
        }
      }
      newResDlg.dispose();
    }
    else {
      JOptionPane.showMessageDialog(this, "Voc no tem PERMISSO para\n" +
                                    "executar esta operao!",
                                    "Advertncia",
                                    JOptionPane.WARNING_MESSAGE);
    }
  }

  void removeResourceButton_actionPerformed(ActionEvent e) {
    try {
      if ( (GlobalDefinitions.sa != null) &&
          (GlobalDefinitions.sa.AccessAllowed("RemoveRecurso;Recursos;MACA",
                                              "Execuo"))) {
        TreePath path = resTree.getSelectionPath();
        if (path != null) {
          Group grp = (Group) path.getLastPathComponent();
          if (!grp.getName().equalsIgnoreCase("aplicacoes")) {
            if (JOptionPane.showConfirmDialog(this,
                                              "Voc tem CERTEZA que deseja\n" +
                                              "EXCLUIR o recurso " +
                                              grp.getName() + "?",
                                              "Advertncia",
                                              JOptionPane.YES_NO_OPTION,
                                              JOptionPane.WARNING_MESSAGE) ==
                JOptionPane.YES_OPTION) {
              if (grp.removeGroup(false)) {
                this.fillResourcesTree(true);
              }
            }
          }
          else {
            JOptionPane.showMessageDialog(this,
                "Grupo aplicacoes NO pode ser removido!",
                                          "Informao",
                                          JOptionPane.INFORMATION_MESSAGE);
          }
        }
        else {
          JOptionPane.showMessageDialog(this,
              "SELECIONE um recurso antes de remov-lo!",
                                        "Informao",
                                        JOptionPane.INFORMATION_MESSAGE);
        }
      }
      else {
        JOptionPane.showMessageDialog(this, "Voc no tem PERMISSO para\n" +
                                      "executar esta operao!",
                                      "Advertncia",
                                      JOptionPane.WARNING_MESSAGE);
      }
    }
    catch (NamingException exc) {
      JOptionPane.showMessageDialog(this, exc.getMessage(),
                                    "Erro na excluso de recurso",
                                    JOptionPane.ERROR_MESSAGE);
    }
  }

  void refreshButton_actionPerformed(ActionEvent e) {
    if ( (GlobalDefinitions.sa != null) &&
        (GlobalDefinitions.sa.AccessAllowed("AtualizaRecurso;Recursos;MACA",
                                            "Execuo"))) {
      this.fillResourcesTree(true);
    }
    else {
      JOptionPane.showMessageDialog(this, "Voc no tem PERMISSO para\n" +
                                    "executar esta operao!",
                                    "Advertncia",
                                    JOptionPane.WARNING_MESSAGE);
    }
  }

  void userTextField_keyPressed(KeyEvent e) {
    if (e.getKeyCode() == KeyEvent.VK_ENTER) {
      this.consultarUsuario();
    }
  }

  void macaTabbedPane_stateChanged(ChangeEvent e) {
    if (macaTabbedPane.getSelectedComponent() == userPanel) {
      userTextField.requestFocus();
    }
    else if (macaTabbedPane.getSelectedComponent() == dirPanel) {
      if (this.dirTree.getSelectionCount() == 0) {
        if (this.dirTree.getRowCount() == 1) {
          this.dirTree.setSelectionRow(0);
        }
        else if (this.dirTree.getRowCount() > 1) {
          this.dirTree.setSelectionRow(1);
        }
      }
    }
    else if (macaTabbedPane.getSelectedComponent() == this.resPanel) {
      this.fillResourcesTree(true);
    }
    this.setUserID();
  }

  void refreshGroupButton_actionPerformed(ActionEvent e) {
    this.associateSelectedGroupToDirTree(true);
  }

  void subTreeMembersCheckBox_actionPerformed(ActionEvent e) {
    TreePath path = dirTree.getSelectionPath();
    if (path != null) {
      Group grp = (Group) path.getLastPathComponent();
      try {
        Vector members = grp.getMembersIDS(this.subTreeMembersCheckBox.
                                           isSelected());
        memberList.setListData(members);
        statusLabel.setText("Total de membros: " + members.size());
      }
      catch (NamingException exc) {
        JOptionPane.showMessageDialog(this, exc.getMessage(),
                                      "Erro lendo membros do grupo",
                                      JOptionPane.ERROR_MESSAGE);
      }
    }
  }

  void this_mouseMoved(MouseEvent e) {
    GlobalDefinitions.isUsed = true;
  }

  void userTable_mouseClicked(MouseEvent e) {
    if (e.getClickCount() >= 2) {
      if (userTable.getSelectedRow() >= 0) {
        //  this.openUserApplet((String) ((MACA_TableSorter)userTable.getModel()).getValueAt(userTable.getSelectedRow(), 0));
      }
    }
  }

  void closeButton_actionPerformed(ActionEvent e) {
    if (containerFrame != null) {
      containerFrame.dispatchEvent(new WindowEvent(containerFrame,
          WindowEvent.WINDOW_CLOSING));
    }
  }

  void exportButton_actionPerformed(ActionEvent e) {
    if (GlobalDefinitions.sa != null) {
      if (GlobalDefinitions.sa.AccessAllowed("ExportarConsulta;Usuarios;MACA",
                                             "Execuo")) {
        JFileChooser fchooser = new JFileChooser();
        if (fchooser.showSaveDialog(this) == JFileChooser.APPROVE_OPTION) {
          if (fchooser.getSelectedFile().exists()) {
            if (JOptionPane.showConfirmDialog(this,
                                              "Aquivo j existe.\n" +
                "Deseja APAGAR este arquivo e criar um novo?",
                "Advertncia",
                JOptionPane.YES_NO_OPTION,
                JOptionPane.WARNING_MESSAGE) == JOptionPane.YES_OPTION) {
              this.exportCurrentSearch(fchooser.getSelectedFile().getPath());
            }
          }
          else {
            this.exportCurrentSearch(fchooser.getSelectedFile().getPath());
          }
        }
      }
      else {
        JOptionPane.showMessageDialog(this, "Voc no tem PERMISSO para\n" +
                                      "executar esta operao!",
                                      "Advertncia",
                                      JOptionPane.WARNING_MESSAGE);
      }
    }
  }

  private void exportRoleMembers(String fileName) throws Exception {
    try {
      Vector headers = this.userRetFldDlg.getSelectedFieldsHeaders();
      headers.add(0, "Login");
      Vector returningFields = this.userRetFldDlg.getSelectedFieldsNames();
      returningFields.add(0, "uid");
      Vector users = new Vector(this.memberList.getModel().getSize());
      for (int n = 0; n < this.memberList.getModel().getSize(); n++) {
        String userID = (String)this.memberList.getModel().getElementAt(n);
        User user = new User(GlobalDefinitions.ctx,
                             System.getProperty("maca_ca.ldap.peopleRDN") + "," +
                             System.getProperty("maca_ca.ldap.rootDN"),
                             "uid=" + userID);
        Attributes attrs = user.getUserAtributes();
        Vector userAttrs = new Vector(returningFields.size());
        for (int k = 0; k < returningFields.size(); k++) {
          Attribute attr = attrs.get( (String) returningFields.get(k));
          if (attr != null) {
            userAttrs.add(attr.get());
          }
          else if ( ( (String) returningFields.get(k)).equalsIgnoreCase(
              "userRoles")) {
            Vector rolesList = user.getRolesNames();
            String userRoles = "";
            for (int i = 0; i < rolesList.size(); i++) {
              userRoles = userRoles + rolesList.get(i) +
                  ( (i == rolesList.size() - 1) ? "" : ";");
            }
            userAttrs.add(userRoles);
          }
          else {
            userAttrs.add("");
          }
        }
        users.add(userAttrs);
      }
      int[] maxs = new int[headers.size()];
      DataOutputStream exportStream = new DataOutputStream(new FileOutputStream(
          fileName));
      exportStream.writeBytes("#    | ");
      for (int n = 0; n < headers.size(); n++) {
        int max = 0;
        for (int i = 0; i < users.size(); i++) {
          String str = (String) ( (Vector) users.get(i)).get(n);
          max = Math.max(max, str.length());
        }
        max = max + 1;
        maxs[n] = max;
        int offset = (max > ( (String) headers.get(n)).length() ?
                      max - ( (String) headers.get(n)).length() : max);
        String filler = "";
        for (int i = 0; i < offset; i++) {
          filler = filler + " ";
        }
        exportStream.writeBytes( (String) headers.get(n) + filler + " | ");
      }
      exportStream.writeBytes("\n");
      exportStream.writeBytes("---- | ");
      for (int n = 0; n < headers.size(); n++) {
        int offset = maxs[n];
        String filler = "";
        for (int i = 0; i < offset; i++) {
          filler = filler + "-";
        }
        exportStream.writeBytes(filler + " | ");
      }
      exportStream.writeBytes("\n");
      for (int n = 0; n < users.size(); n++) {
        String intStr = Integer.toString(n);
        int offset = (5 > intStr.length() ? 5 - intStr.length() : 5);
        String filler = "";
        for (int k = 0; k < offset; k++) {
          filler = filler + " ";
        }
        exportStream.writeBytes(intStr + filler + "| ");
        for (int i = 0; i < headers.size(); i++) {
          String str = (String) ( (Vector) users.get(n)).get(i);
          offset = (maxs[i] > str.length() ? maxs[i] - str.length() : maxs[i]);
          filler = "";
          for (int k = 0; k < offset; k++) {
            filler = filler + " ";
          }
          exportStream.writeBytes(str + filler + " | ");
        }
        exportStream.writeBytes("\n");
      }
      exportStream.close();
      JOptionPane.showMessageDialog(this, "Exportao concluda com sucesso!",
                                    "Exportao de Membros de Papis.",
                                    JOptionPane.INFORMATION_MESSAGE);
    }
    catch (java.io.IOException exc) {
      JOptionPane.showMessageDialog(this, exc.getMessage(),
                                    "Erro de E/S exportando dados.",
                                    JOptionPane.ERROR_MESSAGE);
    }
  }

  private void exportCurrentSearch(String fileName) {
    try {
      int[] maxs = new int[userTable.getColumnCount()];
      DataOutputStream exportStream = new DataOutputStream(new FileOutputStream(
          fileName));
      exportStream.writeBytes("#    | ");
      for (int n = 0; n < userTable.getColumnCount(); n++) {
        int max = 0;
        for (int i = 0; i < userTable.getRowCount(); i++) {
          String str = (String) userTable.getValueAt(i, n);
          max = Math.max(max, str.length());
        }
        max = max + 1;
        maxs[n] = max;
        int offset = (max > userTable.getColumnName(n).length() ?
                      max - userTable.getColumnName(n).length() : max);
        String filler = "";
        for (int i = 0; i < offset; i++) {
          filler = filler + " ";
        }
        exportStream.writeBytes(userTable.getColumnName(n) + filler + " | ");
      }
      exportStream.writeBytes("\n");
      exportStream.writeBytes("---- | ");
      for (int n = 0; n < userTable.getColumnCount(); n++) {
        int offset = maxs[n];
        String filler = "";
        for (int i = 0; i < offset; i++) {
          filler = filler + "-";
        }
        exportStream.writeBytes(filler + " | ");
      }
      exportStream.writeBytes("\n");
      for (int n = 0; n < userTable.getRowCount(); n++) {
        String intStr = Integer.toString(n);
        int offset = (5 > intStr.length() ? 5 - intStr.length() : 5);
        String filler = "";
        for (int k = 0; k < offset; k++) {
          filler = filler + " ";
        }
        exportStream.writeBytes(intStr + filler + "| ");
        for (int i = 0; i < userTable.getColumnCount(); i++) {
          String str = (String) userTable.getValueAt(n, i);
          offset = (maxs[i] > str.length() ? maxs[i] - str.length() : maxs[i]);
          filler = "";
          for (int k = 0; k < offset; k++) {
            filler = filler + " ";
          }
          exportStream.writeBytes(str + filler + " | ");
        }
        exportStream.writeBytes("\n");
      }
      exportStream.close();
      JOptionPane.showMessageDialog(this, "Exportao concluda com sucesso!",
                                    "Exportao de Consulta.",
                                    JOptionPane.INFORMATION_MESSAGE);
    }
    catch (java.io.IOException exc) {
      JOptionPane.showMessageDialog(this, exc.getMessage(),
                                    "Erro de E/S exportando dados.",
                                    JOptionPane.ERROR_MESSAGE);
    }
  }

  void roleConflictsButton_actionPerformed(ActionEvent e) {
    if (GlobalDefinitions.sa != null) {
      if (GlobalDefinitions.sa.AccessAllowed("VerificarConflitos;Grupos;MACA",
                                             "Execuo")) {
        TreePath path = dirTree.getSelectionPath();
        if (path != null) {
          Group grp = (Group) path.getLastPathComponent();
          this.updateRoleConflictPane(grp);
        }
      }
      else {
        JOptionPane.showMessageDialog(this, "Voc no tem PERMISSO para\n" +
                                      "executar esta operao!",
                                      "Advertncia",
                                      JOptionPane.WARNING_MESSAGE);
      }
    }
  }

  void authoFilterChange_actionPerformed(ActionEvent e) {
    if (this.activatedAuthoFilterCheckBox.isSelected()) {
      try {
        this.roleTableModel.filterAutorizations(this.authoStrongCheckBox.
                                                isSelected(),
                                                this.authoWeakCheckBox.
                                                isSelected(),
                                                this.authoParentCheckBox.
                                                isSelected(),
                                                this.authoChildCheckBox.
                                                isSelected(),
                                                this.authoPositiveCheckBox.
                                                isSelected(),
                                                this.authoNegativeCheckBox.
                                                isSelected());
      }
      catch (Exception exc) {
        JOptionPane.showMessageDialog(this, exc.getMessage(),
                                      "Erro lendo autorizaes",
                                      JOptionPane.ERROR_MESSAGE);
      }
    }
  }

  void authoTable_mouseClicked(MouseEvent e) throws Exception {
    if ( (e.getClickCount() > 1) &&
        ( ( (e.getModifiers() & MouseEvent.BUTTON1_MASK) ==
           MouseEvent.BUTTON1_MASK))) {
      this.openAutorizationDialog();
    }
    else if ( (e.getClickCount() >= 1) &&
             ( ( (e.getModifiers() & MouseEvent.BUTTON3_MASK) ==
                MouseEvent.BUTTON3_MASK)) &&
             (this.authoTable.getSelectedRow() >= 0)) {
      this.resFilterComboBoxModel.setSelectedResourceName( (String)this.
          authoTable.getModel().getValueAt(this.authoTable.getSelectedRow(), 1));
      this.refreshAuthorizationsRoleTable();
    }
  }

  void authoNewButton_actionPerformed(ActionEvent e) {
    if (GlobalDefinitions.sa != null) {
      if (GlobalDefinitions.sa.AccessAllowed("CriarPrivilegios;Grupos;MACA",
                                             "Execuo")) {
        try {
          Group res = null;
          if (this.authoTable.getSelectedRowCount() > 0) {
            res = this.roleTableModel.getAutorization(this.authoTable.
                getSelectedRow()).getResource();
          }
          else {
            res = new Group(GlobalDefinitions.ctx,
                            System.getProperty("maca_ca.ldap.resourcesRDN") +
                            "," +
                            System.getProperty("maca_ca.ldap.rootDN"), "");
          }
          Authorization autho = autho = new Authorization(GlobalDefinitions.ctx,
              this.roleTableModel.getRole().getRoleAuthorizationRoot(),
              this.roleTableModel.getRole(), res);
          AuthorizationDialog authoDlg = new AuthorizationDialog(autho);
          authoDlg.setTitle("NOVA Autorizao");
          authoDlg.setVisible(true);
          if (authoDlg.wasSaved()) {
            this.refreshAuthorizationsRoleTable();
          }
        }
        catch (Exception exc) {
          JOptionPane.showMessageDialog(this, exc.getMessage(),
                                        "Erro para criar nova autorizao",
                                        JOptionPane.ERROR_MESSAGE);
        }
      }
      else {
        JOptionPane.showMessageDialog(this, "Voc no tem PERMISSO para\n" +
                                      "executar esta operao!",
                                      "Advertncia",
                                      JOptionPane.WARNING_MESSAGE);
      }
    }
  }

  void authoRemoveButton_actionPerformed(ActionEvent e) {
    if (GlobalDefinitions.sa != null) {
      if (GlobalDefinitions.sa.AccessAllowed("RemoverPrivilegios;Grupos;MACA",
                                             "Execuo")) {
        if (this.authoTable.getSelectedRow() >= 0) {
          if (JOptionPane.showConfirmDialog(this,
                                            ( (this.authoTable.
                                               getSelectedRowCount() > 1) ?
                                             "Deseja REMOVER as " +
                                             this.authoTable.
                                             getSelectedRowCount() +
                                             "\n autorizaes selecionadas?" :
              "Deseja REMOVER a autorizao selecionada?"),
                                            "Advertncia",
                                            JOptionPane.YES_NO_OPTION,
                                            JOptionPane.WARNING_MESSAGE) ==
              JOptionPane.YES_OPTION) {
            try {
              this.roleTableModel.removeRows(this.authoTable.getSelectedRows());
              this.refreshAuthorizationsRoleTable();
            }
            catch (Exception exc) {
              JOptionPane.showMessageDialog(this, exc.getMessage(),
                                            "Advertncia",
                                            JOptionPane.WARNING_MESSAGE);
            }
          }
        }
        else {
          JOptionPane.showMessageDialog(this,
                                        "Selecione uma ou mais autorizaes \n" +
                                        "da lista para remover.",
                                        "Informao",
                                        JOptionPane.INFORMATION_MESSAGE);
        }
      }
      else {
        JOptionPane.showMessageDialog(this, "Voc no tem PERMISSO para\n" +
                                      "executar esta operao!",
                                      "Advertncia",
                                      JOptionPane.WARNING_MESSAGE);
      }
    }
  }

  void authoChangeButton_actionPerformed(ActionEvent e) {
    this.openAutorizationDialog();
  }

  void renameGroupButton_actionPerformed(ActionEvent e) {
    if ( (GlobalDefinitions.sa != null) &&
        (GlobalDefinitions.sa.AccessAllowed("AlterarNome;Grupos;MACA",
                                            "Execuo"))) {
      try {
        TreePath path = dirTree.getSelectionPath();
        if (path != null) {
          Group grp = (Group) path.getLastPathComponent();
          String newGroupName = JOptionPane.showInputDialog(this,
              "Entre com o novo NOME",
              "Alterar Nome do grupo",
              JOptionPane.QUESTION_MESSAGE);
          if (newGroupName != null) {
            if (grp.getGroupType().equalsIgnoreCase(System.getProperty(
                "maca_ca.roleName"))) {
              Role role = grp.getGroupAsRole();
              role.renameGroupName(newGroupName);
            }
            else {
              grp.renameGroupName(newGroupName);
            }
            this.associateSelectedGroupToDirTree(true);
          }
        }
        else {
          JOptionPane.showMessageDialog(this,
                                        "SELECIONE um grupo para renomear!",
                                        "Informao",
                                        JOptionPane.INFORMATION_MESSAGE);
        }
      }
      catch (NamingException exc) {
        JOptionPane.showMessageDialog(this, exc.getMessage(),
                                      "Erro renomeando o grupo",
                                      JOptionPane.ERROR_MESSAGE);
      }
    }
    else {
      JOptionPane.showMessageDialog(this, "Voc no tem PERMISSO para\n" +
                                    "executar esta operao!",
                                    "Advertncia",
                                    JOptionPane.WARNING_MESSAGE);
    }
  }

  void renameResourceButton_actionPerformed(ActionEvent e) {
    try {
      if ( (GlobalDefinitions.sa != null) &&
          (GlobalDefinitions.sa.AccessAllowed("AlterarNome;Recursos;MACA",
                                              "Execuo"))) {
        TreePath path = resTree.getSelectionPath();
        if (path != null) {
          Group grp = (Group) path.getLastPathComponent();
          String newResName = JOptionPane.showInputDialog(this,
              "Entre com o novo NOME",
              "Alterar Nome do Recurso",
              JOptionPane.QUESTION_MESSAGE);
          if (newResName != null) {
            grp.renameGroupName(newResName);
            this.fillResourcesTree(true);
          }
        }
        else {
          JOptionPane.showMessageDialog(this,
              "SELECIONE um recurso antes de renome-lo!",
                                        "Informao",
                                        JOptionPane.INFORMATION_MESSAGE);
        }
      }
      else {
        JOptionPane.showMessageDialog(this, "Voc no tem PERMISSO para\n" +
                                      "executar esta operao!",
                                      "Advertncia",
                                      JOptionPane.WARNING_MESSAGE);
      }
    }
    catch (NamingException exc) {
      JOptionPane.showMessageDialog(this, exc.getMessage(),
                                    "Erro na renomeao do recurso",
                                    JOptionPane.ERROR_MESSAGE);
    }
  }

  void resFilterComboBox_keyReleased(KeyEvent e) {
    if ( (e.getKeyCode() == KeyEvent.VK_ENTER) ||
        (e.getKeyCode() == KeyEvent.VK_BACK_SPACE)) {
      this.refreshAuthorizationsRoleTable();
      checkForConflictsCheckBox_actionPerformed(null);
    }
  }

  void setReturingFieldsButton_actionPerformed(ActionEvent e) {
    this.userRetFldDlg.show();
    userTextField.requestFocus();
  }

  void exportMembersButton_actionPerformed(ActionEvent e) {
    if (GlobalDefinitions.sa != null) {
      if (GlobalDefinitions.sa.AccessAllowed("ExportarConsulta;Usuarios;MACA",
                                             "Execuo")) {
        JFileChooser fchooser = new JFileChooser();
        try {
          if (fchooser.showSaveDialog(this) == JFileChooser.APPROVE_OPTION) {
            if (fchooser.getSelectedFile().exists()) {
              if (JOptionPane.showConfirmDialog(this,
                                                "Aquivo j existe.\n" +
                  "Deseja APAGAR este arquivo e criar um novo?",
                  "Advertncia",
                  JOptionPane.YES_NO_OPTION,
                  JOptionPane.WARNING_MESSAGE) == JOptionPane.YES_OPTION) {
                this.exportRoleMembers(fchooser.getSelectedFile().getPath());
              }
            }
            else {
              this.exportRoleMembers(fchooser.getSelectedFile().getPath());
            }
          }
        }
        catch (Exception exc) {
          JOptionPane.showMessageDialog(this, exc.getMessage(),
              "Erro na exportando membros do papel selecinado.",
              JOptionPane.ERROR_MESSAGE);
        }
      }
      else {
        JOptionPane.showMessageDialog(this, "Voc no tem PERMISSO para\n" +
                                      "executar esta operao!",
                                      "Advertncia",
                                      JOptionPane.WARNING_MESSAGE);
      }
    }
  }

  void authoParentCheckBox_actionPerformed(ActionEvent e) {
    this.refreshAuthorizationsRoleTable();
  }

  void authoChildCheckBox_actionPerformed(ActionEvent e) {
    this.refreshAuthorizationsRoleTable();
  }

  void activatedAuthoFilterCheckBox_actionPerformed(ActionEvent e) {
    this.refreshAuthorizationsRoleTable();
  }

  void resFilterComboBox_popupMenuWillBecomeVisible(PopupMenuEvent e) {
    authoFilterActivated = this.activatedAuthoFilterCheckBox.isSelected();
    this.activatedAuthoFilterCheckBox.setSelected(false);
  }

  void resFilterComboBox_popupMenuWillBecomeInvisible(PopupMenuEvent e) {
    this.activatedAuthoFilterCheckBox.setSelected(authoFilterActivated);
  }

  void checkForConflictsCheckBox_actionPerformed(ActionEvent e) {
    TreePath path = dirTree.getSelectionPath();
    if (path != null) {
      Group grp = (Group) path.getLastPathComponent();
      this.updateRoleConflictPane(grp);
    }
  }

  void roleConflictPanel_focusGained(FocusEvent e) {
    TreePath path = dirTree.getSelectionPath();
    if (path != null) {
      Group grp = (Group) path.getLastPathComponent();
      this.updateRoleConflictPane(grp);
    }
  }
}

class JTreeGroup extends JTree {

}

class MACA_TableSorter extends TableSorter {

    public MACA_TableSorter() {
        super();
    }

    public MACA_TableSorter(TableModel model) {
        super(model);
    }

    public boolean isCellEditable(int row, int column) {
        return false;
    }

    public int compareRowsByColumn(int row1, int row2, int column) {
    try {
        Class type = model.getColumnClass(column);
        TableModel data = model;

        // Check for nulls.

        Object o1 = data.getValueAt(row1, column);
        Object o2 = data.getValueAt(row2, column);

        // If both values are null, return 0.
        if (o1 == null && o2 == null) {
            return 0;
        } else if (o1 == null) { // Define null less than everything.
            return -1;
        } else if (o2 == null) {
            return 1;
        }

        /*
         * We copy all returned values from the getValue call in case
         * an optimised model is reusing one object to return many
         * values.  The Number subclasses in the JDK are immutable and
         * so will not be used in this way but other subclasses of
         * Number might want to do this to save space and avoid
         * unnecessary heap allocation.
         */

        if (type.getSuperclass() == java.lang.Number.class) {
            Number n1 = (Number)data.getValueAt(row1, column);
            double d1 = n1.doubleValue();
            Number n2 = (Number)data.getValueAt(row2, column);
            double d2 = n2.doubleValue();

            if (d1 < d2) {
                return -1;
            } else if (d1 > d2) {
                return 1;
            } else {
                return 0;
            }
        } else if (type == java.util.Date.class) {
            java.util.Date d1 = (java.util.Date)data.getValueAt(row1, column);
            long n1 = d1.getTime();
            java.util.Date d2 = (java.util.Date)data.getValueAt(row2, column);
            long n2 = d2.getTime();

            if (n1 < n2) {
                return -1;
            } else if (n1 > n2) {
                return 1;
            } else {
                return 0;
            }
        } else if (type == String.class) {
            String s1 = (String)data.getValueAt(row1, column);
            String s2    = (String)data.getValueAt(row2, column);
            int result = s1.compareToIgnoreCase(s2);

            if (result < 0) {
                return -1;
            } else if (result > 0) {
                return 1;
            } else {
                return 0;
            }
        } else if (type == Boolean.class) {
            Boolean bool1 = (Boolean)data.getValueAt(row1, column);
            boolean b1 = bool1.booleanValue();
            Boolean bool2 = (Boolean)data.getValueAt(row2, column);
            boolean b2 = bool2.booleanValue();

            if (b1 == b2) {
                return 0;
            } else if (b1) { // Define false < true
                return 1;
            } else {
                return -1;
            }
        } else {
            Object v1 = data.getValueAt(row1, column);
            String s1 = v1.toString();
            Object v2 = data.getValueAt(row2, column);
            String s2 = v2.toString();
            int result = s1.compareToIgnoreCase(s2);

            if (result < 0) {
                return -1;
            } else if (result > 0) {
                return 1;
            } else {
        	return 0;
            }
        }
      }
      catch (java.lang.ArrayIndexOutOfBoundsException exc) {
        return 0;
      }
    }
}