package maca_ad;

/**
 * <p>Title: MACA_CA</p>
 * <p>Description: Middleware de Autenticao e Controle de Acesso</p>
 * <p>Copyright: Copyright (c) 2000-2004</p>
 * <p>Company: Instituto do Corao - FM.USP</p>
 * @author Gustavo Motta
 * @version 3.2.1
 */

import maca_ca.*;
import java.awt.*;
import java.util.*;
import java.applet.*;
import javax.swing.*;
import javax.naming.*;
import java.awt.event.*;
import javax.swing.tree.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.naming.directory.*;
import com.borland.jbcl.layout.*;

public class ResourceApplet extends JApplet {
  //Variveis de instncia definidas manualmente
  private Group group;
  private Hashtable textFields        = null;
  private Hashtable accessModesFields = null;
  private java.awt.Window container = null;


  //Variveis de instncia definidas automaticamnte
  boolean isStandalone = false;
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel bottomPanel = new JPanel();
  JPanel centerPanel = new JPanel();
  JPanel topPanel = new JPanel();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  JPanel resTypePanel = new JPanel();
  JRadioButton archiveRadioButton = new JRadioButton();
  JRadioButton tableRadioButton = new JRadioButton();
  JRadioButton objectRadioButton = new JRadioButton();
  JRadioButton methodRadioButton = new JRadioButton();
  JRadioButton applicationRadioButton = new JRadioButton();
  VerticalFlowLayout verticalFlowLayout1 = new VerticalFlowLayout();
  JPanel accessModePanel = new JPanel();
  Border border1;
  TitledBorder titledBorder1;
  Border border2;
  TitledBorder titledBorder2;
  JScrollPane attrScrollPane = new JScrollPane();
  JPanel attrPanel = new JPanel();
  Border border3;
  Border border4;
  TitledBorder titledBorder3;
  VerticalFlowLayout verticalFlowLayout2 = new VerticalFlowLayout();
  GridBagLayout gridBagLayout2 = new GridBagLayout();
  JLabel cnLabel = new JLabel();
  JTextField cnTextField = new JTextField();
  JLabel initialsLabel = new JLabel();
  JTextField initialsTextField = new JTextField();
  JLabel lLabel = new JLabel();
  JTextField lTextField = new JTextField();
  JLabel descriptionLabel = new JLabel();
  JTextField descriptionTextField = new JTextField();
  ButtonGroup btg = new ButtonGroup();
  JButton saveButton = new JButton();
  Border border5;
  JLabel statusLabel = new JLabel();
  BorderLayout borderLayout2 = new BorderLayout();
  JButton closeButton = new JButton();
  JRadioButton attributeRadioButton = new JRadioButton();

  //Mtodos privados definidos manualmente
  private void textFiledsSetup() {
    textFields = new Hashtable();

    textFields.put("cn",cnTextField);
    textFields.put("initials",initialsTextField);
    textFields.put("description",descriptionTextField);
    textFields.put("l",lTextField);
  }

  private void accessModesFieldsSetup() {
    accessModesFields = new Hashtable();
    Hashtable checkBoxFields = new Hashtable();
    JCheckBox appCheckBox = new JCheckBox("Execuo");
    checkBoxFields.put(appCheckBox.getText(),appCheckBox);
    accessModesFields.put("Aplicao", checkBoxFields);

    checkBoxFields = new Hashtable();
    appCheckBox = new JCheckBox("Execuo");
    checkBoxFields.put(appCheckBox.getText(),appCheckBox);
    accessModesFields.put("Mtodo", checkBoxFields);

    checkBoxFields = new Hashtable();
    appCheckBox = new JCheckBox("Execuo");
    checkBoxFields.put(appCheckBox.getText(),appCheckBox);
    accessModesFields.put("Objeto", checkBoxFields);

    checkBoxFields = new Hashtable();
    appCheckBox = new JCheckBox("Consulta");
    checkBoxFields.put(appCheckBox.getText(),appCheckBox);
    appCheckBox = new JCheckBox("Incluso");
    checkBoxFields.put(appCheckBox.getText(),appCheckBox);
    appCheckBox = new JCheckBox("Excluso");
    checkBoxFields.put(appCheckBox.getText(),appCheckBox);
    appCheckBox = new JCheckBox("Alterao");
    checkBoxFields.put(appCheckBox.getText(),appCheckBox);
    accessModesFields.put("Tabela", checkBoxFields);

    checkBoxFields = new Hashtable();
    appCheckBox = new JCheckBox("Leitura");
    checkBoxFields.put(appCheckBox.getText(),appCheckBox);
    appCheckBox = new JCheckBox("Escrita");
    checkBoxFields.put(appCheckBox.getText(),appCheckBox);
    accessModesFields.put("Atributo", checkBoxFields);

    checkBoxFields = new Hashtable();
    appCheckBox = new JCheckBox("Leitura");
    checkBoxFields.put(appCheckBox.getText(),appCheckBox);
    appCheckBox = new JCheckBox("Escrita");
    checkBoxFields.put(appCheckBox.getText(),appCheckBox);
    appCheckBox = new JCheckBox("Execuo");
    checkBoxFields.put(appCheckBox.getText(),appCheckBox);
    accessModesFields.put("Arquivo", checkBoxFields);
  }

  private void loadFieldsFromAttributes() throws NamingException {
    this.clearTextFields();
    Attributes grpAttrs  = group.getGroupAtributes();
    Enumeration keysEnum = textFields.keys();
    while (keysEnum.hasMoreElements()) {
      String key = (String) keysEnum.nextElement();
      Attribute grpAttr = grpAttrs.get(key);
      if (grpAttr != null) {
        JTextField tf = (JTextField) textFields.get(key);
        tf.setText((String) grpAttr.get());
      }
    }
    this.selectResourceType();
    this.selectAccessMode();
  }

  private void loadAttributesFromFields() throws NamingException {
    Attributes grpAttrs  = group.getGroupAtributes();
    Enumeration keysEnum = textFields.keys();
    while (keysEnum.hasMoreElements()) {
      String key = (String) keysEnum.nextElement();
      JTextField tf = (JTextField) textFields.get(key);
      Attribute grpAttr = grpAttrs.get(key);
      if (grpAttr != null) {
        try {
          grpAttr.set(0, tf.getText());
        }
        catch (IllegalStateException exc) {
          // valor armazenado j est presente e os valores do atributo no so ordenados,
          // logo, o valor no  alterado
        }
      }
      else {
        grpAttrs.put(key,tf.getText());
      }
    }
    this.saveResourceTypeAndAcessModes();
  }

  private void selectResourceType() throws NamingException {
    Attributes grpAttrs  = group.getGroupAtributes();
    Attribute grpAttr = grpAttrs.get("incorresourcetype");
    if (grpAttr != null) {
     String resType = (String) grpAttr.get();
     if (resType.equalsIgnoreCase("Aplicao")) {
       applicationRadioButton.setSelected(true);
       this.updateAccessModesButtons(applicationRadioButton);
     }
     else if (resType.equalsIgnoreCase("Mtodo")) {
       methodRadioButton.setSelected(true);
       this.updateAccessModesButtons(methodRadioButton);
     }
     else if (resType.equalsIgnoreCase("Objeto")) {
       objectRadioButton.setSelected(true);
       this.updateAccessModesButtons(objectRadioButton);
     }
     else if (resType.equalsIgnoreCase("Tabela")) {
       tableRadioButton.setSelected(true);
       this.updateAccessModesButtons(tableRadioButton);
     }
     else if (resType.equalsIgnoreCase("Atributo")) {
       attributeRadioButton.setSelected(true);
       this.updateAccessModesButtons(attributeRadioButton);
     }
     else if (resType.equalsIgnoreCase("Arquivo")) {
       archiveRadioButton.setSelected(true);
       this.updateAccessModesButtons(archiveRadioButton);
     }
     else {
       applicationRadioButton.setSelected(false);
       methodRadioButton.setSelected(false);
       objectRadioButton.setSelected(false);
       tableRadioButton.setSelected(false);
       archiveRadioButton.setSelected(false);
       this.updateAccessModesButtons(null);
     }
    }
  }

  private void selectAccessMode() throws NamingException {
    Attributes grpAttrs  = group.getGroupAtributes();
    Attribute   grpAttr  = grpAttrs.get("incorresourcetype");
    if (grpAttr != null) {
      String resType = (String) grpAttr.get();
      Hashtable checkBoxFields = (Hashtable) accessModesFields.get(resType);
      if (checkBoxFields != null) {
        grpAttr = grpAttrs.get("incorresourceaccessmode");
        if (grpAttr != null) {
          Enumeration acModeEnum = (Enumeration) grpAttr.getAll();
          while (acModeEnum.hasMoreElements()) {
            String attrVal = (String) acModeEnum.nextElement();
            JCheckBox cb = (JCheckBox) checkBoxFields.get(attrVal);
            if (cb != null) {
              cb.setSelected(true);
            }
          }
        }
      }
    }
  }

  private void updateAccessModesButtons(JRadioButton rb) {
    accessModePanel.removeAll();
    if (rb != null) {
      Hashtable checkBoxFields = (Hashtable) accessModesFields.get(rb.getText());
      if (checkBoxFields != null) {
        Enumeration keysEnum = checkBoxFields.keys();
        while (keysEnum.hasMoreElements()) {
          String key = (String) keysEnum.nextElement();
          JCheckBox cb = (JCheckBox) checkBoxFields.get(key);
          accessModePanel.add(cb, null);
        }
        accessModePanel.updateUI();
      }
    }
  }

  private void saveResourceTypeAndAcessModes() throws NamingException {
    String   selResType = this.getSelectedResourceType();
    Attributes resAttrs = group.getGroupAtributes();
    if (!selResType.equalsIgnoreCase("")) {
      resAttrs.put("incorresourcetype", selResType);
      Enumeration acsModesStrEnum = this.getSelectedAccessModes();
      if (acsModesStrEnum.hasMoreElements()) {
        resAttrs.put("incorresourceaccessmode", acsModesStrEnum.nextElement());
        Attribute  acsModeAttr = resAttrs.get("incorresourceaccessmode");
        while (acsModesStrEnum.hasMoreElements()) {
          String acsModeStr = (String) acsModesStrEnum.nextElement();
          acsModeAttr.add(acsModeStr);
        }
      }
      else {
        resAttrs.put("incorresourceaccessmode", "");
      }
    }
    else {
      resAttrs.put("incorresourcetype", "");
      resAttrs.put("incorresourceaccessmode", "");
    }
  }

  private String getSelectedResourceType() {
    if (applicationRadioButton.isSelected()) {
      return applicationRadioButton.getText();
    }
    if (attributeRadioButton.isSelected()) {
      return attributeRadioButton.getText();
    }
    else if (methodRadioButton.isSelected()) {
      return methodRadioButton.getText();
    }
    else if (objectRadioButton.isSelected()) {
      return objectRadioButton.getText();
    }
    else if (tableRadioButton.isSelected()) {
      return tableRadioButton.getText();
    }
    else if (archiveRadioButton.isSelected()) {
      return archiveRadioButton.getText();
    }
    else {
      return "";
    }
  }

  private Enumeration getSelectedAccessModes() {
    Vector acsModesStr = new Vector();
    String  selResType = this.getSelectedResourceType();
    Hashtable acsModes = (Hashtable) accessModesFields.get(selResType);
    if (acsModes != null) {
      if (acsModes.size() > 0) {
        Enumeration   cbEnum = acsModes.elements();
        while (cbEnum.hasMoreElements()) {
          JCheckBox cb = (JCheckBox) cbEnum.nextElement();
          if (cb.isSelected()) {
            acsModesStr.add(cb.getText());
          }
        }
      }
    }
    ObjectEnumeration enumStr = new ObjectEnumeration(acsModesStr);
    return enumStr;
  }

  private void applyChangesToGroup() throws NamingException {
    loadAttributesFromFields();
    group.saveGroupAtributes();
  }

  public void setGroup(Group grp) throws NamingException {
    group = grp;
    this.loadFieldsFromAttributes();
    this.statusLabel.setText("Status:");
    this.initialsTextField.requestFocus();
  }

  private void clearTextFields() {
    Enumeration keysEnum = textFields.keys();
    while (keysEnum.hasMoreElements()) {
      String key = (String) keysEnum.nextElement();
      JTextField txtFld = (JTextField) textFields.get(key);
      txtFld.setText("");
    }
  }

  //Get a parameter value
  public String getParameter(String key, String def) {
    return isStandalone ? System.getProperty(key, def) :
      (getParameter(key) != null ? getParameter(key) : def);
  }

  //Construct the applet
  public ResourceApplet(java.awt.Window frame, String groupName) throws NamingException {
    container = frame;
    group = new Group(GlobalDefinitions.ctx,
                      System.getProperty("maca_ca.ldap.resourcesRDN")+","+
                      System.getProperty("maca_ca.ldap.rootDN"),"cn="+groupName, true);
    this.textFiledsSetup();
    this.accessModesFieldsSetup();
  }

  public ResourceApplet(java.awt.Window frame, Group grp) {
    container = frame;
    group = grp;
    this.textFiledsSetup();
    this.accessModesFieldsSetup();
  }

  //Initialize the applet
  public void init() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception {
    GlobalDefinitions.isUsed = true;
    border1 = BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142));
    titledBorder1 = new TitledBorder(BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142)),"Formas de acesso");
    border2 = BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142));
    titledBorder2 = new TitledBorder(border2,"Tipo de recurso");
    border4 = BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142));
    titledBorder3 = new TitledBorder(border4,"Atributos");
    border5 = BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142));
    this.setSize(new Dimension(552, 405));
    this.getContentPane().setLayout(borderLayout1);
    topPanel.setLayout(gridBagLayout1);
    archiveRadioButton.setMnemonic('Q');
    archiveRadioButton.setText("Arquivo");
    archiveRadioButton.addChangeListener(new javax.swing.event.ChangeListener() {

      public void stateChanged(ChangeEvent e) {
        radioButton_stateChanged(e);
      }
    });
    tableRadioButton.setMnemonic('T');
    tableRadioButton.setText("Tabela");
    tableRadioButton.addChangeListener(new javax.swing.event.ChangeListener() {

      public void stateChanged(ChangeEvent e) {
        radioButton_stateChanged(e);
      }
    });
    objectRadioButton.setMnemonic('O');
    objectRadioButton.setText("Objeto");
    objectRadioButton.addChangeListener(new javax.swing.event.ChangeListener() {

      public void stateChanged(ChangeEvent e) {
        radioButton_stateChanged(e);
      }
    });
    methodRadioButton.setMnemonic('M');
    methodRadioButton.setText("Mtodo");
    methodRadioButton.addChangeListener(new javax.swing.event.ChangeListener() {

      public void stateChanged(ChangeEvent e) {
        radioButton_stateChanged(e);
      }
    });
    applicationRadioButton.setMnemonic('A');
    applicationRadioButton.setText("Aplicao");
    applicationRadioButton.addChangeListener(new javax.swing.event.ChangeListener() {

      public void stateChanged(ChangeEvent e) {
        radioButton_stateChanged(e);
      }
    });
    resTypePanel.setLayout(verticalFlowLayout1);
    accessModePanel.setLayout(verticalFlowLayout2);
    accessModePanel.setBorder(titledBorder1);
    resTypePanel.setBorder(titledBorder2);
    attrScrollPane.setBorder(titledBorder3);
    attrScrollPane.setPreferredSize(new Dimension(100, 100));
    attrPanel.setLayout(gridBagLayout2);
    cnLabel.setText("Nome:");
    initialsLabel.setText("Sigla:");
    lLabel.setText("Localizao:");
    descriptionLabel.setText("Descrio:");
    saveButton.setToolTipText("Grava o recurso");
    saveButton.setMnemonic('G');
    saveButton.setText("Gravar");
    saveButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        saveButton_actionPerformed(e);
      }
    });
    cnTextField.setEditable(false);
    initialsTextField.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        transferFocusOnEnter(e);
      }
    });
    lTextField.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        transferFocusOnEnter(e);
      }
    });
    descriptionTextField.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        transferFocusOnEnter(e);
      }
    });
    centerPanel.setBorder(border5);
    statusLabel.setText("Status:");
    bottomPanel.setLayout(borderLayout2);
    closeButton.setToolTipText("Fechar a janela");
    closeButton.setMnemonic('F');
    closeButton.setText("Fechar");
    closeButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        closeButton_actionPerformed(e);
      }
    });
    attributeRadioButton.addChangeListener(new javax.swing.event.ChangeListener() {

      public void stateChanged(ChangeEvent e) {
        radioButton_stateChanged(e);
      }
    });
    attributeRadioButton.setText("Atributo");
    attributeRadioButton.setMnemonic('R');
    this.getContentPane().add(bottomPanel, BorderLayout.SOUTH);
    bottomPanel.add(statusLabel, BorderLayout.CENTER);
    this.getContentPane().add(centerPanel, BorderLayout.CENTER);
    centerPanel.add(saveButton, null);
    centerPanel.add(closeButton, null);
    this.getContentPane().add(topPanel, BorderLayout.NORTH);
    topPanel.add(accessModePanel, new GridBagConstraints(1, 1, 1, 2, 1.0, 1.0
            ,GridBagConstraints.SOUTHEAST, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 112, 0));
    topPanel.add(attrScrollPane, new GridBagConstraints(0, 0, 2, 1, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 10, 1), 178, 23));
    topPanel.add(resTypePanel, new GridBagConstraints(0, 1, 1, 1, 1.0, 1.0
            ,GridBagConstraints.SOUTHWEST, GridBagConstraints.BOTH, new Insets(0, -1, 0, 8), 0, 0));
    resTypePanel.add(applicationRadioButton, null);
    resTypePanel.add(tableRadioButton, null);
    resTypePanel.add(attributeRadioButton, null);
    resTypePanel.add(archiveRadioButton, null);
    resTypePanel.add(objectRadioButton, null);
    resTypePanel.add(methodRadioButton, null);
    btg.add(archiveRadioButton);
    btg.add(tableRadioButton);
    btg.add(objectRadioButton);
    btg.add(methodRadioButton);
    btg.add(applicationRadioButton);
    btg.add(attributeRadioButton);
    attrScrollPane.getViewport().add(attrPanel, null);
    attrPanel.add(cnTextField, new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 2, 2, 2), 0, 0));
    attrPanel.add(cnLabel, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 2, 2, 2), 0, 0));
    attrPanel.add(initialsLabel, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 2, 2, 2), 0, 0));
    attrPanel.add(initialsTextField, new GridBagConstraints(1, 1, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 2, 2, 2), 0, 0));
    attrPanel.add(lLabel, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 2, 2, 2), 0, 0));
    attrPanel.add(lTextField, new GridBagConstraints(1, 2, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 2, 2, 2), 0, 0));
    attrPanel.add(descriptionLabel, new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 2, 2, 2), 0, 0));
    attrPanel.add(descriptionTextField, new GridBagConstraints(1, 3, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 2, 2, 2), 0, 0));

  }

  //Start the applet
  public void start() {
    try {
      this.loadFieldsFromAttributes();
      if (this.group.isNew()) {
        this.closeButton.setVisible(true);
      }
      else {
        this.closeButton.setVisible(false);
      }
    }
    catch (NamingException exc) {
      System.out.println(exc);
    }
  }

  //Stop the applet
  public void stop() {
  }

  //Destroy the applet
  public void destroy() {
  }

  //Get Applet information
  public String getAppletInfo() {
    return "Applet Information";
  }

  //Get parameter info
  public String[][] getParameterInfo() {
    return null;
  }

  void radioButton_stateChanged(ChangeEvent e) {
     this.updateAccessModesButtons((JRadioButton) e.getSource());
     GlobalDefinitions.isUsed = true;
   }

  void saveButton_actionPerformed(ActionEvent e) {
    try {
      if ((GlobalDefinitions.sa != null) &&
          (GlobalDefinitions.sa.AccessAllowed("GravarRecurso;Recursos;MACA", "Execuo"))) {
        this.applyChangesToGroup();
        statusLabel.setText("Status: recurso gravado com sucesso!");
      }
      else {
        JOptionPane.showMessageDialog(this, "Voc no tem PERMISSO para\n"+
                                            "executar esta operao!",
                                      "Advertncia",
                                      JOptionPane.WARNING_MESSAGE);
      }
    }
    catch (NamingException exc) {
       JOptionPane.showMessageDialog(this, exc.getMessage(),
                                     "Erro na gravao do recurso",
                                     JOptionPane.ERROR_MESSAGE);
    }
  }

  void transferFocusOnEnter(KeyEvent e) {
     if (e.getKeyCode() == KeyEvent.VK_ENTER) {
       e.getComponent().transferFocus();
       GlobalDefinitions.isUsed = true;
     }
  }

  void this_mouseMoved(MouseEvent e) {
  }

  void closeButton_actionPerformed(ActionEvent e) {
    if (container != null) {
      container.dispatchEvent(new WindowEvent(container, WindowEvent.WINDOW_CLOSING));
    }
  }
  void attributeRadioButton_stateChanged(ChangeEvent e) {

  }

}