package maca_ad;

/**
 * <p>Title: MACA_CA</p>
 * <p>Description: Middleware de Autenticao e Controle de Acesso</p>
 * <p>Copyright: Copyright (c) 2000-2004</p>
 * <p>Company: Instituto do Corao - FM.USP</p>
 * @author Gustavo Motta
 * @version 3.2.1
 */

import maca_ca.*;
import java.io.*;
import java.awt.*;
import java.util.*;
import java.beans.*;
import java.applet.*;
import javax.swing.*;
import javax.naming.*;
import java.util.zip.*;
import java.awt.event.*;
import javax.swing.tree.*;
import javax.swing.event.*;
import javax.swing.border.*;
import com.borland.dbswing.*;
import javax.naming.directory.*;
import com.borland.jbcl.layout.*;

public class UserApplet extends JApplet {
  private static final long oneMegaByte = 1024*1024;
  //Variveis de instncia definidas manualmente
  private User user;
  private Hashtable textFields = new Hashtable();
  private Group roleGroup;
  private Group orgGroup;
  private JFrame containerFrame = null;
  private boolean inputChanged = false;

  public static Hashtable LDAP_LABELS_MAP = ldapLabelsMapSetup();

  //Variveis de instncia definidas automaticamente
  boolean isStandalone = false;
  JTabbedPane userTabbedPane = new JTabbedPane();
  JScrollPane idScrollPane = new JScrollPane();
  JPanel idPanel = new JPanel();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  JLabel uidLabel = new JLabel();
  JTextField uidTextField = new JTextField();
  JLabel givenNameLabel = new JLabel();
  JTextField givenNameTextField = new JTextField();
  JLabel cnLabel = new JLabel();
  JTextField cnTextField = new JTextField();
  JLabel snLabel = new JLabel();
  JTextField snTextField = new JTextField();
  JLabel incorSexLabel = new JLabel();
  JTextField incorSexTextField = new JTextField();
  JLabel telephonenumberLabel = new JLabel();
  JTextField telephonenumberTextField = new JTextField();
  JLabel pagerLabel = new JLabel();
  JTextField pagerTextField = new JTextField();
  JLabel mailLabel = new JLabel();
  JTextField mailTextField = new JTextField();
  JLabel labeleduriLabel = new JLabel();
  JTextField labeleduriTextField = new JTextField();
  JPanel bottomPanel = new JPanel();
  JPanel topPanel = new JPanel();
  JButton saveButton = new JButton();
  JScrollPane funcDataScrollPane = new JScrollPane();
  JPanel funcDataPanel = new JPanel();
  GridBagLayout gridBagLayout2 = new GridBagLayout();
  JLabel employeeNumberLabel = new JLabel();
  JTextField employeenumberTextField = new JTextField();
  JLabel ouLabel = new JLabel();
  JTextField ouTextField = new JTextField();
  JLabel employeeTypeLabel = new JLabel();
  JTextField employeeTypeTextField = new JTextField();
  JLabel roomNumberLabel = new JLabel();
  JTextField roomnumberTextField = new JTextField();
  JLabel titleLabel = new JLabel();
  JTextField titleTextField = new JTextField();
  JLabel descriptionLabel = new JLabel();
  JTextField descriptionTextField = new JTextField();
  JScrollPane addressScrollPane = new JScrollPane();
  JPanel addressPanel = new JPanel();
  GridBagLayout gridBagLayout3 = new GridBagLayout();
  JLabel postaladdressLabel = new JLabel();
  JTextField postaladdressTextField = new JTextField();
  JLabel lLabel = new JLabel();
  JTextField lTextField = new JTextField();
  JLabel stLabel = new JLabel();
  JTextField stTextField = new JTextField();
  JLabel postalcodeLabel = new JLabel();
  JTextField postalcodeTextField = new JTextField();
  JLabel cLabel = new JLabel();
  JTextField cTextField = new JTextField();
  JLabel homephoneLabel = new JLabel();
  JTextField homephoneTextField = new JTextField();
  JLabel mobileLabel = new JLabel();
  JTextField mobileTextField = new JTextField();
  JLabel facsimiletelephonenumberLabel = new JLabel();
  JTextField facsimiletelephonenumberTextField = new JTextField();
  Border border1;
  TitledBorder titledBorder1;
  Border border2;
  TitledBorder titledBorder2;
  Border border3;
  TitledBorder titledBorder3;
  Border border4;
  TitledBorder titledBorder4;
  JScrollPane userRoleScrollPane = new JScrollPane();
  Border border5;
  TitledBorder titledBorder5;
  JPanel userRolesPanel = new JPanel();
  GridBagLayout gridBagLayout4 = new GridBagLayout();
  JTree rolesTree = new JTree();
  JButton insertUserRoleButton = new JButton();
  JList userRolesList = new JList();
  Border border6;
  TitledBorder titledBorder6;
  Border border7;
  TitledBorder titledBorder7;
  JButton removeUserRoleButton = new JButton();
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel statusPanel = new JPanel();
  Border border8;
  TitledBorder titledBorder8;
  JLabel statusLabel = new JLabel();
  BorderLayout borderLayout2 = new BorderLayout();
  JPanel buttonPanel = new JPanel();
  Border border9;
  Border border10;
  Border border11;
  TitledBorder titledBorder9;
  Border border12;
  TitledBorder titledBorder10;
  GridBagLayout gridBagLayout6 = new GridBagLayout();
  JScrollPane orgScrollPane = new JScrollPane();
  JButton insertUserOrgButton = new JButton();
  JButton removeUserOrgButton = new JButton();
  JTree orgsTree = new JTree();
  JPanel userOrgPanel = new JPanel();
  JScrollPane orgListScrollPane = new JScrollPane();
  JList userOrgList = new JList();
  GridBagLayout gridBagLayout5 = new GridBagLayout();
  JPanel securityPanel = new JPanel();
  JButton chgPasswordButton = new JButton();
  JButton newPasswordButton = new JButton();
  JTextField areaMeioDescTextField = new JTextField();
  JButton closeButton = new JButton();
  JLabel jLabel1 = new JLabel();
  JTextField creatorsnameTextField = new JTextField();
  JLabel jLabel2 = new JLabel();
  JTextField createtimestampTextField = new JTextField();
  JLabel jLabel3 = new JLabel();
  JTextField modifiersnameTextField = new JTextField();
  JLabel jLabel4 = new JLabel();
  JTextField modifytimestampTextField = new JTextField();
  JButton changeLoginButton = new JButton();
  JCheckBox emailInstCheckBox = new JCheckBox();
  JSlider mailQuotaSlider = new JSlider();
  JLabel mailQuotaLabel = new JLabel();

  //Mtodos privados definidos manualmente

  private static Hashtable ldapLabelsMapSetup() {
    Hashtable ht = new Hashtable();

    ht.put("Login", "uid");
    ht.put("Nome", "givenname");
    ht.put("Apelido", "cn");
    ht.put( "Sobrenome", "sn");
    ht.put("Sexo", "incorsex");
    ht.put("Telefone comercial", "telephonenumber");
    ht.put("Pager", "pager");
    ht.put("E-mail", "mail");
    ht.put("URL", "labeleduri");
    ht.put("Matrcula", "employeenumber");
    ht.put("Instituio", "ou");
    ht.put("rea meio", "employeetype");
    ht.put("Sala", "physicalDeliveryOfficeName");
    ht.put("Cargo", "title");
    ht.put("Descrio", "description");
    ht.put("Endereo", "postaladdress");
    ht.put("Cidade", "l");
    ht.put("Estado", "st");
    ht.put("CEP", "postalcode");
    ht.put("Pas", "c");
    ht.put("Telefone pessoal", "homephone");
    ht.put("Telefone celular", "mobile");
    ht.put("Fax", "facsimiletelephonenumber");
    return ht;
  }

  private void textFiledsSetup() {
    textFields = new Hashtable();

    textFields.put("uid",uidTextField);
    textFields.put("givenname",givenNameTextField);
    textFields.put("cn",cnTextField);
    textFields.put("sn",snTextField);
    textFields.put("incorsex",incorSexTextField);
    textFields.put("telephonenumber",telephonenumberTextField);
    textFields.put("pager",pagerTextField);
    textFields.put("mail",mailTextField);
    textFields.put("labeleduri",labeleduriTextField);
    textFields.put("employeenumber",employeenumberTextField);
    textFields.put("ou",ouTextField);
    textFields.put("employeetype",employeeTypeTextField);
    textFields.put("physicalDeliveryOfficeName",roomnumberTextField);
    textFields.put("title",titleTextField);
    textFields.put("description",descriptionTextField);
    textFields.put("postaladdress",postaladdressTextField);
    textFields.put("l",lTextField);
    textFields.put("st",stTextField);
    textFields.put("postalcode",postalcodeTextField);
    textFields.put("c",cTextField);
    textFields.put("homephone",homephoneTextField);
    textFields.put("mobile",mobileTextField);
    textFields.put("facsimiletelephonenumber",facsimiletelephonenumberTextField);
  }

  private void loadFieldsFromAttributes() throws NamingException {
    Attributes usrAttrs  = user.getUserAtributes();
    Enumeration keysEnum = textFields.keys();
    while (keysEnum.hasMoreElements()) {
      String key = (String) keysEnum.nextElement();
      Attribute usrAttr = usrAttrs.get(key);
      if ((usrAttr != null) && (usrAttr.get() != null)) {
        JTextField tf = (JTextField) textFields.get(key);
        tf.setText((String) usrAttr.get());
      }
    }
  }

  private void loadAttributesFromFields(Attributes usrAttrs) throws NamingException {
      Enumeration keysEnum = textFields.keys();
      while (keysEnum.hasMoreElements()) {
        String key = (String) keysEnum.nextElement();
        JTextField tf = (JTextField) textFields.get(key);
        Attribute usrAttr = usrAttrs.get(key);
        if (usrAttr != null) {
          try {
            usrAttr.set(0, tf.getText());
          }
          catch (IllegalStateException exc) {
            // valor armazenado j est presente e os valores do atributo no so ordenados,
            // logo, o valor no  alterado
          }
        }
        else {
          usrAttrs.put(key,tf.getText());
        }
      }
      this.loadPosixAccountData(usrAttrs);
  }

  private void applyChangesToUser() {
    try {
      Attributes usrAttrs = user.getUserAtributes();
      loadAttributesFromFields(usrAttrs);
      ByteArrayOutputStream buffer = new ByteArrayOutputStream(1024);
      ObjectOutputStream output = new ObjectOutputStream(new GZIPOutputStream(buffer));
      output.writeObject(usrAttrs);
      output.flush();
      output.close();
      String userAttrsStr = Conversion.byteArrayToBase64String(buffer.toByteArray());
      userAttrsStr = userAttrsStr.replace('\n', ' ');
      if (GlobalDefinitions.sa.AccessAllowed("GravarUsuario;Usuarios;MACA(\""+userAttrsStr+"\")", "execuo")) {
        user.setUserAttributes(usrAttrs);
        user.saveUserAtributes();
        statusLabel.setText("Status: gravao efetuada com sucesso!");
      }
      else {
        JOptionPane.showMessageDialog(this, "Voc no tem PERMISSO para\n"+
                                            "executar esta operao!",
                                      "Advertncia",
                                      JOptionPane.WARNING_MESSAGE);
      }
    }
    catch (Exception exc) {
      statusLabel.setText("Status: "+exc.getMessage());
    }
  }

  private void loadPosixAccountData(Attributes attrs) throws NamingException {
    if (this.emailInstCheckBox.isSelected()) {
      Attribute attr = attrs.get("employeenumber");
      attrs.put("uidnumber", attr.get());
      attr = attrs.get("employeetype");
      StringTokenizer areameioTk = new StringTokenizer((String) attr.get(), ".");
      String areameio = "";
      while (areameioTk.hasMoreTokens()) {
        areameio = areameio + areameioTk.nextToken();
      }
      attrs.put("gidnumber", areameio);
      attrs.put("homedirectory", "/home/"+this.user.getUserID());
      attrs.put("loginshell", "/bin/bash");
      long mailQuota = this.mailQuotaSlider.getValue() * oneMegaByte;
      attrs.put("mailquota", Long.toString(mailQuota));
    }
    else {
      attrs.put("uidnumber", "");
      attrs.put("gidnumber", "");
      attrs.put("homedirectory", "");
      attrs.put("loginshell", "");
      attrs.put("mailquota", "0");
    }
  }

  private void posixAccountSetup() throws NamingException {
    this.emailInstCheckBox.setSelected(false);
    Attributes attrs = this.user.getUserAtributes();
    Attribute oc = attrs.get("objectclass");
    if (oc != null) {
      NamingEnumeration enum = oc.getAll();
      boolean hasPosixAccount = false;
      boolean hasMailRecipient = false;
      while (enum.hasMoreElements()) {
        String element = (String) enum.nextElement();
        if (element.equalsIgnoreCase("posixaccount")) {
          hasPosixAccount = true;
        }
        else if (element.equalsIgnoreCase("mailrecipient")) {
          hasMailRecipient = true;
        }
      }
      if (!hasPosixAccount) {
        oc.add("posixaccount");
        attrs.put("uidnumber", "");
        attrs.put("gidnumber", "");
        attrs.put("homedirectory", "");
        attrs.put("loginshell", "");
      }
      else {
        Attribute attr = attrs.get("uidnumber");
        if ((attr != null) && !((String)attr.get()).equalsIgnoreCase("")) {
          this.emailInstCheckBox.setText("Web mail - "+this.user.getUserID()+"@"+"incor.usp.br");
          this.emailInstCheckBox.setSelected(true);
        }
      }
      this.mailQuotaSlider.setValue(5);
      if (!hasMailRecipient) {
        oc.add("mailrecipient");
        attrs.put("mailquota", "0");
      }
      else {
        Attribute attr = attrs.get("mailquota");
        if ((attr != null) && !((String)attr.get()).equalsIgnoreCase("")) {
          long mailQuota = Long.parseLong((String)attr.get()) / oneMegaByte;
          this.mailQuotaSlider.setValue((int)Math.min(Math.max(this.mailQuotaSlider.getMinimum(), mailQuota), this.mailQuotaSlider.getMaximum()));
        }
      }
    }
  }

  private void userRolesSetup() throws NamingException {
    userRoleScrollPane.getViewport().remove(rolesTree);
    rolesTree = new JTree(roleGroup, false);
    rolesTree.expandRow(rolesTree.getRowCount()-1);
    userRoleScrollPane.getViewport().add(rolesTree, null);
    userRolesList.setListData(user.getRolesNames());
  }

  private void userOrgsSetup() throws NamingException {
    orgScrollPane.getViewport().remove(orgsTree);
    orgsTree = new JTree(orgGroup, false);
    orgScrollPane.getViewport().add(orgsTree, null);
    userOrgList.setListData(user.getOrgNamesMembership());
  }

  //Get a parameter value
  public String getParameter(String key, String def) {
    return isStandalone ? System.getProperty(key, def) :
      (getParameter(key) != null ? getParameter(key) : def);
  }

  //Construct the applet
  public UserApplet(JFrame frame, String userID, String userName,
                    String matricula, String areaMeio, String cargo)  throws Exception {
    containerFrame = frame;

    user      = new User(GlobalDefinitions.ctx, System.getProperty("maca_ca.ldap.peopleRDN")+","+
                                                System.getProperty("maca_ca.ldap.rootDN"),
                                                "uid="+userID);
    roleGroup = new Group(GlobalDefinitions.ctx, System.getProperty("maca_ca.ldap.groupsRDN")+","+
                                                 System.getProperty("maca_ca.ldap.rootDN"),
                                                 System.getProperty("maca_ca.ldap.roleRDN"));
    orgGroup  = new Group(GlobalDefinitions.ctx, System.getProperty("maca_ca.ldap.groupsRDN")+","+
                                                 System.getProperty("maca_ca.ldap.rootDN"),
                                                 System.getProperty("maca_ca.ldap.orgChartRDN"));
    this.textFiledsSetup();
    this.loadFieldsFromAttributes();
    this.userRolesSetup();
    this.userOrgsSetup();
    if (user.isNewUser()) {
      frame.setTitle(frame.getTitle() + " - NOVO CADASTRO");
      givenNameTextField.setText(userName);
      employeenumberTextField.setText(matricula);
      employeeTypeTextField.setText(areaMeio);
      this.titleTextField.setText(cargo);
      this.insertUserOrgButton.setEnabled(false);
      this.insertUserRoleButton.setEnabled(false);
    }
    else {
      creatorsnameTextField.setText(user.getOperacionalAttribute("creatorsname"));
      String timestamp = user.getOperacionalAttribute("createtimestamp");
      String date      = timestamp.substring(6,8)+"/"+
                         timestamp.substring(4,6)+"/"+
                         timestamp.substring(0,4)+" - "+
                         timestamp.substring(8,10)+":"+
                         timestamp.substring(10,12)+":"+
                         timestamp.substring(12,14);
      createtimestampTextField.setText(date);
      modifiersnameTextField.setText(user.getOperacionalAttribute("modifiersname"));
      timestamp = user.getOperacionalAttribute("modifytimestamp");
      date      = timestamp.substring(6,8)+"/"+
                  timestamp.substring(4,6)+"/"+
                  timestamp.substring(0,4)+" - "+
                  timestamp.substring(8,10)+":"+
                  timestamp.substring(10,12)+":"+
                  timestamp.substring(12,14);
      modifytimestampTextField.setText(date);
    }
  }

  public UserApplet(JFrame frame, String userID) throws Exception {
    this(frame, userID, "", "", "", "");
  }

  //Initialize the applet
  public void init() {
    try {
      jbInit();
      this.posixAccountSetup();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception {
    border1 = BorderFactory.createEmptyBorder();
    titledBorder1 = new TitledBorder(new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(142, 142, 142)),"Papis do usurio");
    border2 = BorderFactory.createEtchedBorder(Color.white,new Color(142, 142, 142));
    titledBorder2 = new TitledBorder(border2,"Papis disponveis");
    border3 = new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(142, 142, 142));
    titledBorder3 = new TitledBorder(border3,"Papis disponveis");
    border4 = BorderFactory.createEmptyBorder();
    titledBorder4 = new TitledBorder(new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(142, 142, 142)),"Papis do usurio");
    border5 = new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(142, 142, 142));
    titledBorder5 = new TitledBorder(border5,"Papis do usurio");
    border6 = new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(178, 178, 178));
    titledBorder6 = new TitledBorder(border6,"Papis disponveis");
    border7 = new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(178, 178, 178));
    titledBorder7 = new TitledBorder(new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(178, 178, 178)),"Unidade de lotao");
    border8 = BorderFactory.createEmptyBorder();
    titledBorder8 = new TitledBorder(border8,"Status:");
    border9 = BorderFactory.createBevelBorder(BevelBorder.LOWERED,Color.white,Color.white,new Color(142, 142, 142),new Color(99, 99, 99));
    border10 = BorderFactory.createBevelBorder(BevelBorder.LOWERED,Color.white,Color.white,new Color(142, 142, 142),new Color(99, 99, 99));
    border11 = new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(178, 178, 178));
    titledBorder9 = new TitledBorder(border11,System.getProperty("maca_ca.orgChartName"));
    border12 = new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(178, 178, 178));
    titledBorder10 = new TitledBorder(border12,"Papis do usurio");
    this.setSize(new Dimension(597, 432));


    this.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {

      public void mouseMoved(MouseEvent e) {
        this_mouseMoved(e);
      }
    });
    userTabbedPane.setTabPlacement(JTabbedPane.RIGHT);
    userTabbedPane.setPreferredSize(new Dimension(505, 300));
    userTabbedPane.addChangeListener(new javax.swing.event.ChangeListener() {
      public void stateChanged(ChangeEvent e) {
        userTabbedPane_stateChanged(e);
      }
    });
    idPanel.setLayout(gridBagLayout1);
    uidLabel.setLabelFor(uidTextField);
    uidLabel.setText("Login:");
    givenNameLabel.setLabelFor(givenNameTextField);
    givenNameLabel.setText("Nome completo:");
    cnLabel.setLabelFor(cnTextField);
    cnLabel.setText("Prenome ou apelido: ");
    snLabel.setNextFocusableComponent(snTextField);
    snLabel.setText("Sobrenome:");
    incorSexLabel.setLabelFor(incorSexTextField);
    incorSexLabel.setText("Sexo:");
    telephonenumberLabel.setLabelFor(telephonenumberTextField);
    telephonenumberLabel.setText("Telefone comercial:");
    pagerLabel.setLabelFor(pagerTextField);
    pagerLabel.setText("Pager:");
    mailLabel.setLabelFor(mailTextField);
    mailLabel.setText("E-mail:");
    labeleduriLabel.setLabelFor(labeleduriTextField);
    labeleduriLabel.setText("URL:");
    saveButton.setMnemonic('G');
    saveButton.setText("Gravar");
    saveButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        saveButton_actionPerformed(e);
      }
    });
    pagerTextField.setToolTipText("");
    pagerTextField.addInputMethodListener(new java.awt.event.InputMethodListener() {

      public void caretPositionChanged(InputMethodEvent e) {
      }

      public void inputMethodTextChanged(InputMethodEvent e) {
        recordChanged(e);
      }
    });
    pagerTextField.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        transferFocusOnEnter(e);
      }
    });
    funcDataPanel.setLayout(gridBagLayout2);
    employeeNumberLabel.setLabelFor(employeenumberTextField);
    employeeNumberLabel.setText("Matrcula:");
    ouLabel.setLabelFor(ouTextField);
    ouLabel.setText("Instituio:");
    employeeTypeLabel.setLabelFor(employeeTypeTextField);
    employeeTypeLabel.setText("rea meio:");
    roomNumberLabel.setLabelFor(roomnumberTextField);
    roomNumberLabel.setText("Sala:");
    titleLabel.setLabelFor(titleTextField);
    titleLabel.setText("Cargo:");
    descriptionLabel.setLabelFor(descriptionTextField);
    descriptionLabel.setText("Observaes:");
    addressPanel.setLayout(gridBagLayout3);
    postaladdressLabel.setToolTipText("");
    postaladdressLabel.setLabelFor(postaladdressTextField);
    postaladdressLabel.setText("Logradouro:");
    lLabel.setToolTipText("");
    lLabel.setLabelFor(lTextField);
    lLabel.setText("Cidade:");
    stLabel.setLabelFor(stTextField);
    stLabel.setText("Estado:");
    postalcodeLabel.setLabelFor(postalcodeTextField);
    postalcodeLabel.setText("CEP:");
    cLabel.setLabelFor(cTextField);
    cLabel.setText("Pas:");
    homephoneLabel.setLabelFor(homephoneTextField);
    homephoneLabel.setText("Telefone residencial:");
    mobileLabel.setLabelFor(mobileTextField);
    mobileLabel.setText("Celular:");
    facsimiletelephonenumberLabel.setToolTipText("");
    facsimiletelephonenumberLabel.setLabelFor(facsimiletelephonenumberTextField);
    facsimiletelephonenumberLabel.setText("Fax:");
    userRolesPanel.setLayout(gridBagLayout4);
    insertUserRoleButton.setPreferredSize(new Dimension(26, 26));
    insertUserRoleButton.setToolTipText("");
    insertUserRoleButton.setHorizontalTextPosition(SwingConstants.CENTER);
    insertUserRoleButton.setText(">>");
    insertUserRoleButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        insertUserRoleButton_actionPerformed(e);
      }
    });
    userRolesList.setBorder(titledBorder10);
    userRolesList.setPreferredSize(new Dimension(100, 200));
    rolesTree.setAutoscrolls(true);
    rolesTree.setBorder(titledBorder6);
    rolesTree.setRootVisible(false);
    removeUserRoleButton.setToolTipText("");
    removeUserRoleButton.setText("<<");
    removeUserRoleButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        removeUserRoleButton_actionPerformed(e);
      }
    });
    bottomPanel.setLayout(borderLayout1);
    statusLabel.setBorder(border10);
    statusLabel.setText("Status:");
    statusPanel.setLayout(borderLayout2);
    uidTextField.setEditable(false);
    givenNameTextField.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        transferFocusOnEnter(e);
      }
    });
    cnTextField.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        transferFocusOnEnter(e);
      }
    });
    snTextField.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        transferFocusOnEnter(e);
      }
    });
    telephonenumberTextField.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        transferFocusOnEnter(e);
      }
    });
    mailTextField.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        transferFocusOnEnter(e);
      }
    });
    labeleduriTextField.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        labeleduriTextField_keyPressed(e);
      }
    });
    ouTextField.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        transferFocusOnEnter(e);
      }
    });
    roomnumberTextField.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        transferFocusOnEnter(e);
      }
    });
    titleTextField.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        transferFocusOnEnter(e);
      }
    });
    descriptionTextField.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        descriptionTextField_keyPressed(e);
      }
    });
    postaladdressTextField.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        transferFocusOnEnter(e);
      }
    });
    lTextField.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        transferFocusOnEnter(e);
      }
    });
    stTextField.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        transferFocusOnEnter(e);
      }
    });
    postalcodeTextField.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        transferFocusOnEnter(e);
      }
    });
    cTextField.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        transferFocusOnEnter(e);
      }
    });
    homephoneTextField.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        transferFocusOnEnter(e);
      }
    });
    mobileTextField.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        transferFocusOnEnter(e);
      }
    });
    facsimiletelephonenumberTextField.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        facsimiletelephonenumberTextField_keyPressed(e);
      }
    });
    cnTextField.addFocusListener(new java.awt.event.FocusAdapter() {

      public void focusGained(FocusEvent e) {
        cnTextField_focusGained(e);
      }

      public void focusLost(FocusEvent e) {
        cnTextField_focusLost(e);
      }
    });
    snTextField.addFocusListener(new java.awt.event.FocusAdapter() {

      public void focusGained(FocusEvent e) {
        snTextField_focusGained(e);
      }

      public void focusLost(FocusEvent e) {
        snTextField_focusLost(e);
      }
    });
    incorSexTextField.addFocusListener(new java.awt.event.FocusAdapter() {

      public void focusGained(FocusEvent e) {
        incorSexTextField_focusGained(e);
      }

      public void focusLost(FocusEvent e) {
        incorSexTextField_focusLost(e);
      }
    });
    incorSexTextField.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        transferFocusOnEnter(e);
      }

      public void keyTyped(KeyEvent e) {
        incorSexTextField_keyTyped(e);
      }
    });
    ouTextField.setToolTipText("");
    ouTextField.addInputMethodListener(new java.awt.event.InputMethodListener() {

      public void caretPositionChanged(InputMethodEvent e) {
      }

      public void inputMethodTextChanged(InputMethodEvent e) {
        recordChanged(e);
      }
    });
    insertUserOrgButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        insertUserOrgButton_actionPerformed(e);
      }
    });
    insertUserOrgButton.setText(">>");
    insertUserOrgButton.setHorizontalTextPosition(SwingConstants.CENTER);
    insertUserOrgButton.setToolTipText("");
    insertUserOrgButton.setPreferredSize(new Dimension(26, 26));
    removeUserOrgButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        removeUserOrgButton_actionPerformed(e);
      }
    });
    removeUserOrgButton.setText("<<");
    removeUserOrgButton.setToolTipText("");
    orgsTree.setRootVisible(false);
    orgsTree.setBorder(titledBorder9);
    orgsTree.setAutoscrolls(true);
    userOrgPanel.setLayout(gridBagLayout6);
    userOrgList.setPreferredSize(new Dimension(100, 200));
    userOrgList.setBorder(titledBorder7);
    securityPanel.setLayout(gridBagLayout5);
    chgPasswordButton.setMnemonic('A');
    chgPasswordButton.setText("Alterar Senha");
    chgPasswordButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        chgPasswordButton_actionPerformed(e);
      }
    });
    newPasswordButton.setMnemonic('N');
    newPasswordButton.setText("Nova Senha");
    newPasswordButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        newPasswordButton_actionPerformed(e);
      }
    });
    areaMeioDescTextField.setBackground(Color.lightGray);
    areaMeioDescTextField.setRequestFocusEnabled(false);
    areaMeioDescTextField.setEditable(false);
    closeButton.setMnemonic('F');
    closeButton.setText("Fechar");
    closeButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        closeButton_actionPerformed(e);
      }
    });
    givenNameTextField.addInputMethodListener(new java.awt.event.InputMethodListener() {

      public void caretPositionChanged(InputMethodEvent e) {
      }

      public void inputMethodTextChanged(InputMethodEvent e) {
        recordChanged(e);
      }
    });
    cnTextField.addInputMethodListener(new java.awt.event.InputMethodListener() {

      public void caretPositionChanged(InputMethodEvent e) {
      }

      public void inputMethodTextChanged(InputMethodEvent e) {
        recordChanged(e);
      }
    });
    snTextField.addInputMethodListener(new java.awt.event.InputMethodListener() {

      public void caretPositionChanged(InputMethodEvent e) {
      }

      public void inputMethodTextChanged(InputMethodEvent e) {
        recordChanged(e);
      }
    });
    telephonenumberTextField.addInputMethodListener(new java.awt.event.InputMethodListener() {

      public void caretPositionChanged(InputMethodEvent e) {
      }

      public void inputMethodTextChanged(InputMethodEvent e) {
        recordChanged(e);
      }
    });
    mailTextField.addInputMethodListener(new java.awt.event.InputMethodListener() {

      public void caretPositionChanged(InputMethodEvent e) {
      }

      public void inputMethodTextChanged(InputMethodEvent e) {
        recordChanged(e);
      }
    });
    labeleduriTextField.addInputMethodListener(new java.awt.event.InputMethodListener() {

      public void caretPositionChanged(InputMethodEvent e) {
      }

      public void inputMethodTextChanged(InputMethodEvent e) {
        recordChanged(e);
      }
    });
    employeenumberTextField.addInputMethodListener(new java.awt.event.InputMethodListener() {

      public void caretPositionChanged(InputMethodEvent e) {
      }

      public void inputMethodTextChanged(InputMethodEvent e) {
        recordChanged(e);
      }
    });
    employeeTypeTextField.addInputMethodListener(new java.awt.event.InputMethodListener() {

      public void caretPositionChanged(InputMethodEvent e) {
      }

      public void inputMethodTextChanged(InputMethodEvent e) {
        recordChanged(e);
      }
    });
    roomnumberTextField.addInputMethodListener(new java.awt.event.InputMethodListener() {

      public void caretPositionChanged(InputMethodEvent e) {
      }

      public void inputMethodTextChanged(InputMethodEvent e) {
        recordChanged(e);
      }
    });
    titleTextField.addInputMethodListener(new java.awt.event.InputMethodListener() {

      public void caretPositionChanged(InputMethodEvent e) {
      }

      public void inputMethodTextChanged(InputMethodEvent e) {
        recordChanged(e);
      }
    });
    descriptionTextField.addInputMethodListener(new java.awt.event.InputMethodListener() {

      public void caretPositionChanged(InputMethodEvent e) {
      }

      public void inputMethodTextChanged(InputMethodEvent e) {
        recordChanged(e);
      }
    });
    postaladdressTextField.addInputMethodListener(new java.awt.event.InputMethodListener() {

      public void caretPositionChanged(InputMethodEvent e) {
      }

      public void inputMethodTextChanged(InputMethodEvent e) {
        recordChanged(e);
      }
    });
    lTextField.addInputMethodListener(new java.awt.event.InputMethodListener() {

      public void caretPositionChanged(InputMethodEvent e) {
      }

      public void inputMethodTextChanged(InputMethodEvent e) {
        recordChanged(e);
      }
    });
    stTextField.addInputMethodListener(new java.awt.event.InputMethodListener() {

      public void caretPositionChanged(InputMethodEvent e) {
      }

      public void inputMethodTextChanged(InputMethodEvent e) {
        recordChanged(e);
      }
    });
    postalcodeTextField.addInputMethodListener(new java.awt.event.InputMethodListener() {

      public void caretPositionChanged(InputMethodEvent e) {
      }

      public void inputMethodTextChanged(InputMethodEvent e) {
        recordChanged(e);
      }
    });
    cTextField.addInputMethodListener(new java.awt.event.InputMethodListener() {

      public void caretPositionChanged(InputMethodEvent e) {
      }

      public void inputMethodTextChanged(InputMethodEvent e) {
        recordChanged(e);
      }
    });
    homephoneTextField.addInputMethodListener(new java.awt.event.InputMethodListener() {

      public void caretPositionChanged(InputMethodEvent e) {
      }

      public void inputMethodTextChanged(InputMethodEvent e) {
        recordChanged(e);
      }
    });
    mobileTextField.addInputMethodListener(new java.awt.event.InputMethodListener() {

      public void caretPositionChanged(InputMethodEvent e) {
      }

      public void inputMethodTextChanged(InputMethodEvent e) {
        recordChanged(e);
      }
    });
    facsimiletelephonenumberTextField.addInputMethodListener(new java.awt.event.InputMethodListener() {

      public void caretPositionChanged(InputMethodEvent e) {
      }

      public void inputMethodTextChanged(InputMethodEvent e) {
        recordChanged(e);
      }
    });
    employeenumberTextField.setToolTipText("Pressione F1 para consultar matricula pelo nome");
    employeenumberTextField.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        employeenumberTextField_keyPressed(e);
      }
    });
    employeeTypeTextField.addKeyListener(new java.awt.event.KeyAdapter() {

      public void keyPressed(KeyEvent e) {
        employeeTypeTextField_keyPressed(e);
      }
    });
    employeeTypeTextField.setToolTipText("Pressione F1 para pesquisar rea meio pela descrio");
    jLabel1.setText("Criador:");
    creatorsnameTextField.setEditable(false);
    jLabel2.setText("Data:");
    createtimestampTextField.setEditable(false);
    jLabel3.setText("ltimo modificador:");
    jLabel4.setText("Data:");
    modifytimestampTextField.setEditable(false);
    modifiersnameTextField.setEditable(false);
    givenNameTextField.addFocusListener(new java.awt.event.FocusAdapter() {

      public void focusLost(FocusEvent e) {
        givenNameTextField_focusLost(e);
      }
    });
    changeLoginButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        changeLoginButton_actionPerformed(e);
      }
    });
    changeLoginButton.setText("Alterar Login");
    changeLoginButton.setMnemonic('A');
    emailInstCheckBox.setText("Web mail");
    emailInstCheckBox.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        emailInstCheckBox_actionPerformed(e);
      }
    });
    mailQuotaLabel.setText("Limite do e-mail (Mb):");
    mailQuotaSlider.setMajorTickSpacing(10);
    mailQuotaSlider.setMaximum(50);
    mailQuotaSlider.setMinorTickSpacing(5);
    mailQuotaSlider.setPaintLabels(true);
    mailQuotaSlider.setPaintTicks(true);
    mailQuotaSlider.setToolTipText("MBytes");
    mailQuotaSlider.addChangeListener(new javax.swing.event.ChangeListener() {
      public void stateChanged(ChangeEvent e) {
        mailQuotaSlider_stateChanged(e);
      }
    });

    this.getContentPane().add(topPanel, BorderLayout.NORTH);
    this.getContentPane().add(bottomPanel, BorderLayout.SOUTH);

    bottomPanel.add(statusPanel, BorderLayout.SOUTH);
    statusPanel.add(statusLabel, BorderLayout.SOUTH);
    statusPanel.add(buttonPanel, BorderLayout.NORTH);
    buttonPanel.add(changeLoginButton, null);
    buttonPanel.add(saveButton, null);
    buttonPanel.add(closeButton, null);

    this.getContentPane().add(userTabbedPane, BorderLayout.CENTER);

    userTabbedPane.add(idScrollPane,  "Identificao");
    userTabbedPane.add(funcDataScrollPane, "Dados Funcionais");
    userTabbedPane.add(userRoleScrollPane, "Papis");
    userTabbedPane.add(addressScrollPane, "Endereo");
    userTabbedPane.add(userOrgPanel,   "Organograma");
    userTabbedPane.add(securityPanel, "Segurana");

    userOrgPanel.add(orgListScrollPane, new GridBagConstraints(2, 0, 1, 2, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
    userOrgPanel.add(orgScrollPane, new GridBagConstraints(0, 0, 1, 2, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
    userOrgPanel.add(insertUserOrgButton, new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(-40, 2, 0, 2), 0, 0));
    userOrgPanel.add(removeUserOrgButton, new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(40, 2, 0, 2), 0, 0));
    securityPanel.add(jLabel1, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(3, 3, 3, 3), 0, 0));
    securityPanel.add(creatorsnameTextField, new GridBagConstraints(1, 0, 4, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(3, 3, 3, 3), 0, 0));
    securityPanel.add(createtimestampTextField, new GridBagConstraints(2, 1, 3, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(3, 3, 3, 3), 0, 0));
    securityPanel.add(jLabel2, new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(3, 3, 3, 3), 0, 0));
    securityPanel.add(jLabel3, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(3, 3, 3, 3), 0, 0));
    securityPanel.add(modifiersnameTextField, new GridBagConstraints(1, 2, 4, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(3, 3, 3, 3), 0, 0));
    securityPanel.add(jLabel4, new GridBagConstraints(1, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(3, 3, 3, 3), 0, 0));
    securityPanel.add(chgPasswordButton, new GridBagConstraints(1, 4, 2, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(6, 0, 4, 0), 0, 0));
    securityPanel.add(newPasswordButton, new GridBagConstraints(3, 4, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(10, 0, 10, 0), 0, 0));
    securityPanel.add(modifytimestampTextField, new GridBagConstraints(2, 3, 2, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(3, 3, 3, 3), 0, 0));
    idScrollPane.getViewport().add(idPanel, null);
    orgScrollPane.getViewport().add(orgsTree, null);
    orgListScrollPane.getViewport().add(userOrgList, null);
    userRoleScrollPane.getViewport().add(userRolesPanel, null);
    userRolesPanel.add(rolesTree, new GridBagConstraints(0, 0, 1, 3, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 2, 0, 2), 0, 0));
    userRolesPanel.add(userRolesList, new GridBagConstraints(2, 0, 1, 2, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 2), 0, 0));
    userRolesPanel.add(insertUserRoleButton, new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(-40, 2, 0, 2), 22, 0));
    userRolesPanel.add(removeUserRoleButton, new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(40, 2, 0, 2), 0, 0));
    addressScrollPane.getViewport().add(addressPanel, null);
    addressPanel.add(postaladdressLabel, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    addressPanel.add(postaladdressTextField, new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
    addressPanel.add(lLabel, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    addressPanel.add(lTextField, new GridBagConstraints(1, 1, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
    addressPanel.add(stLabel, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    addressPanel.add(stTextField, new GridBagConstraints(1, 2, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
    addressPanel.add(postalcodeLabel, new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    addressPanel.add(postalcodeTextField, new GridBagConstraints(1, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
    addressPanel.add(cLabel, new GridBagConstraints(0, 4, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    addressPanel.add(cTextField, new GridBagConstraints(1, 4, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
    addressPanel.add(homephoneLabel, new GridBagConstraints(0, 5, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    addressPanel.add(homephoneTextField, new GridBagConstraints(1, 5, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
    addressPanel.add(mobileLabel, new GridBagConstraints(0, 6, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    addressPanel.add(mobileTextField, new GridBagConstraints(1, 6, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
    addressPanel.add(facsimiletelephonenumberLabel, new GridBagConstraints(0, 7, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    addressPanel.add(facsimiletelephonenumberTextField, new GridBagConstraints(1, 7, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
    funcDataScrollPane.getViewport().add(funcDataPanel, null);
    funcDataPanel.add(employeeNumberLabel,  new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 2, 2, 2), 0, 0));
    funcDataPanel.add(employeenumberTextField,  new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 2, 2, 0), 0, 0));
    funcDataPanel.add(ouLabel,  new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 2, 2, 2), 0, 0));
    funcDataPanel.add(ouTextField,  new GridBagConstraints(1, 1, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 2, 2, 0), 0, 0));
    funcDataPanel.add(employeeTypeLabel,  new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 2, 2, 2), 0, 0));
    funcDataPanel.add(employeeTypeTextField,  new GridBagConstraints(1, 2, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 2, 2, 0), 0, 0));
    funcDataPanel.add(roomNumberLabel,  new GridBagConstraints(0, 5, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 2, 2, 2), 0, 0));
    funcDataPanel.add(roomnumberTextField,  new GridBagConstraints(1, 5, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 2, 2, 0), 0, 0));
    funcDataPanel.add(titleLabel,  new GridBagConstraints(0, 6, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 2, 2, 2), 0, 0));
    funcDataPanel.add(titleTextField,  new GridBagConstraints(1, 6, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 2, 2, 0), 0, 0));
    funcDataPanel.add(descriptionLabel,  new GridBagConstraints(0, 7, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 2, 2, 2), 0, 0));
    funcDataPanel.add(descriptionTextField,  new GridBagConstraints(1, 7, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 2, 2, 0), 0, 0));
    funcDataPanel.add(areaMeioDescTextField,  new GridBagConstraints(1, 3, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 2, 0, 0), 0, -2));
    idPanel.add(uidLabel,         new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 2, 2, 2), 0, 0));
    idPanel.add(uidTextField,         new GridBagConstraints(2, 0, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 2, 2), 0, 0));
    idPanel.add(givenNameLabel,         new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 2, 2, 2), 0, 0));
    idPanel.add(givenNameTextField,         new GridBagConstraints(2, 1, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 2, 2), 0, 0));
    idPanel.add(cnLabel,         new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 2, 2, 2), 0, 0));
    idPanel.add(cnTextField,         new GridBagConstraints(2, 2, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 2, 2), 0, 0));
    idPanel.add(snLabel,         new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 2, 2, 2), 0, 0));
    idPanel.add(snTextField,         new GridBagConstraints(2, 3, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 2, 2), 0, 0));
    idPanel.add(incorSexLabel,         new GridBagConstraints(0, 4, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 2, 2, 2), 0, 0));
    idPanel.add(incorSexTextField,         new GridBagConstraints(2, 4, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 2, 2), 0, 0));
    idPanel.add(telephonenumberLabel,         new GridBagConstraints(0, 5, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 2, 2, 2), 0, 0));
    idPanel.add(telephonenumberTextField,         new GridBagConstraints(2, 5, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 2, 2), 0, 0));
    idPanel.add(pagerLabel,         new GridBagConstraints(0, 6, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 2, 2, 2), 0, 0));
    idPanel.add(pagerTextField,         new GridBagConstraints(2, 6, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 2, 2), 0, 0));
    idPanel.add(mailLabel,         new GridBagConstraints(0, 9, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 2, 2, 2), 0, 0));
    idPanel.add(mailTextField,         new GridBagConstraints(2, 9, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 2, 2), 0, 0));
    idPanel.add(labeleduriLabel,         new GridBagConstraints(0, 10, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 2, 2, 2), 0, 0));
    idPanel.add(labeleduriTextField,         new GridBagConstraints(2, 10, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 2, 2), 0, 0));
    idPanel.add(emailInstCheckBox,      new GridBagConstraints(2, 7, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 2, 2), 0, 0));
    idPanel.add(mailQuotaSlider,     new GridBagConstraints(2, 8, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 2, 2), 0, 0));
    idPanel.add(mailQuotaLabel,   new GridBagConstraints(0, 8, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 2, 2, 2), 0, 0));
    userTabbedPane.setSelectedIndex(0);
  }

  //Start the applet
  public void start() {
  }

  //Stop the applet
  public void stop() {
  }

  //Destroy the applet
  public void destroy() {
  }

  //Get Applet information
  public String getAppletInfo() {
    return "Applet Information";
  }

  //Get parameter info
  public String[][] getParameterInfo() {
    return null;
  }
  //static initializer for setting look & feel
  static {
    try {
      //UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
      //UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
    }
    catch(Exception e) {
    }
  }


  void saveButton_actionPerformed(ActionEvent e) {
      if ((GlobalDefinitions.sa != null)) {
        if (!employeenumberTextField.getText().equalsIgnoreCase("")) {
          if (!emailInstCheckBox.isSelected() ||
              !employeeTypeTextField.getText().equalsIgnoreCase("")) {
            this.applyChangesToUser();
            this.insertUserOrgButton.setEnabled(true);
            this.insertUserRoleButton.setEnabled(true);
            inputChanged = false;
          }
          else {
            userTabbedPane.setSelectedComponent(funcDataScrollPane);
            statusLabel.setText("Status: o campo 'rea Meio' DEVE ser preenchido!");
            employeeTypeTextField.requestFocus();
          }
        }
        else {
          userTabbedPane.setSelectedComponent(funcDataScrollPane);
          statusLabel.setText("Status: o campo matrcula DEVE ser preenchido!");
          employeenumberTextField.requestFocus();
        }
      }
      else {
        JOptionPane.showMessageDialog(this, "Voc no tem PERMISSO para\n"+
                                            "executar esta operao!",
                                      "Advertncia",
                                      JOptionPane.WARNING_MESSAGE);
      }
  }

  void insertUserRoleButton_actionPerformed(ActionEvent e) {
    TreePath tp = rolesTree.getSelectionPath();
    if (tp != null) {
      try {
        Group gp = (Group) tp.getLastPathComponent();
        Role role = gp.getGroupAsRole();
        if ((GlobalDefinitions.sa != null) &&
            (GlobalDefinitions.sa.AccessAllowed("AtribuirPapel;Usuarios;MACA(\""+user.getUserID()+"\", \""+role.getGroupDN()+"\")",
                                                "Execuo"))) {
          if (role.addMemberToGroup(user.getUserDN())) {
            userRolesList.setListData(user.getRolesNames());
            statusLabel.setText("Status: novo papel atribudo com sucesso!");
          }
          else {
            statusLabel.setText("Status: usurio j possui este papel OU novo papel conflita com papel existente!");
          }
        }
        else {
          JOptionPane.showMessageDialog(this, "Voc no tem PERMISSO para\n"+
                                              "executar esta operao!",
                                        "Advertncia",
                                        JOptionPane.WARNING_MESSAGE);
        }
      }
      catch (NamingException exc) {
        JOptionPane.showMessageDialog(this, exc.getMessage(),
                                      "Erro associando papel a usurio",
                                      JOptionPane.ERROR_MESSAGE);
      }
    }
    else {
      statusLabel.setText("Status: selecione um papel antes de associ-lo ao usurio!");
    }
  }

  void userTabbedPane_stateChanged(ChangeEvent e) {
    if (userTabbedPane.getSelectedComponent() == idScrollPane) {
      givenNameTextField.requestFocus();
    }
    statusLabel.setText("Status:");
  }

  void removeUserRoleButton_actionPerformed(ActionEvent e) {
       String roleName = (String) userRolesList.getSelectedValue();
       if (roleName != null) {
         try {
           Group gp = roleGroup.getChildWith(roleName);
           if ((GlobalDefinitions.sa != null) &&
               (GlobalDefinitions.sa.AccessAllowed("RemoverPapel;Usuarios;MACA(\""+user.getUserID()+"\", \""+gp.getGroupDN()+"\")", "Execuo"))) {
             if (gp.removeMemberFromGroup(user.getUserDN())) {
               userRolesList.setListData(user.getRolesNames());
               statusLabel.setText("Status: papel removido com sucesso!");
             }
             else {
               statusLabel.setText("Status: usurio no possui este papel!");
             }
           }
           else {
             JOptionPane.showMessageDialog(this, "Voc no tem PERMISSO para\n"+
                                                 "executar esta operao!",
                                           "Advertncia",
                                           JOptionPane.WARNING_MESSAGE);
           }
         }
         catch (NamingException exc) {
           JOptionPane.showMessageDialog(this, exc.getMessage(),
                                         "Erro removendo papel de usurio",
                                         JOptionPane.ERROR_MESSAGE);
         }
       }
       else {
         statusLabel.setText("Status: selecione um papel antes de remov-lo do usurio!");
       }
  }

  void chgPasswordButton_actionPerformed(ActionEvent e) {
    ChangePasswordDialog chgPwdDlg = new ChangePasswordDialog();
    chgPwdDlg.usr = user;
    chgPwdDlg.setTitle(chgPwdDlg.getTitle()+" - ["+user.getUserID()+"]");
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    chgPwdDlg.setLocation((d.width - chgPwdDlg.getSize().width) / 2, (d.height - chgPwdDlg.getSize().height) / 2);
    chgPwdDlg.setSize(350, 160);
    chgPwdDlg.show();
  }

  void transferFocusOnEnter(KeyEvent e) {
     if (e.getKeyCode() == KeyEvent.VK_ENTER) {
       e.getComponent().transferFocus();
     }
  }

  void labeleduriTextField_keyPressed(KeyEvent e) {
     if (e.getKeyCode() == KeyEvent.VK_ENTER) {
       userTabbedPane.setSelectedIndex(1);
     }
  }

  void descriptionTextField_keyPressed(KeyEvent e) {
     if (e.getKeyCode() == KeyEvent.VK_ENTER) {
       userTabbedPane.setSelectedIndex(2);
     }
  }

  void facsimiletelephonenumberTextField_keyPressed(KeyEvent e) {
     if (e.getKeyCode() == KeyEvent.VK_ENTER) {
       userTabbedPane.setSelectedIndex(3);
     }
  }

  void cnTextField_focusGained(FocusEvent e) {
    if (cnTextField.getText().equalsIgnoreCase("")) {
      StringTokenizer strTk = new StringTokenizer(givenNameTextField.getText());
      if (strTk.hasMoreTokens()) {
        cnTextField.setText(strTk.nextToken());
        cnTextField.selectAll();
      }
    }
  }

  void snTextField_focusGained(FocusEvent e) {
    if (snTextField.getText().equalsIgnoreCase("")) {
      StringTokenizer strTk = new StringTokenizer(givenNameTextField.getText());
      String sn = "";
      while (strTk.hasMoreTokens()) {
        sn = strTk.nextToken();
      }
      snTextField.setText(sn);
      snTextField.selectAll();
    }
  }

  void incorSexTextField_focusGained(FocusEvent e) {
    if (incorSexTextField.getText().equalsIgnoreCase("")) {
      incorSexTextField.setText("Masculino");
      incorSexTextField.selectAll();
    }
  }

  void incorSexTextField_focusLost(FocusEvent e) {
    if (!incorSexTextField.getText().equalsIgnoreCase("Masculino") &&
        !incorSexTextField.getText().equalsIgnoreCase("Feminino")) {
      incorSexTextField.setText("Masculino");
      inputChanged = true;
    }
  }

  void incorSexTextField_keyTyped(KeyEvent e) {
    Action[] actions = incorSexTextField.getActions();
    if (actions.length > 0) {
      actions[0].setEnabled(false);
      if ((e.getKeyChar() == 'F') || (e.getKeyChar() == 'f')) {
        e.setKeyChar('o');
        incorSexTextField.setText("Feminin");
        inputChanged = true;
      }
      else if ((e.getKeyChar() == 'M') || (e.getKeyChar() == 'm')) {
        e.setKeyChar('o');
        incorSexTextField.setText("Masculin");
        inputChanged = true;
    }
      actions[0].setEnabled(true);
    }
  }

  void removeUserOrgButton_actionPerformed(ActionEvent e) {
     String orgName = (String) userOrgList.getSelectedValue();
     if (orgName != null) {
       try {
         Group gp = orgGroup.getChildWith(orgName);
         if (gp.removeMemberFromGroup(user.getUserDN())) {
           userOrgList.setListData(user.getOrgNamesMembership());
           statusLabel.setText("Status: usurio removido da unidade com sucesso!");
         }
         else {
           statusLabel.setText("Status: usurio no est lotado nesta unidade!");
         }
       }
       catch (NamingException exc) {
         JOptionPane.showMessageDialog(this, exc.getMessage(),
                                       "Erro removendo unidade de lotao do usurio",
                                       JOptionPane.ERROR_MESSAGE);
       }
     }
     else {
       statusLabel.setText("Status: selecione uma unidade de lotao antes de remov-la!");
     }
  }

  void insertUserOrgButton_actionPerformed(ActionEvent e) {
     TreePath tp = orgsTree.getSelectionPath();
     if (tp != null) {
       try {
         Group gp = (Group) tp.getLastPathComponent();
         if (gp.addMemberToGroup(user.getUserDN())) {
           userOrgList.setListData(user.getOrgNamesMembership());
           statusLabel.setText("Status: usurio atribudo  unidade com sucesso!");
         }
         else {
           statusLabel.setText("Status: usurio j est lotado nesta unidade!");
         }
       }
       catch (NamingException exc) {
         JOptionPane.showMessageDialog(this, exc.getMessage(),
                                       "Erro associando local a usurio",
                                       JOptionPane.ERROR_MESSAGE);
       }
     }
     else {
       statusLabel.setText("Status: selecione um local no "+System.getProperty("maca_ca.orgChartName")+" antes de associ-lo ao usurio!");
     }
  }

  void newPasswordButton_actionPerformed(ActionEvent e) {
    NewPasswordDialog newPwdDlg = new NewPasswordDialog();
    newPwdDlg.usr = user;
    newPwdDlg.setTitle(newPwdDlg.getTitle()+" - ["+user.getUserID()+"]");
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    newPwdDlg.setLocation((d.width - newPwdDlg.getSize().width) / 2, (d.height - newPwdDlg.getSize().height) / 2);
    newPwdDlg.setSize(350, 160);
    newPwdDlg.show();
 }

  void this_mouseMoved(MouseEvent e) {
    GlobalDefinitions.isUsed = true;
  }


  void closeButton_actionPerformed(ActionEvent e) {
    if (containerFrame != null) {
      containerFrame.dispatchEvent(new WindowEvent(containerFrame, WindowEvent.WINDOW_CLOSING));
    }
  }

  void recordChanged(InputMethodEvent e) {
    inputChanged = true;
  }

  boolean closeWindow() {
    if (inputChanged) {
      if (JOptionPane.showConfirmDialog(this,
                                        "Registro foi modificado! "+
                                        "Deseja sair SEM grav-lo?", "Registro modificado",
                                         JOptionPane.YES_NO_OPTION,
                                         JOptionPane.QUESTION_MESSAGE) == JOptionPane.YES_OPTION) {
        return true;
      }
      else {
        return false;
      }
   }
   return true;
  }

  void employeenumberTextField_keyPressed(KeyEvent e) {
    this.transferFocusOnEnter(e);
  }

  void employeeTypeTextField_keyPressed(KeyEvent e) {
    this.transferFocusOnEnter(e);
  }

  void givenNameTextField_focusLost(FocusEvent e) {
   }

  void cnTextField_focusLost(FocusEvent e) {
  }

  void snTextField_focusLost(FocusEvent e) {
  }

  void changeLoginButton_actionPerformed(ActionEvent e) {
    if ((GlobalDefinitions.sa != null) &&
        (GlobalDefinitions.sa.AccessAllowed("AlterarLoginUsuario;Usuarios;MACA(\""+user.getUserID()+"\")", "Execuo"))) {
     try {
       String newLoginName = JOptionPane.showInputDialog(this,
                                                         "Entre com o novo LOGIN",
                                                         "Alterar Login",
                                                         JOptionPane.QUESTION_MESSAGE);
        if (newLoginName != null) {
          String oldLogin = user.getUserID();
          this.user.changeLoginName(newLoginName);
          this.loadFieldsFromAttributes();
          this.containerFrame.setTitle("Cadastro do Usurio - ["+user.getUserID()+"]");
          String ldapLogin = (String) GlobalDefinitions.ctx.value.getEnvironment().get(Context.SECURITY_PRINCIPAL);
          if (ldapLogin.equalsIgnoreCase(user.getUserDN())) {
            //Novo nome  o prprio usurio
            // necessrio relogar
            String CurrentRole = GlobalDefinitions.sa.getUserRole();
            GlobalDefinitions.sa.CloseSession();
            JPasswordField password = new JPasswordField((String) GlobalDefinitions.ctx.value.getEnvironment().get(Context.SECURITY_CREDENTIALS));
            GlobalDefinitions.sa.Authenticate(user.getUserID(), password, CurrentRole);
          }
          else if (user.hasPassword(oldLogin)) {
           user.setNewPassword(Context.SECURITY_CREDENTIALS, user.getUserID());
          }
        }
      }
      catch (Exception exc) {
        JOptionPane.showMessageDialog(this, exc.getMessage(),
                                      "Erro na modificaao do Login do usurio",
                                      JOptionPane.ERROR_MESSAGE);
      }
    }
    else {
      JOptionPane.showMessageDialog(this, "Voc no tem PERMISSO para\n"+
                                          "executar esta operao!",
                                    "Advertncia",
                                     JOptionPane.WARNING_MESSAGE);
    }
 }

  void emailInstCheckBox_actionPerformed(ActionEvent e) {
   inputChanged = true;
   if (this.emailInstCheckBox.isSelected()) {
      this.emailInstCheckBox.setText("Web mail - "+this.user.getUserID()+"@"+"incor.usp.br");
      if (this.mailTextField.getText().equalsIgnoreCase("")) {
        this.mailTextField.setText(this.user.getUserID()+"@"+"incor.usp.br");
      }
    }
    else {
      this.emailInstCheckBox.setText("Web mail");
      if (this.mailTextField.getText().equalsIgnoreCase(this.user.getUserID()+"@"+"incor.usp.br")) {
        this.mailTextField.setText("");
      }
    }
  }

  void mailQuotaSlider_stateChanged(ChangeEvent e) {
     mailQuotaSlider.setToolTipText(Integer.toString(mailQuotaSlider.getValue())+" MBytes");
  }


}