package maca_ad;

/**
 * <p>Title: MACA_CA</p>
 * <p>Description: Middleware de Autenticao e Controle de Acesso</p>
 * <p>Copyright: Copyright (c) 2000-2004</p>
 * <p>Company: Instituto do Corao - FM.USP</p>
 * @author Gustavo Motta
 * @version 3.2.1
 */

import java.awt.*;
import java.util.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.border.*;


public class UserReturningFieldsDialog extends JDialog {
  private boolean okButtonPressed = false;

  JPanel jPanel1 = new JPanel();
  JLabel loginStatusLabel = new JLabel();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel selPanel = new JPanel();
  JButton okButton = new JButton();
  JPanel jPanel2 = new JPanel();
  Border border1;
  JCheckBox givenNameCheckBox = new JCheckBox();
  JCheckBox telephonenumberCheckBox = new JCheckBox();
  JCheckBox cnCheckBox = new JCheckBox();
  JCheckBox pagerCheckBox = new JCheckBox();
  JCheckBox snCheckBox = new JCheckBox();
  JCheckBox mailCheckBox = new JCheckBox();
  JCheckBox incorsexCheckBox = new JCheckBox();
  JCheckBox labeleduriCheckBox = new JCheckBox();
  JCheckBox employeenumberCheckBox = new JCheckBox();
  JCheckBox ouCheckBox = new JCheckBox();
  JCheckBox employeetypeCheckBox = new JCheckBox();
  JCheckBox roomnumberCheckBox = new JCheckBox();
  JCheckBox titleCheckBox = new JCheckBox();
  JCheckBox descriptionCheckBox = new JCheckBox();
  JCheckBox userRolesCheckBox = new JCheckBox();
  JComboBox accountTypeComboBox = new JComboBox();

  public Vector getSelectedFieldsNames() {
    Component[] comps    = selPanel.getComponents();
    Vector fields = new Vector();
    for (int n = 0; n < comps.length; n++) {
      if ((comps[n] instanceof JCheckBox) &&
          (((JCheckBox) comps[n]).isSelected())){
        fields.add(((JCheckBox) comps[n]).getToolTipText());
      }
    }
    return fields;
  }

  public Vector getSelectedFieldsHeaders() {
    Component[] comps    = selPanel.getComponents();
    Vector headers = new Vector();
    for (int n = 0; n < comps.length; n++) {
      if ((comps[n] instanceof JCheckBox) &&
          (((JCheckBox) comps[n]).isSelected())){
        headers.add(((JCheckBox) comps[n]).getText());
      }
    }
    return headers;
  }

  public boolean okButtonPressed() {
    return this.okButtonPressed;
  }

  public UserReturningFieldsDialog(Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    try {
      jbInit();
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public UserReturningFieldsDialog() {
    this(null, "", false);
  }
  void jbInit() throws Exception {
    border1 = BorderFactory.createEtchedBorder(Color.white,new Color(149, 142, 130));
    this.setModal(true);
    this.setTitle("Marque os Campos de Retorno");
    loginStatusLabel.setBorder(border1);
    loginStatusLabel.setText("Status:");
    selPanel.setLayout(gridBagLayout1);
    okButton.setMnemonic('O');
    okButton.setText("Ok");
    okButton.addFocusListener(new java.awt.event.FocusAdapter() {

      public void focusGained(FocusEvent e) {
        okButton_focusGained(e);
      }

      public void focusLost(FocusEvent e) {
        okButton_focusLost(e);
      }
    });
    okButton.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        okButton_actionPerformed(e);
      }
    });
    jPanel2.setLayout(borderLayout1);
    jPanel1.setBorder(border1);
    selPanel.setBorder(border1);
    givenNameCheckBox.setToolTipText("givenname");
    givenNameCheckBox.setSelected(true);
    givenNameCheckBox.setText("Nome");
    telephonenumberCheckBox.setToolTipText("telephonenumber");
    telephonenumberCheckBox.setText("Telefone InCor");
    cnCheckBox.setToolTipText("cn");
    cnCheckBox.setText("Prenome");
    pagerCheckBox.setToolTipText("pager");
    pagerCheckBox.setText("Pager");
    snCheckBox.setToolTipText("sn");
    snCheckBox.setText("Sobrenome");
    mailCheckBox.setToolTipText("mail");
    mailCheckBox.setText("E-mail");
    incorsexCheckBox.setToolTipText("incorsex");
    incorsexCheckBox.setText("Sexo");
    labeleduriCheckBox.setToolTipText("labeleduri");
    labeleduriCheckBox.setText("URL");
    employeenumberCheckBox.setToolTipText("employeenumber");
    employeenumberCheckBox.setText("Matrcula");
    ouCheckBox.setToolTipText("ou");
    ouCheckBox.setText("Instituio");
    employeetypeCheckBox.setToolTipText("employeetype");
    employeetypeCheckBox.setText("rea Meio");
    roomnumberCheckBox.setToolTipText("physicalDeliveryOfficeName");
    roomnumberCheckBox.setText("Sala");
    titleCheckBox.setToolTipText("title");
    titleCheckBox.setText("Cargo");
    descriptionCheckBox.setToolTipText("description");
    descriptionCheckBox.setText("Observaes");
    userRolesCheckBox.setToolTipText("userRoles");
    userRolesCheckBox.setText("Papis");
    accountTypeComboBox.addItem("Consulta em todas as contas");
    accountTypeComboBox.addItem("Consulta nas contas bloqueadas");
    accountTypeComboBox.addItem("Consulta nas contas desbloqueadas");
    accountTypeComboBox.setSelectedIndex(0);
    jPanel1.add(okButton, null);
    this.getContentPane().add(selPanel,  BorderLayout.NORTH);
    selPanel.add(givenNameCheckBox,         new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 2, 2), 0, 0));
    selPanel.add(telephonenumberCheckBox,        new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(2, 5, 2, 2), 0, 0));
    selPanel.add(cnCheckBox,        new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(5, 3, 2, 2), 0, 0));
    selPanel.add(pagerCheckBox,       new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(2, 3, 2, 2), 0, 0));
    selPanel.add(snCheckBox,        new GridBagConstraints(2, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(5, 3, 2, 2), 0, 0));
    selPanel.add(mailCheckBox,       new GridBagConstraints(2, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(2, 3, 2, 2), 0, 0));
    selPanel.add(incorsexCheckBox,         new GridBagConstraints(3, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 2, 2), 0, 0));
    selPanel.add(labeleduriCheckBox,        new GridBagConstraints(3, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(2, 5, 2, 2), 0, 0));
    selPanel.add(employeenumberCheckBox,         new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(2, 5, 2, 2), 0, 0));
    selPanel.add(ouCheckBox,      new GridBagConstraints(1, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(2, 3, 2, 2), 0, 0));
    selPanel.add(employeetypeCheckBox,      new GridBagConstraints(2, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(2, 3, 2, 2), 0, 0));
    selPanel.add(roomnumberCheckBox,       new GridBagConstraints(3, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(2, 5, 2, 2), 0, 0));
    selPanel.add(titleCheckBox,        new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(2, 5, 5, 2), 0, 0));
    selPanel.add(descriptionCheckBox,       new GridBagConstraints(1, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(2, 3, 5, 2), 0, 0));
    selPanel.add(userRolesCheckBox,       new GridBagConstraints(2, 3, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(2, 3, 5, 2), 0, 0));
    selPanel.add(accountTypeComboBox,   new GridBagConstraints(3, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    this.getContentPane().add(jPanel2,  BorderLayout.SOUTH);
    jPanel2.add(loginStatusLabel, BorderLayout.SOUTH);
    this.getContentPane().add(jPanel1, BorderLayout.CENTER);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    this.setLocation((d.width - this.getSize().width) / 2, (d.height - this.getSize().height) / 2);
    okButton.setDefaultCapable(true);
  }

  void passwordField_keyTyped(KeyEvent e) {

  }
  void passwordField_keyPressed(KeyEvent e) {

  }
  void passwordField_keyReleased(KeyEvent e) {

  }
  void okButton_focusGained(FocusEvent e) {

  }
  void okButton_focusLost(FocusEvent e) {

  }
  void okButton_actionPerformed(ActionEvent e) {
    this.okButtonPressed = true;
    this.hide();
  }


}