<?xml version='1.0'?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:include href="header.xsl"/>

<xsl:template match="document">
<xsl:variable name="registerType" select="/document/registerType"/>
<xsl:variable name="currentPage" select="/document/currentPage"/>
<xsl:variable name="uid" select="/document/userdata/uid"/>
<xsl:variable name="accountLocked" select="/document/maca_ads/response/user/@accountLocked"/>
<xsl:variable name="lockTime" select="/document/maca_ads/response/user/@lockTime"/>
<xsl:choose>
<xsl:when test="/document/signup">
  <font face="Arial" size = "-1"><h3>Conta do usuário <xsl:value-of select="$uid"/></h3></font>
</xsl:when>
<xsl:otherwise>
        <xsl:choose>
          <xsl:when test="$accountLocked = 'true'">
            <font face="Arial" size = "-1"><h3>Conta do usuário <a href="UserData.jsp?uid={$uid}&amp;registerType=Edit"><xsl:value-of select="$uid"/><font face="Arial" color="red" size = "-2">(<i>bloqueada em <xsl:value-of select="$lockTime"/></i>)</font></a></h3></font>
          </xsl:when>
          <xsl:otherwise>
            <xsl:choose>
              <xsl:when test="$lockTime = ''">
                <font face="Arial" size = "-1"><h3>Conta do usuário <a href="UserData.jsp?uid={$uid}&amp;registerType=Edit"><xsl:value-of select="$uid"/></a></h3></font>
              </xsl:when>
              <xsl:otherwise>
                <font face="Arial" size = "-1"><h3>Conta do usuário <a href="UserData.jsp?uid={$uid}&amp;registerType=Edit"><xsl:value-of select="$uid"/><font face="Arial" color="blue" size = "-2">(<i>último desbloqueio em <xsl:value-of select="$lockTime"/></i>)</font></a></h3></font>
              </xsl:otherwise>
            </xsl:choose>
        </xsl:otherwise>
        </xsl:choose>
</xsl:otherwise>
</xsl:choose>
<xsl:apply-templates select="lookupData"/>

<table border="0" width="100%" bgcolor="#FFFFFF">
<form action="UserData.jsp" method="post">
<xsl:choose>
<xsl:when test="maca_ads/response/user">
<tr>
<td>
  <hr/>
</td>
</tr>
<tr>
<td colspan="20">
<TABLE Border = "0" Cellspacing = "0" Cellpadding = "2" Width = "100%" bgcolor="#FFFFFF">
<tr>
<td>
  <xsl:for-each select="/document/maca_ads/response/user/ldapentry/tab">
    <xsl:variable name="tabname" select="@name"/>
    <xsl:choose>
    <xsl:when test="$tabname != $currentPage">
        <font face="Arial" size = "-1">&#160;<input type="submit" name="page" value="{$tabname}"/>&#160;</font>
    </xsl:when>
    <xsl:otherwise>
      <font face="Arial" size = "-1">&#160;<b><xsl:value-of select="$currentPage"/></b>&#160;</font>
    </xsl:otherwise>
    </xsl:choose>
  </xsl:for-each>
</td>
</tr>
</TABLE>
</td>
</tr>
<tr>
<td>
  <xsl:apply-templates select="maca_ads" mode="ok"/>
</td>
</tr>
<xsl:if test="$registerType = 'Edit'">
<tr>
<td colspan="20">
  <TABLE Border = "0" Cellspacing = "0" Cellpadding = "2" Width = "100%" bgcolor="#FFFFFF">
    <tr>
      <td>
        <font face="Arial" size = "-1"><INPUT type="submit" name="AlterarLogin" value="Alterar login"/></font>&#160;
        <font face="Arial" size = "-1"><INPUT type="submit" name="EditarPapel" value="Alterar papéis"/></font>&#160;
        <font face="Arial" size = "-1"><INPUT type="submit" name="EditarSenhas" value="Gerenciar senhas"/></font>&#160;
        <xsl:variable name="tabname" select="@name"/>
        <xsl:choose>
          <xsl:when test="$accountLocked = 'true'">
            <font face="Arial" size = "-1"><INPUT type="submit" name="DesbloquearConta" value="Desbloquear conta"/></font>
          </xsl:when>
          <xsl:otherwise>
            <font face="Arial" size = "-1"><INPUT type="submit" name="BloquearConta" value="Bloquear conta"/></font>
        </xsl:otherwise>
        </xsl:choose>
      </td>
    </tr>
  </TABLE>
</td>
</tr>
</xsl:if>
<tr>
<td>
<br/>
<xsl:choose>
  <xsl:when test="$registerType = 'New'">
    <font face="Arial" size = "-1"><INPUT type="submit" name="NovoUsuario" value="Cadastrar Novo Usuário"/></font>
  </xsl:when>
  <xsl:otherwise>
    <font face="Arial" size = "-1"><INPUT type="submit" name="GravarUsuario" value="Gravar"/></font>
  </xsl:otherwise>
</xsl:choose>
</td>
</tr>
</xsl:when>
<xsl:otherwise>
<tr>
<td>
<font face="Arial" size = "-1"><h3>Erro!</h3></font>
</td>
</tr>
<tr>
<td>
  <xsl:apply-templates select="maca_ads" mode="nok"/>
</td>
</tr>
</xsl:otherwise>
</xsl:choose>
</form>
</table>
</xsl:template>


<xsl:template match="lookupData">
<xsl:variable name="lookupdata" select="."/>
<img onLoad="javascript:remote({$lookupdata})" src="./figs/blank.gif"/>
</xsl:template>


  <xsl:template match="maca_ads" mode="nok">
          <TABLE Border = "0" Cellspacing = "0" Cellpadding = "2" Width = "100%" bgcolor="#FFFFFF">
            <xsl:apply-templates select="response" mode="nok"/>
          </TABLE>
  </xsl:template>

  <xsl:template match="response" mode="nok">
   <tr>
    <td>
      <xsl:if test="@errormessage">
        <font face="Arial" size = "-1">Mensagem de Erro: <xsl:value-of select="@errormessage"/></font>
      </xsl:if>
    </td>
   </tr>
   <tr>
    <td>
     <font face="Arial" size = "-1">Por favor, volte para a página anterior e tente novamente.</font>
    </td>
   </tr>
  </xsl:template>

  <xsl:template match="maca_ads" mode="ok">
          <TABLE Border = "0" Cellspacing = "0" Cellpadding = "2" Width = "100%" bgcolor="#FFFFFF">
            <xsl:apply-templates select="response" mode="ok"/>
          </TABLE>
  </xsl:template>

  <xsl:template match="response" mode="ok">
    <xsl:apply-templates select="user"/>
  </xsl:template>

  <xsl:template match="user">
     <xsl:apply-templates select="ldapentry"/>
  </xsl:template>

  <xsl:template match="ldapentry">
    <xsl:variable name="currentPage" select="/document/currentPage"/>
    <xsl:variable name="registerType" select="/document/registerType"/>
    <xsl:for-each select="tab">
     <xsl:variable name="tabname" select="@name"/>
     <!--
     tabname: <xsl:value-of select="$tabname"/> <p/>
     -->
     <xsl:if test="$tabname = $currentPage">
       <xsl:for-each select="attribute">
        <xsl:variable name="attributeDisplayname" select="@displayname"/>
        <xsl:variable name="attributeName" select="@name"/>
        <xsl:variable name="value" select="value"/>
        <xsl:variable name="maxlen" select="@maxlen"/>
        <xsl:variable name="attributeNumber" select="concat($attributeName,'nokazudearu')"/>
        <xsl:variable name="required" select="@required"/>
        <xsl:variable name="lookupname" select="@lookupname"/>
        <xsl:variable name="lookupupdatefield" select="@lookupupdatefield"/>
        <xsl:variable name="lookupdisplayfield" select="@lookupdisplayfield"/>
        <xsl:variable name="outer_lookupname" select="/document/lookup/lookupname"/>
        <xsl:variable name="outer_lookupupdatefield" select="/document/lookup/lookupupdatefield"/>
        <xsl:variable name="outer_lookupvalue" select="/document/lookup/lookupvalue"/>

        <tr>
        <!--
        attributeDisplayname: <xsl:value-of select="$attributeDisplayname"/>
        attributeName: <xsl:value-of select="$attributeName"/>
        -->
        <xsl:if test="not(@visible)">
        <xsl:choose>
        <xsl:when test="$attributeName != 'uid'">
          <xsl:choose>
            <xsl:when test="not(@multivalue)">
              <xsl:choose>
                <xsl:when test="@required='true'">
                  <xsl:choose>
                  <xsl:when test="@displayname">
                    <xsl:choose>
                    <xsl:when test="$outer_lookupname = $lookupname and $outer_lookupupdatefield = $lookupupdatefield and $outer_lookupvalue != ''">
                      <td width="15%">
                        <font face="Arial" size = "-1"><xsl:value-of select="$attributeDisplayname"/>:</font></td><td><font face="Arial" size = "-1"><input type="text" name="{$attributeName}" value="{$outer_lookupvalue}" maxlength="{$maxlen}"/></font> <font face="Arial" size = "-1" color="red">*</font>
                        <xsl:if test="$lookupname != '' and $lookupupdatefield != '' and $lookupdisplayfield != ''">
                          <xsl:variable name="page" select="/document/currentPage"/>
                          <!-- <td><font face="Arial" size = "-1"><a href="javascript:remote('{$lookupname}','{$lookupupdatefield}','{$lookupdisplayfield}','{$page}','1')">Consultar</a></font></td>-->
                          <input type="image" name="lookupdata++{$lookupname}++{$lookupupdatefield}++{$lookupdisplayfield}++{$page}++1" alt="Pesquisar possíveis valores de {$attributeDisplayname}" src="./figs/lookup.jpg"/>
                        </xsl:if>
                      </td>
                    </xsl:when>
                    <xsl:otherwise>
                      <td width="15%"><font face="Arial" size = "-1"><xsl:value-of select="$attributeDisplayname"/>:</font></td><td><font face="Arial" size = "-1"><input type="text" name="{$attributeName}" value="{$value}" maxlength="{$maxlen}"/></font> <font face="Arial" size = "-1" color="red">*</font>
                        <xsl:if test="$lookupname != '' and $lookupupdatefield != '' and $lookupdisplayfield != ''">
                          <xsl:variable name="page" select="/document/currentPage"/>
                          <!-- <td><font face="Arial" size = "-1"><a href="javascript:remote('{$lookupname}','{$lookupupdatefield}','{$lookupdisplayfield}','{$page}','1')">Consultar</a></font></td>-->
                          <input type="image" name="lookupdata++{$lookupname}++{$lookupupdatefield}++{$lookupdisplayfield}++{$page}++1" alt="Pesquisar possíveis valores de {$attributeDisplayname}" src="./figs/lookup.jpg"/>
                        </xsl:if>
                      </td>
                    </xsl:otherwise>
                    </xsl:choose>
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:choose>
                    <xsl:when test="$outer_lookupname = $lookupname and $outer_lookupupdatefield = $lookupupdatefield and $outer_lookupvalue != ''">
                      <td width="15%"><font face="Arial" size = "-1"><xsl:value-of select="$attributeName"/>:</font></td><td><font face="Arial" size = "-1"><input type="text" name="{$attributeName}" value="{$outer_lookupvalue}" maxlength="{$maxlen}"/></font> <font face="Arial" size = "-1" color="red">*</font>
                        <xsl:if test="$lookupname != '' and $lookupupdatefield != '' and $lookupdisplayfield != ''">
                          <xsl:variable name="page" select="/document/currentPage"/>
                          <!-- <td><font face="Arial" size = "-1"><a href="javascript:remote('{$lookupname}','{$lookupupdatefield}','{$lookupdisplayfield}','{$page}','1')">Consultar</a></font></td>-->
                          <input type="image" name="lookupdata++{$lookupname}++{$lookupupdatefield}++{$lookupdisplayfield}++{$page}++1" alt="Pesquisar possíveis valores de {$attributeName}" src="./figs/lookup.jpg"/>
                        </xsl:if>
                      </td>
                    </xsl:when>
                    <xsl:otherwise>
                      <td width="15%"><font face="Arial" size = "-1"><xsl:value-of select="$attributeName"/>:</font></td><td><font face="Arial" size = "-1"><input type="text" name="{$attributeName}" value="{$value}" maxlength="{$maxlen}"/></font> <font face="Arial" size = "-1" color="red">*</font>
                        <xsl:if test="$lookupname != '' and $lookupupdatefield != '' and $lookupdisplayfield != ''">
                          <xsl:variable name="page" select="/document/currentPage"/>
                          <!-- <td><font face="Arial" size = "-1"><a href="javascript:remote('{$lookupname}','{$lookupupdatefield}','{$lookupdisplayfield}','{$page}','1')">Consultar</a></font></td>-->
                          <input type="image" name="lookupdata++{$lookupname}++{$lookupupdatefield}++{$lookupdisplayfield}++{$page}++1" alt="Pesquisar possíveis valores de {$attributeName}" src="./figs/lookup.jpg"/>
                        </xsl:if>
                      </td>
                    </xsl:otherwise>
                    </xsl:choose>
                  </xsl:otherwise>
                  </xsl:choose>
                </xsl:when>
                <xsl:otherwise> <!-- se não for required-->
                  <xsl:choose>
                  <xsl:when test="@displayname">
                    <xsl:choose>
                    <xsl:when test="$outer_lookupname = $lookupname and $outer_lookupupdatefield = $lookupupdatefield and $outer_lookupvalue != ''">
                      <td width="15%"><font face="Arial" size = "-1"><xsl:value-of select="$attributeDisplayname"/>:</font></td><td><font face="Arial" size = "-1"><input type="text" name="{$attributeName}" value="{$outer_lookupvalue}" maxlength="{$maxlen}"/></font>
                        <xsl:if test="$lookupname != '' and $lookupupdatefield != '' and $lookupdisplayfield != ''">
                          <xsl:variable name="page" select="/document/currentPage"/>
                          <!-- <td><font face="Arial" size = "-1"><a href="javascript:remote('{$lookupname}','{$lookupupdatefield}','{$lookupdisplayfield}','{$page}','1')">Consultar</a></font></td>-->
                          <input type="image" name="lookupdata++{$lookupname}++{$lookupupdatefield}++{$lookupdisplayfield}++{$page}++1" alt="Pesquisar possíveis valores de {$attributeDisplayname}" src="./figs/lookup.jpg"/>
                        </xsl:if>
                      </td>
                    </xsl:when>
                    <xsl:otherwise>
                      <td width="15%"><font face="Arial" size = "-1"><xsl:value-of select="$attributeDisplayname"/>:</font></td><td><font face="Arial" size = "-1"><input type="text" name="{$attributeName}" value="{$value}" maxlength="{$maxlen}"/></font>
                        <xsl:if test="$lookupname != '' and $lookupupdatefield != '' and $lookupdisplayfield != ''">
                          <xsl:variable name="page" select="/document/currentPage"/>
                          <!-- <td><font face="Arial" size = "-1"><a href="javascript:remote('{$lookupname}','{$lookupupdatefield}','{$lookupdisplayfield}','{$page}','1')">Consultar</a></font></td>-->
                          <input type="image" name="lookupdata++{$lookupname}++{$lookupupdatefield}++{$lookupdisplayfield}++{$page}++1" alt="Pesquisar possíveis valores de {$attributeDisplayname}" src="./figs/lookup.jpg"/>
                        </xsl:if>
                      </td>
                    </xsl:otherwise>
                    </xsl:choose>
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:choose>
                    <xsl:when test="$outer_lookupname = $lookupname and $outer_lookupupdatefield = $lookupupdatefield and $outer_lookupvalue != ''">
                       <td width="15%"><font face="Arial" size = "-1"><xsl:value-of select="$attributeName"/>:</font></td><td><font face="Arial" size = "-1"><input type="text" name="{$attributeName}" value="{$outer_lookupvalue}" maxlength="{$maxlen}"/></font>
                        <xsl:if test="$lookupname != '' and $lookupupdatefield != '' and $lookupdisplayfield != ''">
                          <xsl:variable name="page" select="/document/currentPage"/>
                          <!-- <td><font face="Arial" size = "-1"><a href="javascript:remote('{$lookupname}','{$lookupupdatefield}','{$lookupdisplayfield}','{$page}','1')">Consultar</a></font></td>-->
                          <input type="image" name="lookupdata++{$lookupname}++{$lookupupdatefield}++{$lookupdisplayfield}++{$page}++1" alt="Pesquisar possíveis valores de {$attributeName}" src="./figs/lookup.jpg"/>
                        </xsl:if>
                      </td>
                    </xsl:when>
                    <xsl:otherwise>
                       <td width="15%"><font face="Arial" size = "-1"><xsl:value-of select="$attributeName"/>:</font></td><td><font face="Arial" size = "-1"><input type="text" name="{$attributeName}" value="{$value}" maxlength="{$maxlen}"/></font>
                        <xsl:if test="$lookupname != '' and $lookupupdatefield != '' and $lookupdisplayfield != ''">
                          <xsl:variable name="page" select="/document/currentPage"/>
                          <!-- <td><font face="Arial" size = "-1"><a href="javascript:remote('{$lookupname}','{$lookupupdatefield}','{$lookupdisplayfield}','{$page}','1')">Consultar</a></font></td>-->
                          <input type="image" name="lookupdata++{$lookupname}++{$lookupupdatefield}++{$lookupdisplayfield}++{$page}++1" alt="Pesquisar possíveis valores de {$attributeName}" src="./figs/lookup.jpg"/>
                        </xsl:if>
                      </td>
                    </xsl:otherwise>
                    </xsl:choose>
                  </xsl:otherwise>
                  </xsl:choose>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:when>
            <xsl:otherwise> <!-- if multivalue -->
              <xsl:variable name="outer_lookupnumber" select="/document/lookup/lookupnumber"/>
              <xsl:for-each select="value">
                <xsl:variable name="pos" select="position()"/>
                <xsl:variable name="valuemulti" select="."/>
                <xsl:choose>
                  <xsl:when test="position() &gt; 1">
                    <xsl:choose> <!-- este choose serve só para colocar o nome da entrada apenas para a primeira caixa de diálogo -->
                      <xsl:when test="$required='true'">
                        <td>
                        <xsl:choose>
                          <xsl:when test="$outer_lookupnumber = $pos and $outer_lookupname = $lookupname and $outer_lookupupdatefield = $lookupupdatefield and $outer_lookupvalue != ''">
                            <font face="Arial" size = "-1"><input type="text" name="{$attributeName}" value="{$outer_lookupvalue}" maxlength="{$maxlen}"/></font> <font face="Arial" size = "-1" color="red">*</font>
                          </xsl:when>
                          <xsl:otherwise>
                            <font face="Arial" size = "-1"><input type="text" name="{$attributeName}" value="{$valuemulti}" maxlength="{$maxlen}"/></font> <font face="Arial" size = "-1" color="red">*</font>
                          </xsl:otherwise>
                        </xsl:choose>
                        <xsl:if test="$lookupname != '' and $lookupupdatefield != '' and $lookupdisplayfield != ''">
                          <xsl:variable name="page" select="/document/currentPage"/>
                          <!-- <td><font face="Arial" size = "-1"><a href="javascript:remote('{$lookupname}','{$lookupupdatefield}','{$lookupdisplayfield}','{$page}','1')">Consultar</a></font></td>-->
                          <xsl:choose>
                          <xsl:when test="$attributeDisplayname">
                            <input type="image" name="lookupdata++{$lookupname}++{$lookupupdatefield}++{$lookupdisplayfield}++{$page}++{$pos}" alt="Pesquisar possíveis valores de {$attributeDisplayname}" src="./figs/lookup.jpg"/>
                          </xsl:when>
                          <xsl:otherwise>
                            <input type="image" name="lookupdata++{$lookupname}++{$lookupupdatefield}++{$lookupdisplayfield}++{$page}++{$pos}" alt="Pesquisar possíveis valores de {$attributeName}" src="./figs/lookup.jpg"/>
                          </xsl:otherwise>
                          </xsl:choose>
                        </xsl:if>
                        </td>
                      </xsl:when>
                      <xsl:otherwise>
                        <td>
                          <xsl:choose>
                            <xsl:when test="$outer_lookupnumber = $pos and $outer_lookupname = $lookupname and $outer_lookupupdatefield = $lookupupdatefield and $outer_lookupvalue != ''">
                              <font face="Arial" size = "-1"><input type="text" name="{$attributeName}" value="{$outer_lookupvalue}" maxlength="{$maxlen}"/></font>
                            </xsl:when>
                            <xsl:otherwise>
                              <font face="Arial" size = "-1"><input type="text" name="{$attributeName}" value="{$valuemulti}" maxlength="{$maxlen}"/></font>
                            </xsl:otherwise>
                          </xsl:choose>
                        <xsl:if test="$lookupname != '' and $lookupupdatefield != '' and $lookupdisplayfield != ''">
                          <xsl:variable name="page" select="/document/currentPage"/>
                          <!-- <td><font face="Arial" size = "-1"><a href="javascript:remote('{$lookupname}','{$lookupupdatefield}','{$lookupdisplayfield}','{$page}','1')">Consultar</a></font></td>-->
                          <xsl:choose>
                          <xsl:when test="$attributeDisplayname">
                            <input type="image" name="lookupdata++{$lookupname}++{$lookupupdatefield}++{$lookupdisplayfield}++{$page}++{$pos}" alt="Pesquisar possíveis valores de {$attributeDisplayname}" src="./figs/lookup.jpg"/>
                          </xsl:when>
                          <xsl:otherwise>
                            <input type="image" name="lookupdata++{$lookupname}++{$lookupupdatefield}++{$lookupdisplayfield}++{$page}++{$pos}" alt="Pesquisar possíveis valores de {$attributeName}" src="./figs/lookup.jpg"/>
                          </xsl:otherwise>
                          </xsl:choose>
                        </xsl:if>
                        </td>
                      </xsl:otherwise>
                    </xsl:choose>
                    <!--
                    <xsl:if test="$lookupname != '' and $lookupupdatefield != '' and $lookupdisplayfield != ''">
                      <xsl:variable name="page" select="/document/currentPage"/>
                      <xsl:variable name="count" select="position()"/>
                      <td><font face="Arial" size = "-1"><a href="javascript:remote('{$lookupname}','{$lookupupdatefield}','{$lookupdisplayfield}','{$page}','{$count}')">Consultar</a></font></td>
                    </xsl:if>
                    -->
                  </xsl:when>
                  <xsl:otherwise> <!-- é a primeira linha-->
                    <xsl:choose>
                      <xsl:when test="$required='true'">
                        <xsl:choose>
                        <xsl:when test="$attributeDisplayname">
                          <td width="15%">
                            <font face="Arial" size = "-1"><xsl:value-of select="$attributeDisplayname"/>:</font></td>
                            <td>
                            <xsl:choose>
                              <xsl:when test="$outer_lookupnumber = $pos and $outer_lookupname = $lookupname and $outer_lookupupdatefield = $lookupupdatefield and $outer_lookupvalue != ''">
                                 <font face="Arial" size = "-1"><input type="text" name="{$attributeName}" value="{$outer_lookupvalue}" maxlength="{$maxlen}"/></font> <font face="Arial" size = "-1" color="red">*</font>
                              </xsl:when>
                              <xsl:otherwise>
                                 <font face="Arial" size = "-1"><input type="text" name="{$attributeName}" value="{$valuemulti}" maxlength="{$maxlen}"/></font> <font face="Arial" size = "-1" color="red">*</font>
                              </xsl:otherwise>
                              </xsl:choose>
                            <xsl:if test="$lookupname != '' and $lookupupdatefield != '' and $lookupdisplayfield != ''">
                              <xsl:variable name="page" select="/document/currentPage"/>
                              <!-- <td><font face="Arial" size = "-1"><a href="javascript:remote('{$lookupname}','{$lookupupdatefield}','{$lookupdisplayfield}','{$page}','1')">Consultar</a></font></td>-->
                              <input type="image" name="lookupdata++{$lookupname}++{$lookupupdatefield}++{$lookupdisplayfield}++{$page}++{$pos}" alt="Pesquisar possíveis valores de {$attributeDisplayname}" src="./figs/lookup.jpg"/>
                            </xsl:if>
                          </td>
                        </xsl:when>
                        <xsl:otherwise>
                          <td width="15%"><font face="Arial" size = "-1"><xsl:value-of select="$attributeName"/>:</font></td>
                          <td>
                            <xsl:choose>
                              <xsl:when test="$outer_lookupnumber = $pos and $outer_lookupname = $lookupname and $outer_lookupupdatefield = $lookupupdatefield and $outer_lookupvalue != ''">
                                 <font face="Arial" size = "-1"><input type="text" name="{$attributeName}" value="{$outer_lookupvalue}" maxlength="{$maxlen}"/></font> <font face="Arial" size = "-1" color="red">*</font>
                              </xsl:when>
                              <xsl:otherwise>
                                <font face="Arial" size = "-1"><input type="text" name="{$attributeName}" value="{$valuemulti}" maxlength="{$maxlen}"/></font> <font face="Arial" size = "-1" color="red">*</font>
                              </xsl:otherwise>
                              </xsl:choose>
                            <xsl:if test="$lookupname != '' and $lookupupdatefield != '' and $lookupdisplayfield != ''">
                              <xsl:variable name="page" select="/document/currentPage"/>
                              <!-- <td><font face="Arial" size = "-1"><a href="javascript:remote('{$lookupname}','{$lookupupdatefield}','{$lookupdisplayfield}','{$page}','1')">Consultar</a></font></td>-->
                              <input type="image" name="lookupdata++{$lookupname}++{$lookupupdatefield}++{$lookupdisplayfield}++{$page}++{$pos}" alt="Pesquisar possíveis valores de {$attributeName}" src="./figs/lookup.jpg"/>
                            </xsl:if>
                          </td>
                        </xsl:otherwise>
                        </xsl:choose>
                      </xsl:when>
                      <xsl:otherwise>
                        <xsl:choose>
                        <xsl:when test="$attributeDisplayname">
                          <td width="15%"><font face="Arial" size = "-1"><xsl:value-of select="$attributeDisplayname"/>:</font></td>
                          <td>
                            <xsl:choose>
                              <xsl:when test="$outer_lookupnumber = $pos and $outer_lookupname = $lookupname and $outer_lookupupdatefield = $lookupupdatefield and $outer_lookupvalue != ''">
                                 <font face="Arial" size = "-1"><input type="text" name="{$attributeName}" value="{$outer_lookupvalue}" maxlength="{$maxlen}"/></font>
                              </xsl:when>
                              <xsl:otherwise>
                                 <font face="Arial" size = "-1"><input type="text" name="{$attributeName}" value="{$valuemulti}" maxlength="{$maxlen}"/></font>
                              </xsl:otherwise>
                              </xsl:choose>
                            <xsl:if test="$lookupname != '' and $lookupupdatefield != '' and $lookupdisplayfield != ''">
                              <xsl:variable name="page" select="/document/currentPage"/>
                              <!-- <td><font face="Arial" size = "-1"><a href="javascript:remote('{$lookupname}','{$lookupupdatefield}','{$lookupdisplayfield}','{$page}','1')">Consultar</a></font></td>-->
                              <input type="image" name="lookupdata++{$lookupname}++{$lookupupdatefield}++{$lookupdisplayfield}++{$page}++{$pos}" alt="Pesquisar possíveis valores de {$attributeDisplayname}" src="./figs/lookup.jpg"/>
                            </xsl:if>
                          </td>
                        </xsl:when>
                        <xsl:otherwise>
                          <td width="15%"><font face="Arial" size = "-1"><xsl:value-of select="$attributeName"/>:</font></td>
                          <td>
                            <xsl:choose>
                              <xsl:when test="$outer_lookupnumber = $pos and $outer_lookupname = $lookupname and $outer_lookupupdatefield = $lookupupdatefield and $outer_lookupvalue != ''">
                                 <font face="Arial" size = "-1"><input type="text" name="{$attributeName}" value="{$outer_lookupvalue}" maxlength="{$maxlen}"/></font>
                              </xsl:when>
                              <xsl:otherwise>
                                 <font face="Arial" size = "-1"><input type="text" name="{$attributeName}" value="{$valuemulti}" maxlength="{$maxlen}"/></font>
                              </xsl:otherwise>
                              </xsl:choose>
                            <xsl:if test="$lookupname != '' and $lookupupdatefield != '' and $lookupdisplayfield != ''">
                              <xsl:variable name="page" select="/document/currentPage"/>
                              <!-- <td><font face="Arial" size = "-1"><a href="javascript:remote('{$lookupname}','{$lookupupdatefield}','{$lookupdisplayfield}','{$page}','1')">Consultar</a></font></td>-->
                              <input type="image" name="lookupdata++{$lookupname}++{$lookupupdatefield}++{$lookupdisplayfield}++{$page}++{$pos}" alt="Pesquisar possíveis valores de {$attributeName}" src="./figs/lookup.jpg"/>
                            </xsl:if>
                          </td>
                        </xsl:otherwise>
                        </xsl:choose>
                      </xsl:otherwise>
                    </xsl:choose>
                    <!--
                    <xsl:if test="$lookupname != '' and $lookupupdatefield != '' and $lookupdisplayfield != ''">
                      <xsl:variable name="page" select="/document/currentPage"/>
                      <xsl:variable name="count" select="position()"/>
                      <td><font face="Arial" size = "-1"><a href="javascript:remote('{$lookupname}','{$lookupupdatefield}','{$lookupdisplayfield}','{$page}','{$count}')">Consultar</a></font></td>
                    </xsl:if>
                    -->
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:for-each>
              <xsl:variable name="valuecount" select="count(value)"/>
              <xsl:if test="/document/counts/countname"> <!-- se cliquei no botão para adicionar mais uma entrada-->
                <xsl:for-each select="/document/counts/countname">
                  <xsl:variable name="pos" select="$valuecount + position()"/>
                  <xsl:variable name="countname" select="."/>
                  <xsl:if test="$countname=$attributeNumber">
                    <xsl:choose>
                      <xsl:when test="$required='true'">
                        <td><font face="Arial" size = "-1"><input type="text" name="{$attributeName}" maxlength="{$maxlen}"/></font> <font face="Arial" size = "-1" color="red">*</font>
                          <xsl:if test="$lookupname != '' and $lookupupdatefield != '' and $lookupdisplayfield != ''">
                            <xsl:variable name="page" select="/document/currentPage"/>
                            <!-- <td><font face="Arial" size = "-1"><a href="javascript:remote('{$lookupname}','{$lookupupdatefield}','{$lookupdisplayfield}','{$page}','1')">Consultar</a></font></td>-->
                            <xsl:choose>
                            <xsl:when test="$attributeDisplayname">
                              <input type="image" name="lookupdata++{$lookupname}++{$lookupupdatefield}++{$lookupdisplayfield}++{$page}++{$pos}" alt="Pesquisar possíveis valores de {$attributeDisplayname}" src="./figs/lookup.jpg"/>
                            </xsl:when>
                            <xsl:otherwise>
                              <input type="image" name="lookupdata++{$lookupname}++{$lookupupdatefield}++{$lookupdisplayfield}++{$page}++{$pos}" alt="Pesquisar possíveis valores de {$attributeName}" src="./figs/lookup.jpg"/>
                            </xsl:otherwise>
                            </xsl:choose>
                          </xsl:if>
                        </td>
                      </xsl:when>
                      <xsl:otherwise>
                        <td><font face="Arial" size = "-1"><input type="text" name="{$attributeName}" maxlength="{$maxlen}"/></font>
                          <xsl:if test="$lookupname != '' and $lookupupdatefield != '' and $lookupdisplayfield != ''">
                            <xsl:variable name="page" select="/document/currentPage"/>
                            <!-- <td><font face="Arial" size = "-1"><a href="javascript:remote('{$lookupname}','{$lookupupdatefield}','{$lookupdisplayfield}','{$page}','1')">Consultar</a></font></td>-->
                            <xsl:choose>
                            <xsl:when test="$attributeDisplayname">
                              <input type="image" name="lookupdata++{$lookupname}++{$lookupupdatefield}++{$lookupdisplayfield}++{$page}++{$pos}" alt="Pesquisar possíveis valores de {$attributeDisplayname}" src="./figs/lookup.jpg"/>
                            </xsl:when>
                            <xsl:otherwise>
                              <input type="image" name="lookupdata++{$lookupname}++{$lookupupdatefield}++{$lookupdisplayfield}++{$page}++{$pos}" alt="Pesquisar possíveis valores de {$attributeName}" src="./figs/lookup.jpg"/>
                            </xsl:otherwise>
                            </xsl:choose>
                          </xsl:if>
                        </td>
                      </xsl:otherwise>
                    </xsl:choose>
                  </xsl:if>
                </xsl:for-each>
              </xsl:if>
              <td> <input type="submit" name="{$attributeNumber}" value="Mais valores"/></td>
            </xsl:otherwise> <!-- acaba aqui o tratamento a campos multivalorados-->
          </xsl:choose>
        </xsl:when> <!-- é do <xsl:when test="$attributeName != 'uid'">-->
        <xsl:otherwise>
          <xsl:choose>
          <xsl:when test="@displayname">
            <xsl:choose>
            <xsl:when test="$outer_lookupname = $lookupname and $outer_lookupupdatefield = $lookupupdatefield and $outer_lookupvalue != ''">
              <td width="15%"><font face="Arial" size = "-1"><xsl:value-of select="$attributeDisplayname"/>:</font></td><td><font face="Arial" size = "-1"><xsl:value-of select="$outer_lookupvalue"/></font><input type="hidden" name="{$attributeName}" value="{$outer_lookupvalue}"/>
                 <xsl:if test="$lookupname != '' and $lookupupdatefield != '' and $lookupdisplayfield != ''">
                    <xsl:variable name="page" select="/document/currentPage"/>
                    <!-- <td><font face="Arial" size = "-1"><a href="javascript:remote('{$lookupname}','{$lookupupdatefield}','{$lookupdisplayfield}','{$page}','1')">Consultar</a></font></td>-->
                    <input type="image" name="lookupdata++{$lookupname}++{$lookupupdatefield}++{$lookupdisplayfield}++{$page}++1" alt="Pesquisar possíveis valores de {$attributeDisplayname}" src="./figs/lookup.jpg"/>
                  </xsl:if>
              </td>
            </xsl:when>
            <xsl:otherwise>
              <td width="15%"><font face="Arial" size = "-1"><xsl:value-of select="$attributeDisplayname"/>:</font></td><td><font face="Arial" size = "-1"><xsl:value-of select="$value"/></font><input type="hidden" name="{$attributeName}" value="{$value}"/>
                 <xsl:if test="$lookupname != '' and $lookupupdatefield != '' and $lookupdisplayfield != ''">
                    <xsl:variable name="page" select="/document/currentPage"/>
                    <!-- <td><font face="Arial" size = "-1"><a href="javascript:remote('{$lookupname}','{$lookupupdatefield}','{$lookupdisplayfield}','{$page}','1')">Consultar</a></font></td>-->
                    <input type="image" name="lookupdata++{$lookupname}++{$lookupupdatefield}++{$lookupdisplayfield}++{$page}++1" alt="Pesquisar possíveis valores de {$attributeDisplayname}" src="./figs/lookup.jpg"/>
                  </xsl:if>
              </td>
            </xsl:otherwise>
            </xsl:choose>
          </xsl:when>
          <xsl:otherwise>
            <xsl:choose>
            <xsl:when test="$outer_lookupname = $lookupname and $outer_lookupupdatefield = $lookupupdatefield and $outer_lookupvalue != ''">
              <td width="15%"><font face="Arial" size = "-1"><xsl:value-of select="$attributeName"/>:</font></td><td><font face="Arial" size = "-1"><xsl:value-of select="$outer_lookupvalue"/></font><input type="hidden" name="{$attributeName}" value="{$outer_lookupvalue}"/>
                 <xsl:if test="$lookupname != '' and $lookupupdatefield != '' and $lookupdisplayfield != ''">
                    <xsl:variable name="page" select="/document/currentPage"/>
                    <!-- <td><font face="Arial" size = "-1"><a href="javascript:remote('{$lookupname}','{$lookupupdatefield}','{$lookupdisplayfield}','{$page}','1')">Consultar</a></font></td>-->
                    <input type="image" name="lookupdata++{$lookupname}++{$lookupupdatefield}++{$lookupdisplayfield}++{$page}++1" alt="Pesquisar possíveis valores de {$attributeName}" src="./figs/lookup.jpg"/>
                  </xsl:if>
              </td>
            </xsl:when>
            <xsl:otherwise>
              <td width="15%"><font face="Arial" size = "-1"><xsl:value-of select="$attributeName"/>:</font></td><td><font face="Arial" size = "-1"><xsl:value-of select="$value"/></font><input type="hidden" name="{$attributeName}" value="{$value}"/>
                 <xsl:if test="$lookupname != '' and $lookupupdatefield != '' and $lookupdisplayfield != ''">
                    <xsl:variable name="page" select="/document/currentPage"/>
                    <!-- <td><font face="Arial" size = "-1"><a href="javascript:remote('{$lookupname}','{$lookupupdatefield}','{$lookupdisplayfield}','{$page}','1')">Consultar</a></font></td>-->
                    <input type="image" name="lookupdata++{$lookupname}++{$lookupupdatefield}++{$lookupdisplayfield}++{$page}++1" alt="Pesquisar possíveis valores de {$attributeName}" src="./figs/lookup.jpg"/>
                  </xsl:if>
              </td>
            </xsl:otherwise>
            </xsl:choose>
          </xsl:otherwise>
          </xsl:choose>
        </xsl:otherwise>
        </xsl:choose>
        </xsl:if>
        </tr>
       </xsl:for-each>
     </xsl:if>
    </xsl:for-each>
    <tr>
      <td colspan="10">
        <br/>
      </td>
    </tr>
    <tr>
      <td colspan="10">
        <font face="Arial" size="-1"><font face="Arial" size="-1" color="red">*</font> Preenchimento obrigatório.</font>
       </td>
    </tr>
    <tr>
      <td colspan="10">
        <hr/>
      </td>
    </tr>
  </xsl:template>

</xsl:stylesheet>


