package maca_cs;

/**
 * <p>Title: MACA_CA</p>
 * <p>Description: Middleware de Autenticao e Controle de Acesso</p>
 * <p>Copyright: Copyright (c) 2000-2004</p>
 * <p>Company: Instituto do Corao - FM.USP</p>
 * @author Gustavo Motta
 * @version 3.2.1
 */

  import java.io.*;
  import maca_ca.*;
  import contexts.*;
  import java.util.*;
  import javax.naming.*;
  import java.util.zip.*;
  import javax.naming.directory.*;

  public class LdapContext implements  contexts.Context {
    private DirContextHolder ctx;

    private boolean contains(Attribute attr, Object element) throws NamingException {
      if (attr != null) {
        Enumeration enum = attr.getAll();
        while (enum.hasMoreElements()) {
          Object attrValue = enum.nextElement();
          if (attrValue != null) {
            if ((attrValue instanceof String) &&
                (element instanceof String))  {
              if (((String)attrValue).equalsIgnoreCase((String)element)) {
                return true;
              }
            }
            else if (attrValue.equals(element)) {
              return true;
            }
          }
          else if (attrValue == element) {
            return true;
          }
        }
      }
      return false;
    }

    public LdapContext(DirContextHolder aDirHolder) {
      ctx = aDirHolder;
    }


    public Object getValue(String index) throws contexts.ContextException {
      /**@todo: Implement this contexts.Context method*/
      throw new java.lang.UnsupportedOperationException("Method getValue() not yet implemented in class 'LdapContext'.");
    }

    public boolean inEvaluation(Object element, Object aSet) throws contexts.ContextException {
      if (aSet instanceof Attribute) {
        try {
          Attribute attr = (Attribute) aSet;
          if ((attr != null) && (element != null)) {
            if ((element instanceof String) && (!"".equals(element))) {
              return contains(attr, element);
            }
            else if ((element instanceof Attribute) && ((Attribute) element).size() > 0) {
              Attribute elemAttr = (Attribute) element;
              Enumeration enum = elemAttr.getAll();
              while (enum.hasMoreElements()) {
                if (!contains(attr, enum.nextElement())) {
                  return false;
                }
              }
              return true;
            }
            return false;
          }
          else {
             return false;
          }
        }
        catch (Exception exc) {
          throw new contexts.ContextException("Erro avaliando conjunto '"+aSet+"' no contexto 'LdapContext': "+exc.toString());
        }
      }
      else {
        throw new contexts.ContextException("Conjunto '"+aSet+"' indisponvel no contexto 'LdapContext'.");
      }
    }

    public Object functionApplication(String functionName, Vector argumentList) throws contexts.ContextException {
      if (functionName.equalsIgnoreCase("valorAtributo")) {
        if (argumentList.size() >= 2) {
          return valorAtributo(((String) argumentList.get(0)), ((String) argumentList.get(1)));
        }
        else {
          throw new ContextException("Nmero invlido de argumentos na funo '"+functionName+"' no contexto 'LdapContext'.");
        }
      }
      else if (functionName.equalsIgnoreCase("valoresAtributo")) {
        if (argumentList.size() >= 2) {
          return valoresAtributo(((String) argumentList.get(0)), ((String) argumentList.get(1)));
        }
        else {
          throw new ContextException("Nmero invlido de argumentos na funo '"+functionName+"' no contexto 'LdapContext'.");
        }
      }
      else if (functionName.equalsIgnoreCase("papelAbaixoDe")) {
        if (argumentList.size() >= 2) {
          return new Boolean(papelAbaixoDe(((String) argumentList.get(0)), ((String) argumentList.get(1))));
        }
        else {
          throw new ContextException("Nmero invlido de argumentos na funo '"+functionName+"' no contexto 'LdapContext'.");
        }
      }
      else if (functionName.equalsIgnoreCase("papelIgualA")) {
        if (argumentList.size() >= 2) {
          return new Boolean(papelIgualA(((String) argumentList.get(0)), ((String) argumentList.get(1))));
        }
        else {
          throw new ContextException("Nmero invlido de argumentos na funo '"+functionName+"' no contexto 'LdapContext'.");
        }
      }
      else if (functionName.equalsIgnoreCase("papelAbaixoOuIgualA")) {
        if (argumentList.size() >= 2) {
          return new Boolean(papelAbaixoOuIgualA(((String) argumentList.get(0)), ((String) argumentList.get(1))));
        }
        else {
          throw new ContextException("Nmero invlido de argumentos na funo '"+functionName+"'. no contexto 'LdapContext'");
        }
      }
      else {
        throw new ContextException("Funo '"+functionName+"' no definida no contexto 'LdapContext'.");
      }
    }

    private javax.naming.directory.Attributes getAttributes(String attrsStr, String attrName) throws javax.naming.NamingException {
      attrName   = attrName.trim();
      String uid = attrsStr;
      javax.naming.directory.Attributes attrs = new BasicAttributes(true);
      if (!"userPassword".equalsIgnoreCase(attrName)) {
        try {
          attrsStr = attrsStr.replace(' ', '\n');
          ObjectInputStream input = new ObjectInputStream(new GZIPInputStream(new ByteArrayInputStream(Conversion.base64StringtoByteArray(attrsStr))));
          attrs = (javax.naming.directory.Attributes) input.readObject();
        }
        catch (Exception exc) {
          attrs = ctx.value.getAttributes("uid="+uid+","+
                                          System.getProperty("maca_ca.ldap.peopleRDN")+","+
                                          System.getProperty("maca_ca.ldap.rootDN"),
                                          new String[] {attrName});
        }
      }
      return attrs;
    }

    private String valorAtributo(String attrsStr, String attrName) throws ContextException {
      try {
        javax.naming.directory.Attributes attrs = getAttributes(attrsStr, attrName);
        javax.naming.directory.Attribute  attr = attrs.get(attrName);
        if ((attr != null) && (attr.size() > 0) && (attr.get() != null)) return attr.get().toString();
        return "";
      }
      catch (Exception exc) {
        throw new ContextException("Erro executando a funao 'valorAttributo': "+exc.getMessage());
      }
    }

    private javax.naming.directory.Attribute valoresAtributo(String attrsStr, String attrName) throws ContextException {
      try {
        javax.naming.directory.Attributes attrs = getAttributes(attrsStr, attrName);
        javax.naming.directory.Attribute   attr = attrs.get(attrName);
        if (attr != null) return attr;
        return new BasicAttribute(attrName);
      }
      catch (Exception exc) {
        throw new ContextException("Erro executando a funao 'valoresAtributo': "+exc.getMessage());
      }
    }

    private String getRoleNameAsLDAP_DN(String papelBase) {
      String roleDN = System.getProperty("maca_ca.ldap.roleRDN")+","+
                      System.getProperty("maca_ca.ldap.groupsRDN")+","+
                      System.getProperty("maca_ca.ldap.rootDN");
      String roleRDN = "";
      StringTokenizer strTk = new StringTokenizer(papelBase, ";");
      while (strTk.hasMoreTokens()) {
        roleRDN = roleRDN + (roleRDN.equals("")?"":",") + "cn=" + strTk.nextToken();
      }
      roleDN = roleRDN + (roleRDN.equals("")?"":",") + roleDN;
      return roleDN;
    }

    private boolean papelAbaixoDe(String papel, String papelBase) throws ContextException {
      try {
        papel     = papel.toLowerCase().trim();
        papelBase = getRoleNameAsLDAP_DN(papelBase.toLowerCase().trim());
        return papel.endsWith(papelBase);
      }
      catch (Exception exc) {
        throw new ContextException("Erro executando a funao 'papelAbaixoDe': "+exc.getMessage());
      }
    }

    private boolean papelIgualA(String papel, String papelBase) throws ContextException {
      try {
        papel     = papel.toLowerCase().trim();
        papelBase = getRoleNameAsLDAP_DN(papelBase.toLowerCase().trim());
        return papel.equalsIgnoreCase(papelBase);
      }
      catch (Exception exc) {
        throw new ContextException("Erro executando a funao 'papelIgualA': "+exc.getMessage());
      }
    }

    private boolean papelAbaixoOuIgualA(String papel, String papelBase) throws ContextException {
      try {
        return this.papelIgualA(papel, papelBase) || this.papelAbaixoDe(papel, papelBase);
      }
      catch (Exception exc) {
        throw new ContextException("Erro executando a funao 'papelAbaixoOuIgualA': "+exc.getMessage());
      }
    }

}