package maca_cs;

/**
 * <p>Title: MACA_CA</p>
 * <p>Description: Middleware de Autenticao e Controle de Acesso</p>
 * <p>Copyright: Copyright (c) 2000-2004</p>
 * <p>Company: Instituto do Corao - FM.USP</p>
 * @author Gustavo Motta
 * @version 3.2.1
 */

import maca_ca.*;
import java.io.*;
import org.xml.sax.*;
import org.omg.maca_cs.TimeBase.*;
import org.omg.maca_cs.Security.*;
import org.omg.maca_cs.SecurityLevel2.*;
import org.omg.maca_cs.DfResourceAccessDecision.*;

public class MonitorImpl implements maca_cs.MonitorOperations {

  private boolean hasAccess(org.omg.maca_cs.SecurityLevel2.Credentials creds,
                            String resourceName, String operation) throws Exception {
    if (creds != null) {
      ExtensibleFamily extFamily = new ExtensibleFamily((short) 0, (short) 1);
      AttributeType[] attrTypes = {new AttributeType(extFamily, AccessId.value)};
      SecAttribute[] attrs = creds.get_attributes(attrTypes);
      ResourceNameComponent[] resNameCompts = {new ResourceNameComponent("Aplicacoes", resourceName)};
      ResourceName resName = new ResourceName("127.0.0.1", resNameCompts);
      return AuthenticatorServer.ado.access_allowed(resName, operation, attrs);
    }
    return false;
  }

  public MonitorImpl(LogWriter aLog) {
    super();
  }

  public String executeRequest (org.omg.maca_cs.SecurityLevel2.Credentials creds, String request) {
    try {
      if (this.hasAccess(creds, "Monitor;MACA", "execuo")) {
        MonitorSaxParser parser = new MonitorSaxParser();
        return parser.parser(creds, request);
      }
      else {
        String str = "";
        str += "<?xml version='1.0' encoding='ISO-8859-1'?>";
        str += "<maca_cs version=\"3.1\">";
        str += "<response action=\"Monitor;MACA\"";
        str += "          status=\"not_ok\"";
        str += "          errormessage=\"Acesso no autorizado!\">";
        str += "</response>";
        str += "</maca_cs>";
        return str;
      }
    }
    catch (Exception exc) {
      StringWriter sw = new StringWriter();
      PrintWriter pw = new PrintWriter(sw);
      exc.printStackTrace(pw);
      pw.close();
      String str = "";
      str += "<?xml version='1.0' encoding='ISO-8859-1'?>";
      str += "<maca_cs version=\"3.1\">";
      str += "<response action=\"Monitor;MACA\"";
      str += "          status=\"error\"";
      str += "          errormessage=\""+sw.toString()+"\">";
      str += "</response>";
      str += "</maca_cs>";
      return str;
    }
  }

  public MonitorImpl() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  private void jbInit() throws Exception {
  }
}