<?xml version='1.0'?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <xsl:include href="header.xsl"/>

  <xsl:template match="document">
    <h2><xsl:value-of select="title"/></h2>
    <xsl:apply-templates select="form"/>
    <xsl:apply-templates select="accessDenied"/>
  </xsl:template>

  <xsl:template match="form">
    <xsl:variable name="name" select="name"/>
    <xsl:variable name="action" select="action"/>
    <xsl:variable name="method" select="method"/>
    <form name="{$name}" action="{$action}" method="{$method}">
      <TABLE>
       <TR>
         <TD>
            <xsl:apply-templates select="rghc"/>
         </TD>
      </TR>
       <TR>
         <TD>
             <xsl:apply-templates select="submit"/>
         </TD>
      </TR>
      </TABLE>
    </form>
  </xsl:template>

  <xsl:template match="rghc">
      <xsl:variable name="name" select="name"/>
      RGHC: <input TYPE="TEXT" NAME="{$name}" VALUE="" MAXLENGTH="50"/>
  </xsl:template>

  <xsl:template match="password">
      <xsl:variable name="name" select="name"/>
      Senha: <input TYPE="PASSWORD" NAME="{$name}" VALUE="" MAXLENGTH="50"/>
  </xsl:template>

  <xsl:template match="submit">
    <input type="submit" name="Submit" value="Pesquisar"/>
  </xsl:template>

  <xsl:template match="reset">
    <input type="reset" value="Reset"/>
  </xsl:template>

  <xsl:template match="accessDenied">
    Acesso nao autorizado!
  </xsl:template>

</xsl:stylesheet>